#include <stdio.h>
#include <string.h>
#include <readline/readline.h>
#ifdef __GNUC__
#define readline_init_ readline_init__
#endif
void readline_init_( void );
void
getfile_( char *prompt, char *file, int *len_file, long l_prompt, long l_file ) {
/****
C ******************************************************************************
C ***
C ***	Uses GNU's readline to get enable filename completion.
C ***
C ***	PROMPT	  > c	Prompt, can be char(0) to suppress prompt
C ***	FILE	  < c	resultant file name
C ***	LEN_FILE  < i	# of characters written to FILE;
C ***			0 if EOF detected
C ***
C ***	Note: GNU's readline is a C function, so calling it from Fortran
C ***	      is system dependent.  This here works for Suns.
C ***
C ***	Modifications:
C ***
C ***	 4-NOV-1994 19:11:17.00		ML / IoA.  Created.
C ***	 8-NOV-1994 17:04:53.00		ML / IoA.  Wrote C interface
C ***					readline_init in C.  We need some
C ***					options which can't be accessed from
C ***					Sun Fortran.  Extern variables are
C ***					inaccessible except for struct's.
C ***	14-FEB-1995 17:07:25.00		ML / IoA.  Replace Fortran's free
C ***					with C's.  Seems to be broken under
C ***					Solaris.
C ***   10-MAY-1997 15:56:06.00         ML / Stegaurach.  C version for Linux.
C ***
C ***
C ******************************************************************************
C ***/

	char *p = (char *)malloc( l_prompt+1 );
	char *f;
        int l_f;



        if( p == NULL ) {
	   perror( "getfile" );
	   exit( 1 );
	}
        strncpy( p, prompt, l_prompt );
        *(p+l_prompt) = '\0';

	
	readline_init_();
	f = readline( p );

	memset( file, ' ', l_file );
	if( f == NULL ) {
	   *len_file = -1;
	} else {
	   l_f = strlen( f );
	   *len_file = l_file < l_f ? l_file : l_f;
	   strncpy( file, f, *len_file );
	   if( file[*len_file-1] == ' ' ) (*len_file)--;
	}
	if( *len_file > 0 ) add_history( f );
	if( f ) free( f );
	if( p ) free( p );

}
