        subroutine formatJD( jd, datstr )
        implicit none
C ***
C ****************************************************************************
C ***
C ***   $Id: formatJD.f,v 1.1 2002/12/13 15:43:05 michael Exp $
C ***
C ***   Convert modified Julian Date back to local time representation as
C ***   DD-MMM-YYYY hh:mm:ss
C ***
C ***   jd      > D     Julian Date to convert
C ***   datstr  < C     converted date
C ***
C ***
C ***   $Log: formatJD.f,v $
C ***   Revision 1.1  2002/12/13 15:43:05  michael
C ***   Intial version.
C ***
C ***
C ****************************************************************************
C ***
        double precision jd
        character *(*) datstr

        integer month, day, year, hour, minute, second
        real rsec
        character monthname(12)*3
        data monthname /'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
     >                  'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'/

        call gdate( jd, month, day, year, hour, minute, rsec )

        second = int( rsec + 0.5 )
        if( second .ge. 60 ) then
           second = second - 60
           minute = minute + 1
           if( minute .ge. 60 ) then
              minute = minute - 60
              hour = hour + 1
           end if
        end if
           
        write( datstr, '(i2.2, ''-'', a, ''-'', i4, '' '', 
     >                 i2.2, '':'', i2.2, '':'', i2.2)' )
     >    day, monthname(month), year, hour, minute, second
        end
