      subroutine gdate (xjdate, month, iday, iyear, hour, min, sec )
      implicit none
      double precision xjdate
      integer iday, month, iyear, hour, min
      real sec

c     gregorian date subroutine

c     input

c      xjdate = modified julian date

c     output

c      month = calendar month
c      iday  = calendar day
c      iyear = calendar year
c ***  hour  = hour
c ***  min   = minute
c ***  sec   = seconds


c     Orbital Mechanics Fortran Toolbox
c 
C ***
C ***   Taken from http://cdeagle.cnchost.com/omfort.zip
C ***   and modified slightly.
C ***
C ***   $Log: gdate.f,v $
C ***   Revision 1.1  2002/12/13 15:42:08  michael
C ***   Initial version with addition of return of time.
C ***   Returns time in UTC.  No provision for time zones or DST.
C ***
C ***
C ***

c     *********************************

      
      double precision day, xjd, x, fday, z, a, alpha, b, dsec
      integer ic, id, ie
      
      xjd = xjdate + 2 400 000.5d0

      z = int(xjd + 0.5d0)

      fday = xjd + 0.5d0 - z

      if (fday .lt. 0.0d0) then
         fday = fday + 1.0d0
         z = z - 1.0d0
      end if

      if (z .lt. 2299161d0) then
         a = z
      else
         alpha = int((z - 1867216.25d0)/36524.25d0)
         a = z + 1.0d0 + alpha - int(alpha/4.0d0)
      end if

      b = a + 1524.0d0
      ic = int((b - 122.1d0)/365.25d0)
      id = int(365.25d0*ic)
      ie = int((b - id)/30.6001d0)
      
      day = b - id - int(30.6001d0*ie) + fday
      iday = int(day)

      if (ie .lt. 14) then
         month = ie - 1
      else
         month = ie - 13
      end if

      if (month .gt. 2) then
         iyear = ic - 4716
      else
         iyear = ic - 4715
      end if

      dsec = 86400.d0*fday
      hour = int( 24.d0*fday )
      min = int( 60d0*(24d0*fday - hour)  )
      dsec = 86400d0*fday - 60d0*int(1440.d0*fday)
      sec = dsec
      if( sec .ge. 60. ) then
         sec = sec - 60.
         min = min + 1
      end if

      end
