/* Fortran callable function that returns current
 * date/time in VMS format.
 * 
 * Linux version.  Locale not properly honored.
 *
 *  3-DEC-1996 00:12:13.00	ML / Stegaurach.
 * 11-MAR-1997 02:14:19.00      ML / Stegaurach.  Fixed array bounds problem.
 *
 */
#include <time.h>
#include <ctype.h>
void datum_( char *date, long len ) {
	time_t now;
	int i, n;
	char *format = "%d-%b-%Y %H:%M:%S.00";
	char tbuf[24]; /* we need a buffer to guarantee room for time string + \0 */

	if( len < 20 ) {
	   format = "%d-%b-%y %H:%M:%S";
	} else { 
        if( len < 23 ) {
	   format = "%d-%b-%Y %H:%M:%S";
        }
	}
	

	now = time(NULL);
	n = strftime( tbuf, 24, format, localtime(&now) );

        n = (n < len) ? n : len;
	for( i = 0; i < n; i++ ) date[i] = tbuf[i];
	for( i = n; i < len; i++ ) date[i] = ' ';
        
	date[0] = (date[0]=='0' ? ' ':date[0]);
	date[4] = toupper( date[4] );
	date[5] = toupper( date[5] );
}
