      INTEGER FUNCTION LIB$GET_SYMBOL(SYMBOL,DSTSTR,LENGTH)
*      INTEGER FUNCTION LIB$GET_SYMBOL(SYMBOL,DSTSTR,LENGTH,TABLE)
C
C     L I B $ S Y S _ T R N L O G
C
C     A simple version of the VMS system call.  Symbols are replaced by
C     Environment variables.
C
C     Parameters -   (">" input, "!" modified, "<" output)
C
C     (>) SYMBOL     (String) The symbol to lookup
C     (<) DSTSTR     (String) The symbol value
C *** (<) LENGTH    (INTEGER) The symbol length (optional argument - not)
C *** (<) TABLE	  (long word) no function in Unix (optional argument - not)
C
C     Return value -
C
C     Whatever LIB$SYS_TRNLOG returns.
C
C     History:
C
C     14th Sep 1989.  SNS / CIT. Original.
C+
C ***	 3-OCT-1994 17:22:25.00		ML / IoA.  Added LENGTH and TABLE to
C ***					argument list.  Makes it VMS conform.
C ***	 3-OCT-1994 17:53:53.00		ML / IoA.  Optional arguments don't
C ***				work.  What did you expect?  This is Unix
C ***				and from Sun.  Took out Table as it is never
C ***                           used.
C ***   14-AUG-1997 18:49:18.29         ML / Bamberg.  And Fujitsu's Fortran
C ***                           is even worse.  Doesn't have %loc.  So take
C ***                           that out too.
      IMPLICIT NONE
C
      CHARACTER SYMBOL*(*)
      CHARACTER DSTSTR*(*)
      INTEGER LENGTH
      INTEGER TABLE
C
C     Routines
C
      INTEGER LIB$SYS_TRNLOG
C
C     Local Variables
C
      INTEGER LENG

      LIB$GET_SYMBOL=LIB$SYS_TRNLOG(SYMBOL,LENG,DSTSTR)
C      IF( %LOC(LENGTH) .NE. 0 ) LENGTH = LENG
      LENGTH = LENG

      END
      INTEGER FUNCTION LIB$SYS_TRNLOG(LOGNAME,LENGTH,DSTSTR)
C
C     L I B $ S Y S _ T R N L O G
C
C     A simple version of the VMS system call.
C
C     Parameters -   (">" input, "!" modified, "<" output)
C
C     (>) LOGNAME    (String) The logical name to translate
C     (<) PROMPT     (Integer) The length of the output string
C     (<) LENGTH     (String) The logical name translation
C
C     Return value -
C
C     SS$_NORMAL	- everything worked
C     SS$_NOTRAN	- if the logical name was not found
C
C     History:
C
C     12th Sep 1989.  SNS / CIT. Original.
C ***	 3-OCT-1994 17:55:56.00		ML / IoA.  Fixed length.  Must be 0
C ***                                   if SS$_NOTRAN
C+
      IMPLICIT NONE
C
      INCLUDE 'sscode.inc'
C
      CHARACTER LOGNAME*(*)
      INTEGER LENGTH
      CHARACTER DSTSTR*(*)
C
C     Local Variables
C
      INTEGER I
      CHARACTER TEMP*256

      LENGTH=0
      TEMP=' '
      CALL GETENV(LOGNAME(:LEN(LOGNAME)),TEMP)
      DO 10 I=LEN(TEMP),1,-1
	 IF (TEMP(I:I) .NE. ' ') THEN
	    LENGTH=I
	    LIB$SYS_TRNLOG=SS$_NORMAL
	    DSTSTR=TEMP
	    GOTO 20
	 END IF
10    CONTINUE
      LIB$SYS_TRNLOG=SS$_NOTRAN
20    CONTINUE
      END
