#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#if defined(__uxp__) || defined(sun)
#include <curses.h>
#include <term.h>
#else
#include <termcap.h>
#endif
#include <sys/ioctl.h>
#include <termios.h>
#ifdef Linux
#define get_image_id_ get_image_id__
#define prgid_old_ prgid_old__
#endif

#define min(a,b) (a)<(b) ? (a) : (b)
#define max(a,b) (a)>(b) ? (a) : (b)
#if defined(__uxp__) || defined(sun)
#define cup(col,line) tputs((char *)tgoto( Cursor_code, ((col)-1), ((line)-1) ), 1, &fputerr )
#else
#define cup(col,line) tputs(tgoto( Cursor_code, ((col)-1), ((line)-1) ), 1, &fputerr )
#endif

#if defined(__uxp__) || defined(sun)
int fputerr ( char c ) {   
   return fputc( (int)c, stderr );
}
#else
int fputerr ( int c ) {   
   return fputc( c, stderr );
}
#endif

/* forward declarations */
void
prgid( char *id, char *date, int old, long l_id, long l_date );

void
get_image_id_( char *, char *, long, long );

void
datum_( char*, long );
/* end forward declations */


void
prgid_( char *id, char *date, long l_id, long l_date ) {

   prgid( id, date, 0, l_id, l_date );
}

void
prgid_old_( char *id, char *date, long l_id, long l_date ) {
   prgid( id, date, 1, l_id, l_date );
}


void
prgid( char *id, char *date, int old, long l_id, long l_date ) {
/*
 ***
 ******************************************************************************
 ***
 ***	Schreibt Programmidentifikation.
 ***
 ***	ID:    Programmname
 ***	DATE: Datum der Programmerzeugung
 ***
 ***	 2-DEC-1991 03:51:01.51
 ***
 ***	Modifications:
 ***
 ***	25-FEB-1994 13:10:08.00		ML / IoA.  Added signal handler to turn
 ***					off Sun's stupid .trace files with
 ***					CTRL/C and CTRL/Y
 ***	28-JUN-1994 20:03:15.00		ML / IoA.  Added signal 13 as well.
 ***	29-JUN-1994 21:19:05.00		ML / IoA.  And 15!
 ***
 ******************************************************************************
 ***/

	 
/***
 ***	Local variables
 ***/
	int i, istat, iwidth, j, l, l1, l2, l3, lskip;
	char dat[25], iname[41], *c;
	char Escstr[20], Cursor_code[30];
	char *term_type, bp[1024], *escstr[1], *cursor_code[1];
	int ansi, batch;
        struct winsize ttysize;

	char esc = 27;


/***
 ***	Code
 ***/

#ifdef FOO
!	i = signal( 2, exit, -1 )
!	i = signal( 3, exit, -1 )
!	i = signal( 13, exit, -1 )	! broken pipe
!	i = signal( 15, exit, -1 )	! kill
#endif

	   escstr[0] = Escstr;
	   cursor_code[0] = Cursor_code;;
	   
	   if( !old ) {
	      i = sizeof(iname);
	      j = sizeof(dat);
	      memset( iname, ' ', i );
	      memset( dat, ' ', j );
	      get_image_id_( iname, dat, i-1, j-1 );
	      for( c = iname + i - 1; *c == ' ' && *c != '\0'; c-- ) {
		 *c = '\0';
	      }
	      for( c = dat + j - 1; *c == ' ' && *c != '\0'; c-- ) {
		 *c = '\0';
	      }

	   } else {
	      i = sizeof(iname);
	      memset( iname, 0, i );
	      i = min( i-1, l_id );
	      strncpy( iname, id, i );
	      for( c = iname + i - 1; *c == ' ' && *c != '\0'; c-- ) {
		 *c = '\0';
	      }

	      i = sizeof(dat);
	      memset( dat, 0, i );
	      i = min( i-1, l_date );
	      strncpy( dat, date, i );
	      for( c = dat + i - 1; *c == ' ' && *c != '\0'; c-- ) {
		 *c = '\0';
	      }

	   }

	 term_type = getenv( "TERM" );
	 batch = (term_type == NULL || *term_type == '\0');
   
	 if( !batch ) {
	    istat = sscanf( term_type, "vt%d", &i ); /* returns 1 if TERM=vt123 */
	    ansi = (strcmp( term_type, "ansi" ) == 0 || 
/*		    strcmp( term_type, "xterm" ) == 0 ||*/
		    istat == 1);   /* crummy; assumption: TERM=vt123*
				    * or TERM=ansi */

	    
	    if( tgetent( bp, term_type ) == 0 ) {
	       batch = 1;
	    }
	    
	    if( ioctl( 0, TIOCGWINSZ, &ttysize ) == 0 ) {
	       iwidth = ttysize.ws_col;
	    } else if( !batch ) {
	       iwidth = tgetnum( "co" );
	    } else {
	       iwidth = 80;
	    }
	 
	 } else {
	    iwidth = 80;
	    ansi = 0;
	 }
	 
	l1 = strlen( iname );
	l2 = strlen( dat );
	for( l3 = l_date - 1; l3 >= 0; l3-- ) {
	   if( date[l3] != ' ' && date[l3] != '\0' ) break;
	}
        l3++;
	if( old ) {
	   l = l1 + l2;
	} else {
	   l = l1;
	}

	lskip = iwidth - (6 + l3) + 1;  	     /* New cursor position,
/*	lskip = iwidth - (6 + l2);     		     /* New cursor position,
                                                      * symmetric to mid of screen. */
	lskip = min( lskip, iwidth - (l3 + 6) + 1 ); /* Move long stuff left if
                                                      * possible */
        lskip = max( lskip, l2 + 6 + 2 );            /* Too long, move left as
						      * far as possible */
	l3 = min( l3, iwidth - lskip - 6 + 1 );      /* and cut off string. */
        l3 = max( l3, 0 );


	if( !batch ) {
	   tputs( tgetstr( "cl", escstr ), 1, &fputerr );
	   escstr[0] = Escstr;
	   tputs( tgetstr( "md", escstr ), 1, &fputerr );
	   tgetstr( "cm", cursor_code );
	}

        if( ansi ) {
	   l = (iwidth/2 - l)/2 + 1;
	   cup( l, 1 );
	   if( old ) {
	      fprintf( stderr, "%c%s%s%s", esc, "#3", iname, dat );
	      cup( l, 2 );
	      fprintf( stderr, "%c%s%s%s", esc, "#4", iname, dat );
	      cup( 1, 5 );
	   } else {
	      fprintf( stderr, "%c%s%s", esc, "#3", iname );
	      cup( l, 2 );
	      fprintf( stderr, "%c%s%s%c%s", esc, "#4", iname, esc, "[m" );
	      cup( 1, 3 );
	      fprintf( stderr, "%c%s%s", esc, "[1mLink: ", dat );
	      cup( lskip, 3 );
	      fprintf( stderr, "%s%*.*s", "Code: ", l3, l3, date );
	      cup( 1, 6 );
	   }
	} else {
	   if( old ) {
	      l = (iwidth - (2*l - 1))/2;
	      if( !batch ) {
	         cup( l, 1 );
                 for( i = 0; i < l1; i++ ) {
	            fprintf( stderr, "%c ", iname[i] );
		 }
                 for( i = 0; i < l1; i++ ) {
	            fprintf( stderr, "%c ", dat[i] );
		 }
	         cup( l+1, 2 );
                 for( i = 1; i <= 2*l1 + 2*l2 - 1; i++ ) {
	            fprintf( stderr, "=" );
		 }
		 fprintf( stderr, "\n" );
	      } else {
                 for( i = 0; i < l - 1; i++ ) {
	            fprintf( stderr, " ");
		 }
                 for( i = 0; i < l1; i++ ) {
	            fprintf( stderr, " %c", iname[i] );
		 }
                 for( i = 0; i < l2; i++ ) {
	            fprintf( stderr, " %c", dat[i] );
		 }
		 fprintf( stderr, "\n" );
                 for( i = 0; i < l; i++ ) {
	            fprintf( stderr, " " );
		 }
                 for( i = 1; i <= 2*l1 + 2*l2 - 1; i++ ) {
	            fprintf( stderr, "=" );
		 }
		 fprintf( stderr, "\n" );
	      }
	   } else {
	      l = (iwidth - (2*l1 - 1))/2;
	      if( !batch ) {
	         cup( l, 1 );
		 for( i = 0; i < l1; i++ ) {
		    fprintf( stderr, " %c", iname[i] );
		 }
	         cup( l+1, 2 );
                 for( i = 1; i <= 2*l1 - 1; i++ ) {
	            fprintf( stderr, "=" );
		 }
	         fprintf( stderr, "\n" );
	      } else {
                 for( i = 0; i < l - 1; i++ ) {
	            fprintf( stderr, " " );
		 }
		 for( i = 0; i < l1; i++ ) {
		    fprintf( stderr, " %c", iname[i] );
		 }
		 fprintf( stderr, "\n" );
                 for( i = 0; i < l; i++ ) {
	            fprintf( stderr, " " );
		 }
                 for( i = 1; i <= 2*l1 - 1; i++ ) {
	            fprintf( stderr, "=" );
		 }
	         fprintf( stderr, "\n" );
	      }
	      lskip = lskip - (l2 + 6) - 1;
	      fprintf( stderr, "Link: %*.*s%*.*sCode: %*.*s\n", 
		      l2, l2, dat, 
		      lskip, lskip, " ", 
		      l3, l3, date );
	   }
	   fprintf( stderr, "\n\n" );
	}
	datum_( dat, 25 );
        dat[20] = '\0';
	if( !batch ) {
	   escstr[0] = Escstr;
	   tputs( tgetstr( "me", escstr ), 1, &fputerr );
	}
	fprintf( stderr, "Current Date: %s\n", dat );
        fflush( stderr );
        fflush( stdout );
}

