	SUBROUTINE APODIZE(N,N1,N2,DATA,PERCENT)
* Program to apodize the ends of the spectrum with a cosine bell
* The cosine bell starts rising from zero at N1 and falls to zero at N2
	REAL*4 DATA(1)
	PARAMETER( PI = 3.14159265 )
	NSQUASH = N * .01 * PERCENT
	NSQUASH = MIN(NSQUASH,(N2-N1)/2)
	DO I = 0,NSQUASH-1
	    ARG = PI * FLOAT(I)/(NSQUASH-1)
	    FACTOR = .5 * (1 - COS(ARG))
	    DATA(N1+I) = FACTOR * DATA(N1+I)
	    DATA(N2-I) = FACTOR * DATA(N2-I)
	END DO
	DO I = 1,N1-1
	    DATA(I) = 0
	END DO
	DO I = N2+1,N
	    DATA(I) = 0
	END DO
	RETURN
	END

	SUBROUTINE SUBCONT(NPT,DATA,CURVE)
* Program to fit and subtract the continuum from a spectrum

	REAL*4 DATA(NPT), CURVE(NPT)
C	REAL*4 TEMP(NPT)
	REAL*4 LPOLY, SCALE(2)
	REAL*8 COEFF(5)

	DO I = 1,NPT
	    CURVE(I) = I
	END DO
* Include this for division
*	DO 5 J = 1,NPT
*5	TEMP(J) = ALOG(DATA(J))
	SCALE(1) = CURVE(1)
	SCALE(2) = CURVE(NPT)
	NCOEFF = 5
	CALL FITLPOLY(NPT,CURVE,DATA,SCALE,NCOEFF,COEFF)

	DO 70 J = 1,NPT
	CURVE(J) = LPOLY(CURVE(J),SCALE,NCOEFF,COEFF)
* Include this for division
*	CURVE(J) = EXP(CURVE(J))

* This is the original fit subtraction
70	DATA(J) = DATA(J) - CURVE(J)

* This is a test to see if division works better
*	if(curve(j).le.0) write(6,*) 'help, help: continuum fit < 0'
*70	DATA(J) = DATA(J)/CURVE(J) - 1

	RETURN
	END

	SUBROUTINE HKZERO(N,WAVE,DATA,PERCENT)
* Program to apodize the ends of the spectrum with a cosine bell,
* making sure to take out all of H+K by starting at 3994A
	REAL*4 WAVE(1), DATA(1)
	REAL*4 CUT1, CUT2
	DATA CUT1, CUT2 /3910., 3994./
	PARAMETER( PI = 3.14159265 )
	I1 = 0
	I2 = 0
	DO I = 1,N
	    IF(WAVE(I).GT.CUT1.AND.I1.EQ.0) THEN
	    	I1 = I - 1
	    ENDIF
	    IF(WAVE(I).GT.CUT2.AND.I2.EQ.0) THEN
	    	I2 = I
	    	GOTO 11
	    ENDIF
	END DO
11	CONTINUE
	NSQUASH = N * .01 * PERCENT
	DO I = 1,I2
	    DATA(I) = 0
	END DO
	DO I = 1,NSQUASH
	    ARG = PI * (I-1)/(NSQUASH-1)
	    FACTOR = .5 * (1 - COS(ARG))
	    DATA(I+I2) = FACTOR * DATA(I+I2)
	    DATA(N-I+1) = FACTOR * DATA(N-I+1)
	END DO
	RETURN
	END

	SUBROUTINE SODIUM(NPIX,WAVEB,WAVER,V,TEMP,NAD)
* Program to make a "sodium correction spectrum" from a passed template.
* Given a continuum subtracted template spectrum, SODIUM will create 
* another that has just NaD of a maximum amplitude of 1. The NaD will
* be shifted to a redshift of V km/s.
	REAL*4 NAD(NPIX), TEMP(NPIX)
	PARAMETER( PI = 3.14159265 )
	PIXEL(W) = A * ALOG(W) + B
	WAVELENGTH(P) = EXP((P - B) / A)

	A = NPIX / ALOG(WAVER/WAVEB)
	B = -A * ALOG(WAVEB)
	I1 = PIXEL(5885.)
	I2 = PIXEL(5901.)
	NSQUASH = 20
	DO I = 1,I1-NSQUASH
	    NAD(I) = 0
	END DO
	DO I = 1,NSQUASH
	    ARG = PI * FLOAT(I-1)/(NSQUASH-1)
	    FACTOR = .5 * (1 - COS(ARG))
	    NAD(I+I1-NSQUASH) = FACTOR * TEMP(I+I1-NSQUASH)
	    NAD(I2+NSQUASH-I+1) = FACTOR * TEMP(I2+NSQUASH-I+1)
	END DO
	DO I = I1,I2
	    NAD(I) = TEMP(I)
	END DO
	DO I = I2+NSQUASH,NPIX
	    NAD(I) = 0
	END DO
	DMIN = 0
	DO I = I1,I2
	    DMIN = AMIN1(NAD(I),DMIN)
	END DO
	DO I = I1-NSQUASH,I2+NSQUASH
	    NAD(I) = -NAD(I) / DMIN
	END DO
	IF(V.EQ.0) RETURN
	LOG2N = NINT(ALOG(FLOAT(NPIX))/ALOG(2.))
	SHIFT = A * ALOG(V/299793.+1)
	PHASE = 2*PI*SHIFT/NPIX
	CALL RCVECTOR(NPIX,NAD,NAD)	
	CALL FFT2C(NAD,LOG2N,+1)
	CALL ADDPHASE(NPIX,NAD,PHASE)
	CALL FFT2C(NAD,LOG2N,-1)
	CALL CRVECTOR(NPIX,NAD,NAD)
	RETURN
	END
