        function cont( mlam )
C ***
C ******************************************************************************
C ***
C ***	Continuum Calculation
C ***
C ***	Modifications:
C ***
C ***	19-MAY-1998 17:24:04.93		ML / Bamberg.  Use MAP1 for contiuum
C ***					interpolation.
C ***	 9-JUN-1998 21:09:40.13		ML / Bamberg.  Or not.  Doesn't seem
C ***					to make any difference.  Commented out.
C ***
C ******************************************************************************
C ***
	implicit none
	include 'LINLTE.INC'

C ***
C ***	Parameters
C ***
        real cont, conopa, mlam

C ***
C ***	Global variables
C ***
	include 'OPCON.INC'
      	include 'STRUCT.INC'
      	include 'IF.INC'
      	include 'FLUSS.INC'

C ***
C ***	Local variables
C ***
	logical extra, no_flux
	integer l, n, ignore
        real x, xp, y, z, dum( nopcon )

C ***
C ***	Functions
C ***
	real pol, flux, map1

        xp( x ) = exp( x*2.30258E0 )

	no_flux = .false.
	go to 1


	entry conopa( mlam )
C ***         ======

	no_flux = .true.

1	continue
        z = 28548./mlam
        y = 1.1911E35/mlam/mlam/mlam/mlam/mlam
        do n = 1, nma
           blam( n ) = y/( exp(z*theta(n)) - 1. )
           do l = 1, lma
              dum( l ) = alsl( n, l )
           end do
           sigmac( n ) = xp( pol(mlam, olam, dum, 1, lma, 2, extra) )
!map1!           ignore = map1( olam, dum, lma,  mlam, sigmac(n), 1 )
!map1!           sigmac( n ) = xp( sigmac(n) )
           do l = 1, lma
              dum( l ) = alkl( n, l )
           end do
!map1!           ignore = map1( olam, dum, lma,  mlam, etac(n), 1 )
!map1!           etac( n ) = ( xp(etac(n)) + sigmac(n) )/roptot( n )
           etac( n ) = ( xp(pol(mlam, olam, dum, 1, lma, 2, extra)) +
     >                   sigmac(n) )/roptot( n )
        end do
	if( extra ) then
	   write( stdout, * )
     >       'LINLTE>> WARNING: Continuous opacities extrapolated for ',
     >        mlam, ' ngstrm!'
	end if
	if( .not.no_flux ) then
           conti = .TRUE.
           cont = flux( 0. )
           conti = .FALSE.
	else
	   cont = 0.
	end if

        end
