* Various subroutines to perform correlations and other things
	SUBROUTINE PREPARE(N,DATA,FT,NAP1,NAP2,PERCENT,K1,K2,K3,K4,RMS)
	REAL*4 DATA(1)
	COMPLEX FT(1)
	LOG2N = NINT(ALOG(FLOAT(N))/ALOG(2.))
	CALL RRVECTOR(N,DATA,FT)
	CALL APODIZE(N,NAP1,NAP2,FT,PERCENT)
	CALL RCVECTOR(N,FT,FT)
	CALL FFT2C(FT,LOG2N,+1)
	RMS = RMSFILTER(N,K1,K2,K3,K4,FT)
	RETURN
	END

        SUBROUTINE CFNPARAM(N,A,K1,K2,K3,K4,SCALE,VELOCITY,
     1	FTDATA,FTTEMP,FTCFN,CFN,V,W,R,H)
	COMPLEX FTDATA(1), FTTEMP(1), FTCFN(1)
	REAL*4 VELOCITY(1), CFN(1)
	REAL*8 PC(5)
	LOGICAL*1 ERROR
	PARAMETER( C=299793. )
	POLY(Z) = PC(1) + Z*(PC(2) + Z*(PC(3) + Z*(PC(4) + Z*PC(5))))

	LOG2N = NINT(ALOG(FLOAT(N))/ALOG(2.))
	CALL CORRELATE(N,FTDATA,FTTEMP,FTCFN)
	CALL CCVECTOR(N,FTCFN,CFN)
	CALL FILTER(N,K1,K2,K3,K4,CFN)
	CALL FFT2C(CFN,LOG2N,-1)
	CALL CRVECTOR(N,CFN,CFN)
	CALL FLIP(N,CFN)
	CALL PEAKFIT(N,VELOCITY,CFN,V,W,PC,ERROR)
	IF(ERROR) WRITE(6,*) 'Error in PEAKFIT'
	H = POLY(V) / SCALE / N
	SHIFT = A * ALOG(V/C+1)
	CALL ASPART(N,K1,K2,K3,K4,SHIFT,FTCFN,ARMS,SRMS)
	ARMS = ARMS / SCALE / N
	SRMS = SRMS / SCALE / N
	IF(ARMS.GT.0) THEN
	    R = H / (2*ARMS)
	ELSE
	    R = 1000
	END IF
c	WRITE(6,2000) V, H, W, R
c2000	FORMAT(1X,'V =',F7.0,'  H =',F5.2,'  W =',F6.1,'  R =',F6.2)
c	WRITE(6,2001) RMS, ARMS, SRMS
c2001	FORMAT(1X,'rms =',F7.1,'  Arms =',F7.4,'  Srms =',F7.4)
	RETURN
	END

	SUBROUTINE CORRELATE(N,FT1,FT2,CFN)
	COMPLEX*8 FT1(1), FT2(1), CFN(1)
	DO J = 1,N
	    CFN(J) = FT1(J) * CONJG(FT2(J))
	END DO
	RETURN
	END

	SUBROUTINE QUOTIENT(N,FT1,FT2,CFN)
	COMPLEX*8 FT1(1), FT2(1), CFN(1)
	DO J = 1,N
	    IF(FT2(J).NE.0) THEN
	    	CFN(J) = FT1(J) / FT2(J)
	    ELSE
	    	CFN(J) = 0
	    END IF
	END DO
	RETURN
	END

	SUBROUTINE POLAR(N,FT,R,T)
	REAL*4 R(1), T(1)
	COMPLEX*8 FT(1)
	DO J = 1,N
	    R(J) = CABS(FT(J))
	    IF(R(J).GT.0) THEN
	    	T(J) = ATAN2(AIMAG(FT(J)),REAL(FT(J)))
	    ELSE
	    	T(J) = 0
	    END IF
	END DO
	RETURN
	END

	SUBROUTINE ADDPHASE(N,CFN,PHASE)
	COMPLEX*8 CFN(1), FACTOR
	DO J = 1,N
	    IF(J.LT.N/2+1) THEN
	        ARG = (J-1) * PHASE
	    ELSE
	        ARG = (J-N-1) * PHASE
	    END IF
	    FACTOR = CMPLX(COS(ARG),SIN(ARG))
	    CFN(J) = CFN(J) * FACTOR
	END DO
	RETURN
	END

	FUNCTION RMSFILTER(N,K1,K2,K3,K4,X)
* Return the rms of a real function passed through a bandpass filter in
* Fourier space. The bandpass is the square root of a cosine bell.
	COMPLEX*8 X(1)
	PARAMETER( PI=3.14159 )
	RMSFILTER = 0
	DO K = K1,K4
	    IF(K.EQ.0.OR.K.EQ.N/2) THEN
	        F = 1
	    ELSE
	        F = 2
	    END IF
	    IF(K.LT.K2) THEN
	    	ARG = PI * FLOAT(K-K1)/FLOAT(K2-K1)
	    	FACTOR = .5 * (1-COS(ARG))
	    ELSE IF(K.GT.K3) THEN
	    	ARG = PI * FLOAT(K-K3)/FLOAT(K4-K3)
	    	FACTOR = .5 * (1+COS(ARG))
	    ELSE
	    	FACTOR = 1
	    END IF
	    RMSFILTER = RMSFILTER + F * FACTOR *
     1	(REAL(X(K+1))*REAL(X(K+1)) + AIMAG(X(K+1))*AIMAG(X(K+1)))
	END DO
	RMSFILTER = SQRT(RMSFILTER) / N   !Because it is the transform
	RETURN
	END

	SUBROUTINE FILTER(N,K1,K2,K3,K4,X)
* Filter a Fourier tranform by multiplying by a cosine bell
	COMPLEX*8 X(1)

	DO J = 1,N
	    IF(J.LT.N/2+1) THEN
	    	NUMBER = J - 1
	    ELSE
	    	NUMBER = J - N - 1
	    END IF
	    NUMA = ABS(NUMBER)
	    IF(NUMA.LT.K1.OR.NUMA.GT.K4) THEN
	    	FACTOR = 0
	    ELSE IF(NUMA.LT.K2) THEN
	    	ARG = 3.14159 * FLOAT(NUMA-K1)/FLOAT(K2-K1)
	    	FACTOR = .5 * (1-COS(ARG))
	    ELSE IF(NUMA.GT.K3) THEN
	    	ARG = 3.14159 * FLOAT(NUMA-K3)/FLOAT(K4-K3)
	    	FACTOR = .5 * (1+COS(ARG))
	    ELSE
	    	FACTOR = 1
	    END IF
	    X(J) = X(J) * FACTOR
	END DO
	RETURN
	END

	SUBROUTINE SQFILTER(N,K1,K2,K3,K4,RMS,X,R)
* Filter a Fourier tranform by multiplying by a square root cosine bell
* Inverse transform, divide by RMS and put in R
	COMPLEX*8 X(1)
	REAL*4 R(1)

	LOG2N = NINT(ALOG(FLOAT(N))/ALOG(2.))
	DO J = 1,N
	    IF(J.LT.N/2+1) THEN
	    	NUMBER = J - 1
	    ELSE
	    	NUMBER = J - N - 1
	    END IF
	    NUMA = ABS(NUMBER)
	    IF(NUMA.LT.K1.OR.NUMA.GT.K4) THEN
	    	FACTOR = 0
	    ELSE IF(NUMA.LT.K2) THEN
	    	ARG = 3.14159 * FLOAT(NUMA-K1)/FLOAT(K2-K1)
	    	FACTOR = SQRT(.5 * (1-COS(ARG)))
	    ELSE IF(NUMA.GT.K3) THEN
	    	ARG = 3.14159 * FLOAT(NUMA-K3)/FLOAT(K4-K3)
	    	FACTOR = SQRT(.5 * (1+COS(ARG)))
	    ELSE
	    	FACTOR = 1
	    END IF
	    X(J) = X(J) * FACTOR / RMS
	END DO
	CALL FFT2C(X,LOG2N,-1)
	CALL CRVECTOR(N,X,R)
	RETURN
	END

	SUBROUTINE FLIP(N,BUF)
	REAL*4 BUF(1)
	DO J = 1,N/2
	    TEMP = BUF(J)
	    BUF(J) = BUF(J+N/2)
	    BUF(J+N/2) = TEMP
	END DO
	RETURN
	END

	SUBROUTINE PHASEBAND(N,SHIFT,X,PHASE)
* Computes the phase of a complex function on the assumption that it is
* within +/- pi of 2*pi*SHIFT*j/N
	REAL*4 PHASE(1)
	COMPLEX*8 X(1)
	PARAMETER( PI = 3.14159265 )
	DO I = 1,N/2
	    ANGLE = 2*PI*(I-1)*SHIFT/N
	    IF(X(I).EQ.0) THEN
	    	PHASE(I) = ANGLE
	    ELSE
	    	PHASE(I) = ATAN2(AIMAG(X(I)),REAL(X(I)))
	    END IF
	    NPI = (PHASE(I)-ANGLE) / PI
	    IF(NPI.GT.0) THEN
	        NCYCLE = (NPI + 1) / 2
	    ELSE
	        NCYCLE = (NPI - 1) / 2
	    END IF
	    PHASE(I) = PHASE(I) - 2*PI*NCYCLE
	    IF(I.LT.N/2) PHASE(I+N/2) = PHASE(I) - ANGLE
	END DO
	RETURN
	END

	SUBROUTINE PHASERR(N,SHIFT,X,AV,K1,K2,DEV)
* Computes the phase of a complex function on the assumption that it is
* within +/- pi of 2*pi*SHIFT*j/N. It then computes K1 and K2 beyond which
* the phase is random, and DEV of the phase within K1 and K2 (1 = random)
	COMPLEX*8 X(1)
	REAL*4 AV(1)
	PARAMETER( PI = 3.14159265 )
	PARAMETER( NAV=50 )

	DO I = 1,N/2
	    AV(I) = 0
	END DO
	DO I = 1,N/2
	    ANGLE = 2*PI*(I-1)*SHIFT/N
	    IF(X(I).EQ.0) THEN
	    	PHASE = ANGLE
	    ELSE
	    	PHASE = ATAN2(AIMAG(X(I)),REAL(X(I)))
	    END IF
	    NPI = (PHASE-ANGLE) / PI
	    IF(NPI.GT.0) THEN
	        NCYCLE = (NPI + 1) / 2
	    ELSE
	        NCYCLE = (NPI - 1) / 2
	    END IF
	    PHASE = PHASE - 2*PI*NCYCLE - ANGLE
	    DO J = -NAV,NAV
	        IF(I+2*J.GE.1.AND.I+2*J.LE.N/2) THEN
	            NS = MIN(NAV,MIN(I+J-1,N/2-(I+J)))
	            IF(NS.EQ.0) THEN
	                FRAC = 1
	            ELSE
	                FRAC = (1 - ABS(FLOAT(J))/NS) / NS
	            END IF
	            AV(I+J) = AV(I+J) + 2 / PI * ABS(PHASE) * FRAC
	        END IF
	    END DO
	END DO
	DEV = 2
	DO I = 5,N/2-NAV
	    DEV = AMIN1(DEV,AV(I))
	END DO
	K1 = -1
	K2 = -1
	CUT = 0.5 * (1 + DEV)
	DO I = 5,N/2-NAV
	    IF(K1.EQ.-1.AND.AV(I).LT.CUT) K1 = I - 1
	    IF(K1.NE.-1.AND.K2.EQ.-1.AND.AV(I).GT.CUT) K2 = I-2
	END DO
	RETURN
	END

	SUBROUTINE GAUSSIAN(N,SIGMA,X)
* Multiplies the ft X by a gaussian of rms SIGMA in real space
	COMPLEX*8 X(1)
	PARAMETER( PI=3.14159265 )

	WIDTH = N / (2*PI*SIGMA)
	DO J = 1,N
	    NUMBER = J - 1
	    IF(J.GE.N/2+1) NUMBER = NUMBER - N
	    ARG = -.5*(NUMBER/WIDTH)*(NUMBER/WIDTH)
	    IF(ARG.LT.-40) THEN
	    	FACTOR = 0
	    ELSE
	    	FACTOR = EXP(ARG)
	    END IF
	    X(J) = X(J) * FACTOR
	END DO
	RETURN
	END
