        subroutine deriv( x, f, dfdx, n )
	implicit none
C ***
C ***	Parameters
C ***
	integer n
        real x( n ), f( n ), dfdx( n )

C ***
C ***	Local variables
C ***
	integer j
	real s, scale, d, d1, tan, tan1

        dfdx( 1 ) = ( f(2) - f(1) )/( x(2) - x(1) )
        dfdx( n ) = ( f(n) - f(n - 1) )/( x(n) - x(n - 1) )
        if( n .gt. 2 ) then
           s = abs( x(2) - x(1) )/( x(2) - x(1) )
           do j = 2, n - 1
              scale = max( abs(f(j - 1)), abs(f(j)), abs(f(j + 1)) )/
     >                abs( x(j) )
              if( scale .eq. 0. ) scale = 1.
              d1 = ( f(j + 1) - f(j) )/( x(j + 1) - x(j) )/scale
              d = ( f(j) - f(j - 1) )/( x(j) - x(j - 1) )/scale
              tan1 = d1/( s*sqrt(1. + d1**2) + 1. )
              tan = d/( s*sqrt(1. + d**2) + 1. )
              dfdx( j ) = ( tan1 + tan )/( 1. - tan1*tan )*scale
           end do
        end if

        end
