	subroutine eqwidth
C ***	
C ***	Integrates spectrum to get equivalent width.
C ***	
C ***	Output in COMMON /calcul/
C ***	
	implicit none
	include 'LINLTE.INC'
C ***
C ***	Local variables
C ***
	real dl, ddl, d0, d1, d2, d3, d4
C ***
C ***	Functions
C ***
	real dep
C ***
C ***	Global variables
C ***
	include 'IF.INC'
	include 'CALCUL.INC'
        include 'PROFIL.INC'


C ***
C ***   ANFANGSLAMBDA UND SCHRITTWEITE DER INTEGRATION
C ***
        wcal = 0.
        mma = 0
        dl = 0.
        if( single ) then
           ddl = 10.
        else
           dl = -10.
           do while( abs(dep(dl)) .gt. rmin )
              dl = 2.*dl
	   end do
           ddl = -dl/16.
        end if

        d3 = 0.
        do while( dl .lt. endlam .or. rmin .lt. d3 )
C ***
C ***      INTEGRATION DER AEQUIVALENTBREITE (SIMPSON, Bart)
C ***
1          continue
              d0 = dep( dl )
              d1 = dep( dl + ddl )
              d2 = dep( dl + 2.*ddl )
              d3 = dep( dl + 3.*ddl )
              d4 = dep( dl + 4.*ddl )
           if( (abs(d4 - d2) .gt. 0.1 .or.
     >          abs(d3 - d1) .gt. 0.1 .or.
     >          abs(d2 - d0) .gt. 0.1) .and. ddl .gt. 19. ) then
              ddl = ddl/2.
              go to 1

           end if

           wcal = wcal + ddl*( 14.*d0 + 64.*d1 + 24.*d2 + 64.*d3 +
     >	          14.*d4 )/45.

           dl = dl + 4.*ddl
           if( dl .gt. -1. ) ddl = 2.*ddl

        end do
	if( single ) wcal = 2.*wcal

	end
