        subroutine falt( output )
C ***
C ***	21-MAR-1995 20:06:20.00		ML / IoA.  Changed FCLAM in output to
C ***                                   be either FCLAM or ICLAM depending on
C ***                                   cos theta.
C ***	 7-MAR-1997 13:56:02.88		ML / Bamberg.  PLOT.OUT output
C ***					normalized to one: ifabs .eq. 3
C ***   16-APR-1997 22:34:51.00         ML / Stegaurach.  SAVE multi,
C ***                                   ximac_ldat, lima_abs, ia%
C ***                                   Damn, save it all...
C ***	11-JUN-1997 18:56:17.00		ML / Bamberg.  Faltungsdaten output
C ***					fixed.  Had still `pre-vsini' spacing.
C ***	16-JUN-1997 20:37:42.28		ML / Bamberg.  Changed F_nu by 1e-2.
C ***                                   Hopefully, this is now correct.
C ***   16-JUL-1997 20:44:23.00         ML / Stegaurach.  Option of having
C ***					several kind of fluxes simultaneously 
C ***					in PLOT.OUT
C ***	31-JUL-1997 18:20:40.38		ML / Bamberg.  Add Teff/logg to PLOT.OUT
C ***	14-SEP-1997 20:54:59.00		ML / Stegaurach.  Changed format for
C ***					fluxes in PLOT.OUT: a few digits less
        
        implicit none

C ***
C ***	Arguments
C ***
	logical output

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'OUTWAV.INC'
	include 'FCON.INC'
	include 'PROFIL.INC'
	include 'IF.INC'
	include 'CALCUL.INC'
	include 'FILES.INC'
	include 'PRINT.INC'
	include 'FLUSS.INC'
	include 'TEFF.INC'

C ***
C ***   Functions
C ***
        real pol, proapp, s

C ***
C ***   Local variables
C ***
	real clight
        parameter( clight = 2.997925e10 )

	integer count
        logical first, iwie, extra, multi, ximac_ldat
        logical iften1000, ifone, iffnu, ifflam


	integer nlin, ncol
        integer ia, ia1, ia2, ia4, ia8
        integer expand, lima, lima_abs, nspac, i, imax, m, mo, mode, n
	integer j, il, ni, status, headlines, datalines, reqtit
        save i, multi, ximac_ldat, lima_abs, ia1, ia2, ia4, ia8
        real a, dldop, str, streu, scan, u, v, w, x, xim

        character plozei*120, line*58, i_or_f
        integer ord( 10 )
        real pap( 250 )
        real rmac( ipkt ), rrot( ipkt ), rap( ipkt )
        real lim( 10 ), lap( 250 ), lamlap( 250 ), ladlap( 250 ),
     >       lampap( 250 )
        real lo, lofwhm, lmfak, normap
	data first /.true./, iwie /.false./

        save

C ***
C ***	get continuum flux and opacities for center of interval
C ***
	mlam = 0.5*( endlam + anflam )
	fclam = pol( mlam, alam, afclam, 1, nfc, 1, extra )

C ***
C ***   READIN FALVAR
C ***
	if( first ) then
C ***
C ***	   open FALT_DAT, status=old.  Done in ANALYZE.
C ***
           multi = .true.
C ***
C ***	   Set ximac_ldat to .true. if xi macro has been set in LINE.DAT.
C ***
           ximac_ldat = ximac .ge. 0.
	end if
        count = 0
        i = 1
1       continue
        if( i .eq. 1 ) then
C ***	do while( i .eq. 1 )
           count = count + 1
	   if( multi ) then
              read( FALT_DAT, * ) ia, nspac, expand, xim, lima
              ia8 = ia/8
              ia = mod( ia, 8 )
              ia4 = ia/4
              ia = mod( ia, 4 )
              ia2 = ia/2
              ia1 = mod( ia, 2 )
	      lima_abs = abs( lima )
              if( lima .ne. 0 ) then
                 do 2 i = 1, lima_abs
                    read( FALT_DAT, * ) ord( i ), lim( i )
2                continue
                 read( FALT_DAT, * ) mo, lo
                 if( lima .gt. 0 ) then
                    read( FALT_DAT, * ) imax, ( lap(i), pap(i), i = 1,
     >                                  imax )
                 else
                    read( FALT_DAT, * ) lofwhm
                 end if
                 read( FALT_DAT, * ) str
              end if
              if( .not.ximac_ldat ) then
	         ximac = xim
	      end if
	   end if
               
C ***   
C ***      MACRO
C ***
           if( ximac .gt. 0. ) then
              dldop = mlam*ximac/299792.
	      call rotcon( lascan, rscan, rmac, mma, 0., 0., dldop,
     >          3.5, 1 )
           else
              do m = 1, mma
                 rmac( m ) = rscan( m )
              end do
           end if
C ***
C ***	   Rotational broadening
C ***
	   if( vsini .gt. 0. ) then
	      call rotcon( lascan, rmac, rrot, mma, vsini, beta_cl, 0.,
     >          0., 2 )
	   else
	      do m = 1, mma
	         rrot(m) = rmac(m)
	      end do
	   end if

C ***
C ***      APPAR
C ***
           if( lima .eq. 0 ) then
              do 6 m = 1, mma
                 rap( m ) = rrot( m )
                 rstreu( m ) = rap( m )
6             continue

           else
              do 7 ni = 1, lima_abs
                 if( mlam .lt. lim(ni) ) go to 8
7             continue

8             m = ord( min(ni, lima_abs) )
              if( mlam .gt. lim(lima_abs) ) m = ord( lima_abs ) - 1
              lmfak = mlam/lo*mo/m
              if( lima .lt. 0 ) then
C ***
C ***            STAPRO
C ***
                 a = 2.0
                 dldop = lofwhm*lmfak*0.600561
9                continue
                 i = 1
                 u = min( dldop/6., 0.005 )
                 v = 20.*u - 0.001
                 w = 0.
                 x = 0.30/dldop
                 mode = 0
10               continue
                 if( w .lt. v ) then
                    lamlap( i ) = w
                    lampap( i ) = proapp( a, w/dldop, x )
                    i = i + 1
                    w = w + u
                    go to 10

                 else

                    mode = mode + 1
                    go to ( 11, 12, 13, 14, 15 ) mode

11                  w = v
                    u = 0.005
                    v = 0.099
                    go to 10

12                  w = 0.10
                    u = 0.025
                    v = 0.499
                    go to 10
             
13                  w = 0.50
                    u = 0.1
                    v = 0.999
                    go to 10

14                  if( str .lt. 0. ) then
	               u = 0.15
                    else
                       u = 0.5
                    end if
                    w = 1.00
                    v = 10.1
                    go to 10

                 end if

15               imax = i - 1
                 lamlap( imax + imax - 1 ) = lamlap( imax )
                 lampap( imax + imax - 1 ) = lampap( imax )
                 n = imax - 1
                 do 16 i = 1, n
                    lamlap( n + i ) = lamlap( i )
                    lampap( n + i ) = lampap( i )
16               continue
                 do 17 i = 1, n
                    lamlap( imax - i ) = -lamlap( imax + i )
                    lampap( imax - i ) = lampap( imax + i )
17               continue
                 imax = 2*imax - 1
                 normap = 0.
                 streu = 0.
                 do 18 i = 2, imax - 1
                    ladlap( i ) = 0.5*( lamlap(i + 1) - lamlap(i - 1) )
                    v = ladlap( i )*lampap( i )
                    normap = normap + v
                    if( abs(lamlap(i)) .gt. 0.299 ) streu = streu + v
18               continue
                 ladlap( 1 ) = ladlap( 2 )
                 ladlap( imax ) = ladlap( imax - 1 )
                 v = ladlap( 1 )*lampap( 1 ) +
     >               ladlap( imax )*lampap( imax )
                 normap = normap + v
                 streu = ( streu + v )/normap
                 w = streu/abs( str )
                 if( abs(w - 1) .gt. 0.01 ) then
                    a = a/w
                    go to 9

                 end if

                 do 19 i = 1, imax
                    lampap( i ) = lampap( i )/normap
19               continue

              else
C ***
C ***            INDPRO
C ***
                 do 20 i = 1, imax
                    lamlap( i ) = lap( i )*lmfak
20               continue
                 normap = 0.
                 do 21 i = 2, imax - 1
                    ladlap( i ) = 0.5*( lamlap(i + 1) - lamlap(i - 1) )
                    normap = normap + ladlap( i )*pap( i )
21               continue
                 ladlap( 1 ) = ladlap( 2 )
                 ladlap( imax ) = ladlap( imax - 1 )
                 normap = normap + ladlap( 1 )*pap( 1 ) +
     >                    ladlap( imax )*pap( imax )
                 do 22 i = 1, imax
                    lampap( i ) = pap( i )/normap
22               continue
              end if

C ***
C ***         FALTUNG
C ***
              rrot( 1 ) = rrot( 2 )
              rrot( mma ) = rrot( mma - 1 )
              do 24 m = 1, mma
                 x = 0.
                 u = lascan( m )
                 do 23 i = 1, imax
                    x = x + ladlap( i )*lampap( i )*
     >                  pol( u + lamlap(i), lascan, rrot, 1, mma, 1,
     >                       extra )
23               continue
                 rap( m ) = x
                 if( lima .gt. 0 ) then
	            rstreu( m ) = rstreu( m ) + 
     >                            abs( str )*( 1. - rap(m) )
	         else
                    rstreu( m ) = rap( m )
	         end if
24            continue
	   end if

	   
	   if( output ) then
C ***          
C ***         OUTPUT FALVAR
C ***
              if( costhe .ge. 0. ) then
	         i_or_f = 'I'
	      else
                 i_or_f = 'F'
	      end if
	      reqtit = 16
	      headlines = 6 + 3
	      datalines = 0
	      if( lima .lt. 0 ) datalines = datalines + 2
              if( lima_abs .gt. 1 ) datalines = datalines + lima_abs - 1
              if( ia1 .eq. 1 ) datalines = datalines + imax + 2
	      call page( headlines, datalines, reqtit )
	      if( curtit .ne. reqtit ) then
	         if( ip .ne. 0 ) then
	            write( 3, '(//)' )
	            ip = ip + 3
	         end if
                 if( ifwave ) then
                    write( 3, 9000 ) 'WAVANF', 'WAVEND', 'DELWAV',
     >                i_or_f,
     >                anfwav, endwav, delwav, ximac, vsini, beta_cl,
     >                lima, mlam, fclam, nspac, expand
                 else
                    write( 3, 9000 ) 'LAMANF', 'LAMEND', 'DELLAM',
     >                i_or_f,
     >                anflam, endlam, 0.001*dellam, ximac, vsini,
     >                beta_cl, lima, mlam, fclam, nspac, expand
                 end if
	         ip = ip + 6
	         curtit = reqtit
              end if
	      if( lima .ne. 0 ) then
C ***         
C ***            OUTPUT
C ***         
                 write( 3, 9020 ) ord( 1 ), lim( 1 ), mo, lo, imax   ! overprint
                 if( lima .lt. 0 ) write( 3, 9030 ) lofwhm, str      ! overprint
                 if( lima_abs .gt. 1 ) then
                    do 25 i = 2, lima_abs
                       write( 3, 9040 ) ord( i ), lim( i )
25                  continue
                    ip = ip + lima_abs - 1
                 end if
              
                 if( lima .lt. 0 ) then
	            write( 3, 9050 ) streu, a
                    ip = ip + 2
	         end if
                 if( ia1 .eq. 1 ) then
C ***         
C ***               OUTPUT APPARATEPROFIL
C ***         
                    if( lima .gt. 0 ) then
                       write( 3, 9060 ) ( lap(i), pap(i), lamlap(i),
     >                   lampap(i), i = 1, imax )
                    else
                       write( 3, 9070 ) ( lamlap(i), lampap(i),
     >	                 i = 1, imax )
                    end if
                    ip = ip + imax + 2
              
                 end if
              
              end if
              
	      nlin = (nfc - 1)/6 + 1
              ncol = (nfc - 1)/nlin + 1

	      reqtit = 17
	      headlines = 1 + 2
	      datalines = 1
	      do m = 1, nlin
                 call page( headlines, datalines, reqtit )
	         if( curtit .ne. reqtit ) then
                    if( ip .ne. 0 ) then
                       write( 3, '(/)' )
                       ip = ip + 2
                    end if
	            write( 3, '(1x, 6a)' ) ('    MLAM     FCLAM    ',
     >                                     n = 1, ncol)
                    ip = ip + 1
                    curtit = reqtit
                 end if
                 write( 3, '((1x, 6(0p, f10.3, 1p, e10.3, 2x)))' )
     >             (alam(m+n), afclam(m+n), n = 0, nfc - m, nlin )
                 ip = ip + 1
	      end do

              if( ia2 .eq. 1 ) then                                   
C ***         
C ***            SCAN PRINT
C ***
                 reqtit = 18
                 headlines = 2
                 if( ifwave ) headlines = headlines + 1
	         if( headlines + mma .le. maxlines ) then
                    datalines = mma
                    call page( headlines, datalines, reqtit )
                 end if
                 datalines = min( 5, mma )
                 headlines = headlines + 3
                 if( ifwave ) then
                    do m = mma, 1, -1
                       call page( headlines, datalines, reqtit )
                       if( curtit .ne. reqtit ) then
                          if( ip .ne. 0 ) then
                             write( 3, '(//)' )
                             ip = ip + 3
                          end if
                          write( 3, '(3a, //, a)' ) '      LASCAN  ',
     >                      'RSCAN   RMAC   RROT    RAP RSTREU   ',
     >                      'I or F lambda',
     >                      ' *********WAVE NUMBERS !!'
                          ip = ip + 3
                          curtit = reqtit
                       end if
                       write( 3, 9090 ) anfwav + (mma - m)*delwav,
     >                   10000.*rscan(m), 10000.*rmac(m),
     >                   10000.*rrot(m), 10000.*rap(m),
     >                   10000.*rstreu(m), rstreu(m)*
     >                   s( lascan(m) - 0.5, alam, afclam, nfc )
                       ip = ip + 1
                    end do
                 else
                    do m = 1, mma
                       call page( headlines, datalines, reqtit )
                       if( curtit .ne. reqtit ) then
                          if( ip .ne. 0 ) then
                             write( 3, '(//)' )
                             ip = ip + 3
                          end if
                          write( 3, '(3a, /)' ) '      LASCAN  ',
     >                      'RSCAN   RMAC   RROT    RAP RSTREU   ',
     >                      'I or F lambda'
                          ip = ip + 2
                          curtit = reqtit
                       end if
                       write( 3, 9090 ) lascan(m), 10000.*rscan(m),
     >                   10000.*rmac(m), 10000.*rrot(m), 10000.*rap(m),
     >                   10000.*rstreu(m), rstreu(m)*
     >                   s( lascan(m) - 0.5, alam, afclam, nfc )
                       ip = ip + 1
                    end do
                 end if
              
              end if
              
              if( ia4 .eq. 1 .or. itv .eq. 1 ) then
C ***         
C ***            SCAN PLOT
C ***
C ***            No complete page control desired here
C ***         
	         reqtit = 19
                 headlines = 0
                 if( mma .le. maxlines ) then
C ***
C ***               new page if everything fits on single page
C ***
                    datalines = mma
                 else
C ***
C ***               else new page if current page is more than half full and
C ***               we need more than half a page
C ***
                    datalines = min( maxlines/2, mma )
                    headlines = headlines + 3
                 end if
                 call page( headlines, datalines, reqtit )
                 if( curtit .ne. reqtit ) then
                    if( ip .ne. 0 ) then
                       write( 3, '(//)' )
                       ip = ip + 3
                    end if
                    curtit = reqtit
                 end if
                 write( stdout, '(//)' )
                 if( ifwave ) then
                    do 26 m = mma, 1, -1
                       x = rstreu( m )
                       if( itv .eq. 1 ) then
                          call falt_plot( x, 50, expand, plozei )
                          write( stdout, 9100 ) 1.E8/lascan( m ),
     >	                    plozei(:56)
                       end if
              
                       if( ia4 .eq. 1 ) then
                          call falt_plot( x, nspac, expand, plozei )
                          scan = anfwav + ( mma - m )*delwav
                          write( 3, 9100 ) scan, plozei(:115)
                          ip = ip + 1
                       end if
              
26                  continue
                 else
                    w = 0.
                    do 27 m = 1, mma
                       x = rstreu( m )
                       w = w + dellam*( 1. - x )
                       if( itv .eq. 1 ) then
                          call falt_plot( x, 50, expand, plozei )
                          write( stdout, 9100 ) lascan( m ),
     >                                          plozei(:56), w
                       end if
              
                       if( ia4 .eq. 1 ) then
                          call falt_plot( x, nspac, expand, plozei )
                          write( 3, 9100 ) lascan( m ), plozei(:115), w
                          ip = ip + 1
                       end if
              
27                  continue
              
                 end if
              
              end if
              
28            continue
              if( ia8 .eq. 1 ) then
C ***         
C ***            WRITE PLOT.OUT
C ***         
                 if( .not. iwie ) then
                    iwie = .true.
                    open( unit = PLOT_OUT, file = 'PLOT.OUT',
     >                   status = 'NEW', iostat = status )
                    if( status .ne. 0 ) open( unit = PLOT_OUT, 
     >                                        file = 'PLOT.OUT',
     >                                      status = 'UNKNOWN' )
                 end if
C ***         
C ***            We may destroy RROT here.  Saves another array.
C ***         
                 if( ihead .gt. 0 .and. head(:1) .ne. ' ' ) then
                    j = ihead
                 else
                    j = 1      ! suppress 'ATM-FEINANALYSE' stuff
                 end if
                 if( ifwave ) then
                    write( PLOT_OUT,
     >                     '(i6,2f11.3,1x,i6,1x,f5.3,1x,a,1x,a)' )
     >                    mma, anfwav, endwav, nint(teff), glog,
     >                    date, head(:j)
                 else
                    write( PLOT_OUT,
     >                     '(i6,2f11.3,1x,i6,1x,f5.3,1x,a,1x,a)' ) 
     >                    mma, anflam, endlam, nint(teff), glog,
     >                    date, head(:j)
                 end if
              
                 iften1000 = index( ifabs, '0' ) .ne. 0
                 ifone = index( ifabs, '3' ) .ne. 0
                 iffnu = index( ifabs, '2' ) .ne. 0
                 ifflam = index( ifabs, '1' ) .ne. 0
                 line = ' '
                 do m = 1, mma
                    il = 0

C ***               Wavelength

                    if( ifwave ) then
                       write( line, '(f10.3)' ) anfwav +
     >                                          (mma - m)*delwav
                    else
                       write( line, '(f10.3)' ) lascan(m)
                    end if
                    il = 12          ! next free position

C ***               10000 flux

                    if( iften1000 ) then
                       write( line(il:), '(f8.0)' ) 10 000.*rstreu(m)
                       il = il + 9   ! one extra for space
                    end if

C ***               unity flux

                    if( ifone ) then
                       write( line(il:), '(f8.6)' ) rstreu(m)
                       il = il + 9   ! one extra...
                    end if

                    if( iffnu .or. ifflam ) then
                       x = pol( lascan(m), alam, afclam, 1 , nfc, 1,
     >                          extra )

C ***                  F lambda

                       if( ifflam ) then
                          write( line(il:), '(1p,e11.5)' ) rstreu(m)*x
                          il = il + 12
                       end if  

C ***                  F nu

                       if( iffnu ) then
                          write( line(il:), '(1p,e11.5)' )
     >                      1.e-16*rstreu(m)*x*
     >                      lascan( m )*lascan( m )/clight
                            il = il + 12
                       end if
                    end if

                    write( plot_out, '(a)' ) line(:il-2)
              
                 end do
              
              end if
	   end if   ! output
C ***   
C ***      ENDE
C ***
           if( multi ) then
   	      read( FALT_DAT, * ) i
           else
              i = 0
	   end if
           go to 1
              
        end if
C ***	end do

        if( first ) then
           multi = count .gt. 1
	   first = .false.
	end if
	if( multi ) rewind FALT_DAT
              
9000	format( 54x, 'F a l t u n g s d a t e n', /,
     >          54x, '=========================',
     >        //, '     ', a6, '    ', a6, ' ', a6, ' XIMAC vsini  ',
     >        'beta  LIMA  ORD    LIM   MO   LO    LOFWHM  STREU    ',
     >        'MLAM     ', a1, 'CLAM    NSPAC  EXPAND  IMAX', //, ' ',
     >        2f10.3, f7.3, f6.2, f6.1, f6.2, i6, t92, f10.3, 1p,
     >        e10.3, i7, i6
     >        )
9020    format( '+', t53, i5, f8.0, i4, f7.0, t127, i6 )
9030    format( '+', t77, f8.3, f7.3 )
9040    format( 52x, i5, f8.0 )
9050    format( /' Fraction outside 0.3 A  STREU=', f8.4, 
     >          '    Instru parameter A=', f7.3 )
9060    format( /'        LAP       PAP    LAMLAP    LAMAP',
     >          /(' ', 4f10.6) )
9070    format( /'     LAMLAP    LAMPAP', /(' ', 2f10.6) )
9090    format( 1x, f11.3, 5f7.0, 4x, 1p, e10.3, 0p )
9100    format( ' ', f10.3, a, f7.1 )
              
        end   
