       FUNCTION FLUX( DL )
C---IFSCAT =0 NO SCATTER, =1 SCATTER
C---IFSURF =0 SOURCE FUNCTION,TAULAM
C---       =1 +FLUX
C---       =2 +INTENSITY
C ***
C ***	Modifications:
C ***
C ***	16-JAN-1995 12:10:22.00		ML / IoA.  Change to 53 point
C ***					tau scale/matrices
C ***	14-MAY-1995 21:50:57.00		ML / IoA.  Added safety for F in
C ***					depth dependent output.  Could cause
C ***                                   division by zero.
C ***	20-FEB-1998 16:11:09.60		ML / Bamberg.  Subscript range error
C ***					on B2CT1.  Changed DO loop to go to
C ***					NMA - 1 instead of NMA.  Second DO
C ***					loop was already doing that.
       implicit none

C ***
C ***  Arguments
C ***
       REAL DL, FLUX

C ***
C ***  Global variables
C ***
       INCLUDE 'LINLTE.INC'
C
       INCLUDE 'MATX.INC'
       INCLUDE 'STRUCT.INC'
       INCLUDE 'IF.INC'
       INCLUDE 'FLUSS.INC'
       INCLUDE 'DEPTH.INC'

C ***
C ***  Local variables
C ***
       REAL XS( NXTAU ), XBLAM( NXTAU ), XBETA( NXTAU ),
     >      DIAG( NXTAU )
       REAL A( NDEPTH ), B( NDEPTH ), C( NDEPTH )
       REAL HNU( NDEPTH ), JNU( NDEPTH ), JMINS( NDEPTH )
       REAL DUM( NDEPTH )
       REAL CTWO( NDEPTH ), B2CT( NDEPTH ), B2CT1( NDEPTH )
       REAL TAULAM( NDEPTH )
       REAL STRUE( NDEPTH )
       REAL NEW, SC, ERROR, DELXS, OLD, SNEW
       REAL D, DDDDD, CH, F, TL1, TL2, TANGLE

       INTEGER K, L, M, N, NM1, NMJ, NR
       INTEGER MAXJ, MDUMMY

C ***
C ***  Functions
C ***
       INTEGER MAP1
       REAL SUMETA, SUMET2

       EQUIVALENCE( XBLAM(1), A(1), HNU(1), DUM(1), B2CT(1) )
       EQUIVALENCE( XBETA(1), B(1), JNU(1), B2CT1(1) )
       EQUIVALENCE( DIAG(1), C(1), JMINS(1), CTWO(1) )

       DO N = 1, NMA
          DUM( N ) = SUMETA( N + 0, DL, SUMET2 )
          SC = SIGMAC( N )/ROPTOT( N )
          STRUE( N ) = ( SUMET2 - SC )/( DUM(N) - SC )*BLAM( N )
          BETA( N ) = SC/DUM( N )
       END DO
       CALL INTEG( RTAU, DUM, TAULAM, NMA, RTAU(1)*DUM(1) )
       TAULAM( 1 ) = 0.
       IF( IFSCAT .NE. 1 ) THEN
          DO N = 1, NMA
             SLAM( N ) = ( 1. - BETA(N) )*STRUE( N ) +
     >                   BETA( N )*BLAM( N )
          END DO
          IF( IFSURF .EQ. 1 ) THEN
             IF( IFSPHA .EQ. 1 ) THEN
                DO N = 1, NMA
                   SLAM( N ) = SLAM( N )*R( N )*R( N )
                END DO
             END IF
             MAXJ = MAP1( TAULAM, SLAM, NMA, XTAU, XS, NXTAU )
          END IF
       ELSE

          IF( IFSPHA .EQ. 1 .AND. IFSURF .EQ. 1 ) THEN
             DO N = 1, NMA
                STRUE( N ) = STRUE( N )*R( N )*R( N )
             END DO
          END IF

          MAXJ = MAP1( TAULAM, STRUE, NMA, XTAU, XBLAM, NXTAU )
          MAXJ = MAP1( TAULAM, BETA, NMA, XTAU, XBETA, NXTAU )
          DO L = 1, NXTAU
             IF( XBETA(L) .LT. 0. ) XBETA( L ) = 0.
             XS( L ) = XBLAM( L )
             DIAG( L ) = 1. - XBETA( L )*COEFJ( L, L )
             XBLAM( L ) = ( 1. - XBETA(L) )*XBLAM( L )
          END DO
          ERROR = 1.
          L = 1
          DO WHILE( ERROR .GE. 0.00001 .AND. L .LE. NXTAU )
             ERROR = 0.
             DO K = NXTAU, 1, -1
                delxs = 0.
                do m = 1, nxtau
                   delxs = delxs + coefj( k, m )*xs(m)
                end do
                DELXS = ( DELXS*XBETA(K) + XBLAM(K) - XS(K) )/DIAG( K )
                ERROR = MAX( ABS( DELXS/XS(K) ), ERROR )
                XS( K ) = XS( K ) + DELXS
             END DO
             L = L + 1
          END DO
          IF( ERROR .GE. 0.00001 ) WRITE( STDOUT, FMT = 9000 ) ERROR
          MDUMMY = MAP1( XTAU, XS, NXTAU, TAULAM, SLAM, MAXJ )
          IF( MAXJ .NE. NMA ) THEN
             DO N = MAXJ + 1, NMA
                SLAM( N ) = STRUE( N )
             END DO
             M = MAX( MAXJ - 1, 1 )
             NM1 = NMA - M + 1
             NMJ = NMA - MAXJ + 1
             ERROR = 1.
             L = 1
             DO WHILE( ERROR .GE. 0.00001 .AND. L .LE. NXTAU )
                ERROR = 0.
                CALL DERIV( TAULAM(M), SLAM(M), HNU(M), NM1 )
                DO N = M, NMA
                   HNU( N ) = HNU( N )/3.
                END DO
                CALL DERIV( TAULAM(MAXJ), HNU(MAXJ), JMINS(MAXJ), NMJ )
                DO N = MAXJ + 1, NMA
                   JNU( N ) = JMINS( N ) + SLAM( N )
                   SNEW = ( 1. - BETA(N) )*STRUE( N ) +
     >                    BETA( N )*JNU( N )
                   ERROR = ABS( SNEW - SLAM(N) )/SNEW + ERROR
                   SLAM( N ) = SNEW
                END DO
                L = L + 1
             END DO
             IF( ERROR .GE. 0.00001 ) WRITE( STDOUT, 9010 ) ERROR, MAXJ,
     >                                DL
          END IF
       END IF
       IF( IFSURF .EQ. 2 ) THEN
C ***
C ***    Intensity calculation
C ***
          CALL PARCOE( SLAM, TAULAM, A, B, C, NMA )
          DO N = 1, NMA - 1
             CTWO( N ) = C( N )*2.
             B2CT( N ) = B( N ) + CTWO( N )*TAULAM( N )
             B2CT1( N ) = B( N ) + CTWO( N )*TAULAM( N + 1 )
          END DO
          OLD = 1.
          FLUX = 0.
          DO N = 1, NMA - 1
             TANGLE = TAULAM( N + 1 )/COSTHE
             IF( TANGLE .GT. 70. ) THEN
                GO TO 16

             ELSE
                NEW = EXP( -TANGLE )
                D = TANGLE - TAULAM( N )/COSTHE
                IF( D .LE. 0.03 ) THEN
                   IF( D .GT. 0.001 ) THEN
                      DDDDD = ( (((D/9. + 1.)*D/8. + 1.)*D/7. + 1.)*D/
     >                        6. + 1. )*D/5. + 1.
                   ELSE
                      DDDDD = 1.
                   END IF
                   FLUX = FLUX + NEW*( SLAM(N) +
     >                    (SLAM(N) + B2CT(N)*COSTHE + (SLAM(N) +
     >                    (B2CT(N) + CTWO(N)*COSTHE)*COSTHE)*(DDDDD*D/
     >                    4. + 1.)*D/3.)*D/2. )*D
                ELSE
                   FLUX = FLUX + OLD*( SLAM(N) +
     >                    (B2CT(N) + CTWO(N)*COSTHE)*COSTHE ) -
     >                    NEW*( SLAM(N + 1) + (B2CT1(N) +
     >                    CTWO(N)*COSTHE)*COSTHE )
                END IF
                OLD = NEW
             END IF
          END DO
          FLUX = FLUX + OLD*( SLAM(NMA) +
     >           (B2CT(NMA) + CTWO(NMA)*COSTHE)*COSTHE )
16        CH = COSTHE
       ELSE IF( IFSURF .EQ. 1 ) THEN
C ***
C ***    Flux calculation
C ***
          FLUX = 0.
          DO M = 1, NXTAU
             FLUX = FLUX + COEFH( M )*XS( M )
          END DO
          FLUX = 4.*FLUX
          CH = 2./3.
       ELSE IF( IFSURF .EQ. 0 ) THEN
          FLUX = -10000.
          RETURN
       END IF
       IF( (CONTI .OR. (ABS(DL - DLK(IABS(KCONTR))) .LT. 1.) .OR.
     >     BOA(4)) .AND. KCONTR .GE. 0 ) THEN
C ***
C ***    Depth dependent quantities
C ***
          F = 0.
          A( 1 ) = 0.
          DO N = 2, NMA
             TL1 = TAULAM( N )/CH
             TL2 = TAULAM( N - 1 )/CH
             IF( TL1 .GT. 87. .OR. TL2 .GT. 87. ) THEN
                DO NR = N, NMA
                   A( NR ) = 0.
                END DO
                GO TO 20

             ELSE
                A( N ) = 0.5*( SLAM(N)/EXP(TL1) +
     >                   SLAM(N - 1)/EXP(TL2) )*( TL1 - TL2 )
                F = F + A( N )
             END IF
          END DO

20        CONTINUE
          if( f .eq. 0. ) f = 1.e-32
          IF( CONTI ) THEN
             DO N = 1, NMA
                TAULAC( N ) = TAULAM( N )
                CONTRC( N ) = 100.*A( N )/F
             END DO
          ELSE
             DO N = 1, NMA
                CONTRL( N ) = 100.*A( N )/F
             END DO
          END IF
       END IF

9000   FORMAT( ' Quellfunktion konvergiert nicht!  ERROR=', F9.5 )
9010   FORMAT( ' Quellfunktion fuer grosse Tau konv. nicht!  ERROR=',
     >       F9.5, '  MAXJ=', I4, /
     >         '                                             DL=', 1P,
     >       e10.4 )

       END
