        subroutine gam( k )
C ***
C ******************************************************************************
C ***
C ***	Modifications:
C ***
C ***	14-APR-1998 18:16:38.96	ML / Bamberg.  Made from KAPGAM.
C ***	
C ***
C ******************************************************************************
C ***
	implicit none

C ***   Arguments
C ***
        integer k

C ***
C ***   Global variables
C ***
	include 'LINLTE.INC'
        include 'IONS.INC'
        include 'STRUCT.INC'
        include 'PRES.INC'
        include 'LINDAT.INC'
        include 'LINE.INC'
	include 'BROAD.INC'

C ***
C ***   Functions
C ***
        real xp, rrca

C ***
C ***   Local variables
C ***
        logical cowley

        real c4konst

C ***   c4konst = 10^-8/K/5040 ,  10^-8 wegen Einheit 10^8 rad/sec

        parameter( c4konst = 1.e-8/6.96e-13 )

        integer iz, n
	real log_lam, nl, nu
        real anm, c4fak, qneff2, th, w, x, x1, z

        xp( x ) = exp( x*2.30258e0 )

C ***
C ***   line dependent quantities
C ***

        log_lam = log10( lamk(k) )
        w = -20.3015 + gflg( k )
        
	if( lprof(k) .eq. PVOIGT ) then
           cowley = c4lg(k) .eq. 0.
           c4lg( k ) = c4lg( k ) - dlogc4
           w = w + log_lam
           iz = mod( namk(k), 100 ) + 1
           if( iz .gt. 9 ) iz = 1
           if( cowley ) then
C ***   
C ***         Fuer Naeherung des Starkeffekts nach Cowley (1971)[Atome]
C ***                                         und  Griem  (1968)[Ionen]
C ***         (S.Stuerenburg, Jan.1991; modified: M. Lemke 18-MAY-1992)
C ***   
C ***	      c4fak is 4 times smaller than in Cowley paper, was that my
C ***	      modification? ML, 12-MAY-1995 15:08:04.00
C ***   
C ***	      12-MAY-1995 15:11:08.00             ML / IoA.  
C ***	      Added one more neff2 to c4lg.  Not critical, used only in
C ***	      output.  Cowley gives T-independent gamma, which is X1
C ***	      below, so it always used the correct value.
C ***   
              if( iz .eq. 1 ) then
                 c4fak = 2.259e-7*4.
              else
                 c4fak = 5.421e-7/iz/iz*4.
              end if
        
              qneff2 = iz*iz*13.6/( max( 1.e-2,   ! make sure it's > 0
     >                                   chij(kj(k)) - chik(k) ) )
              x1 = c4fak*qneff2*qneff2*c4konst*xp( 2./3.*dlogc4 )
              c4lg( k ) = -( 1.5*(log10(qneff2*qneff2) +
     >                            log10(c4fak/11.37)) - 3.9 ) - 
     >	                  dlogc4
           end if
        
           if( drrca(k) .gt. -0.1 ) then
              rrcau( k ) = 0.
              rrcao( k ) = 0.
           else
              rrcau( k ) = rrca( chik(k), diu(k) + chij(kj(k)), 
     >                     lu(k), iz + 0 )
              rrcao( k ) = rrca( 12398.54/lamk(k) + chik(k),
     >                     dio(k) + chij(kj(k)), lo(k), iz + 0 )
C ***                                                   ^^^^
C ***                               something strange is going on here
C ***                               VMS gives ACCESS VIO in RRCA for
C ***                               certain input without the + 0.
C ***                               Goes away with /noop.  Bounds check ok
              drrca( k ) = abs( rrcao(k) ) - abs( rrcau(k) )
           end if
        
           drrca( k ) = abs( drrca(k) )*xp( dlogc6 )
           c6lg( k ) = 32.3867 - log10( drrca(k) )
           if( rad(k) .lt. -0.001 ) 
     >                         rad( k ) = 2.22e7/lamk(k)/lamk(k)
           rad( k ) = rad( k )*xp( dloggr )
        else if( lprof(k) .eq. PVCS ) then
        
	   w = -12.053 + 8. - 16. + 2.*log_lam + gflg( k )        
!	       pi e^2/(m c^2)  pr[A] lam[A]
!	   w = w + 8. - 16. + 2.*log_lam + log_lam
!                  ------------------------
!                   dlam -> dnue (profile)
           c4lg( k ) = c4lg( k ) - dlogc4
           rad( k ) = rad( k )*xp( dloggr )
	else if( lprof(k) .eq. PHY ) then
           nl = drrca( k )
           nu = c4lg( k )
           w = w + 2.4054 + 2.*log10( nl )
           rrcau( k ) = 0.
           rrcao( k ) = 0.
           drrca( k ) = 0.
           anm = 0.06479*( nu**3/nl/nl + nl**3/nu/nu )/
     >           sqrt( nu*nu - nl*nl )
	else if( lprof(k) .eq. PHOP ) then
	   continue
        else if( lprof(k) .eq. PHEBCSS .or.
     >           lprof(k) .eq. PHEGRIEM .or.
     >           lprof(k) .eq. PHEBWB ) then
           w = -12.053 + 8. - 16. + 2.*log_lam + gflg( k )        
!           pi e^2/(m c^2)  pr[A] lam[A]
!             w = w + 8. - 16. + 2.*log_lam + log_lam
!                     ------------------------
!                      dlam -> dnue (profile)
*           c4lg( k ) = c4lg( k ) - dlogc4
*           rad( k ) = rad( k )*xp( dloggr )
        else if( lprof(k) .eq. PVCSSB ) then
        
	   w = -12.053 + 8. - 16. + 2.*log_lam + gflg( k )        
!	       pi e^2/(m c^2)  pr[A] lam[A]
!	   w = w + 8. - 16. + 2.*log_lam + log_lam
!                  ------------------------
!                   dlam -> dnue (profile)
           c4lg( k ) = c4lg( k ) - dlogc4
           rad( k ) = rad( k )*xp( dloggr )
        else
	   write( stdout, * ) 'LINLTE>> GAM: don''t know ',
     >                        'what to do with profile type ',
     >                        lprof(k), ' line #', k
        end if
        

        do n = 1, nma
           th = theta( n )
           z = 1. - xp( -12398.54/lamk(k)*th )
           eta0( n, k ) = xp( w + zetaj(n, kj(k)) - chik(k)*th )*
     >                    z/roptot( n )
	   if( lprof(k) .eq. PVOIGT ) then
              eta0( n, k ) = eta0( n, k )/vdop( n, kj(k) )
        
              if( cowley ) then
                 x = x1*xp( pelg(n) )*th
              else if( c4lg(k) .lt. -dlogc4 ) then
                 x = 0.
              else
                 x = xp( -2.*c4lg(k)/3. + eldplg(n) )
              end if
        
              alpha( n, k ) = ( x + rad(k) +
     >                        xp(-0.4*c6lg(k) + vdwlg(n)) )*
     >                        lamk(k)/37.673e10/vdop( n, kj(k) )
           else if( lprof(k) .eq. PVCS ) then
!              eta0( n, k ) = eta0( n, k )/vdop( n, kj(k) ) 
              eta0( n, k ) = eta0( n, k )
        
              if( c4lg(k) .le. -1. - dlogc4 ) then
                 x = 0.
              else
                 x = xp( -c4lg(k) + phlg(n) +
     >                   13.3816 + !log(16*pi/3/k_boltz/5040)
     >                   (-8.)     ! 1/sec --> 10^8/sec
     >                 )*th
              end if
        
              alpha( n, k ) = x + rad(k)  ! gamma_reson + gamma_rad
	      alpha( n, k ) = alpha( n, k )/4./3.1415926/
     >                        2.997925e18*1.e8*
     >                        lamk( k )*lamk( k )
        
	   else if( lprof(k) .eq. PHY ) then
              eta0( n, k ) = eta0( n, k )*th*xp( pelg(n) )
              alpha( n, k ) = anm*sqrt( th )*
     >                        ( 4.1007 - pelg(n)/2. -
     >                          2.*log10(c4lg(k)) - 
     >                          1.5*log10(th) )
	   else if( lprof(k) .eq. PHOP ) then
	      continue
           else if( lprof(k) .eq. PHEBCSS .or.
     >              lprof(k) .eq. PHEGRIEM .or.
     >              lprof(k) .eq. PHEBWB ) then
              eta0( n, k ) = eta0( n, k )
              alpha( n, k ) = 99.     ! dummy, not used anywhere
           else if( lprof(k) .eq. PVCSSB ) then
              eta0( n, k ) = eta0( n, k )
              alpha( n, k ) = 99.     ! dummy, not used anywhere
        
           else
              write( stdout, * ) 'LINLTE>> Kapgam (3): don''t ',
     >                           'know what to do with profile ',
     >                           'type ', lprof(k), ' line #', k
           end if
        
        end do	! n = 1, nma
        
        end
