	function h_vnm( i, j )
C ***
C ******************************************************************************
C ***
C ***	Compute frequency of Hydrogen transition i -> j.
C ***
C ***	i	I  >	principal quantum number of lower state
C ***   j	I  >	principal quantum number of upper state
C ***
C ***	Modifications:
C ***
C ***	 15-JUN-1994 16:53:12.00		ML / IoA Cambridge.  Created.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer i, j
	real h_vnm

C ***
C ***	Local variables
C ***
	real ryd
	parameter( ryd = 3.28808691e15 )	! tweaked to give correct
						! wavelength in h_data

C ***
C ***	Code
C ***
	h_vnm = ryd*(1./(i*i) - 1./(j*j))

	end
