	function hebcss( k )
C ***
C ******************************************************************************
C ***
C ***   Select He line for which BCSS theory available.  Return value:
C ***
C ***   k       > I  number of blend line
C ***   hebcss  < I  1: 4471 A
C ***                2: 4387 A
C ***                3: 4026 A
C ***                4: 4922 A
C ***               -1: other, i.e., no BCSS available, use Voigt function
C ***		    -2: not a He line
C ***
C ***	 5-APR-1995 16:34:00.00		ML / IoA.  Created.
C ***	30-APR-1997 15:32:06.52		ML / Bamberg.  DRRCA check added.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***   Arguments
C ***
	integer k
	integer hebcss

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'LINE.INC'
	include 'LINDAT.INC'

C ***
C ***	Code
C ***

	if( namk(k) .eq. 200 ) then
           if( abs(lamk(k) - 4471.) .lt. 1. ) then
              hebcss = 1
           else if( abs(lamk(k) - 4387.) .lt. 1 ) then
              hebcss = 2
           else if( abs(lamk(k) - 4026.) .lt. 1. ) then
              hebcss = 3
           else if( abs(lamk(k) - 4922.) .lt. 1. ) then
              hebcss = 4
           else
              hebcss = -1
           end if
	else
	   hebcss = -2
	end if

	end
