	function hegriem( k )
C ***
C ******************************************************************************
C ***
C ***   Select He line for which Griem theory available.
C ***
C ***   k       > I  number of blend line
C ***   hegriem < I  1: 4922 A 
C ***                2: 4713 A 
C ***                3: 4437 A 
C ***                4: 4388 A 
C ***                5: 4121 A 
C ***                6: 3964 A 
C ***                7: 3888 A 
C ***                8: 5875 A 
C ***                9: 6678 A AS 5875
C ***               10: 7065 A AS 5875
C ***               11: 5015 A 
C ***               12: 5048 A 
C ***               13: 2945 A 
C ***               14: 2829 A AS 2945
C ***               15: 4026 A (from BCSS.FOR)
C ***               16: 4471 A (from BCSS.FOR)
C ***               -1: other, i.e., no Griem data available
C ***		    -2: not a He line
C ***
C ***
C ***	30-APR-1997 17:08:35.11  	ML / Bamberg.  Created from Uli's stuff.
C ***	 5-MAY-1997 21:02:52.68		ML / Bamberg.  Fixed some missing lines.
C ***   28-OCT-1997 23:02:32.00         ML / Stegaurach.  Added 4026, 4471
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***   Arguments
C ***
	integer k
	integer hegriem

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'LINE.INC'
	include 'LINDAT.INC'

C ***
C ***	Code
C ***

	if( namk(k) .eq. 200 ) then
	   if( abs(lamk(k) - 4922.) .lt. 1. ) then
	      hegriem = 1   
	   else if( abs(lamk(k) - 4713.) .lt. 1. ) then
	      hegriem = 2   
	   else if( abs(lamk(k) - 4437.) .lt. 1. ) then
	      hegriem = 3   
	   else if( abs(lamk(k) - 4388.) .lt. 1. ) then
	      hegriem = 4   
	   else if( abs(lamk(k) - 4121.) .lt. 1. ) then
	      hegriem = 5   
	   else if( abs(lamk(k) - 3964.) .lt. 1. ) then
	      hegriem = 6
	   else if( abs(lamk(k) - 3888.) .lt. 1. ) then
	      hegriem = 7   
	   else if( abs(lamk(k) - 5875.) .lt. 1. ) then
	      hegriem = 8
	   else if( abs(lamk(k) - 6678.) .lt. 1. ) then
	      hegriem = 9   
	   else if( abs(lamk(k) - 7065.) .lt. 1. ) then
	      hegriem = 10  
	   else if( abs(lamk(k) - 5015.) .lt. 1. ) then
	      hegriem = 11  
	   else if( abs(lamk(k) - 5048.) .lt. 1. ) then
	      hegriem = 12  
	   else if( abs(lamk(k) - 2829.) .lt. 1. ) then
	      hegriem = 14  
	   else if( abs(lamk(k) - 4026.) .lt. 1. ) then
              hegriem = 15
	   else if( abs(lamk(k) - 4471.) .lt. 1. ) then
              hegriem = 16
           else
              hegriem = -1
           end if
	else
	   hegriem = -2
	end if

	end
