        subroutine kapgam( mode )
C ***
C ******************************************************************************
C ***
C ***	Modifications:
C ***
C ***	13-OCT-1994 18:32:37.00	ML / IoA.  Changed computation of W for
C ***			        VCS branch.
C ***	12-MAY-1995 15:11:08.00	ML / IoA.  Added one more neff2 to c4lg in
C ***				Cowley/Griem approximation.  Not critical,
C ***				used only in output.
C ***				Cowley gives T-independent gamma, which is X1
C ***	            		below, so it always used the correct value.
C ***
C ***                           Also changed c4fak to 4*c4fak as it should be
C ***				according to Cowley paper.  Don't know how I
C ***	                        got the other value.  This does change results.
C ***
C ***	 4-MAR-1997 20:41:14.49	ML / Bamberg.  He broadening copied from
C ***			        earlier experiments.
C ***   16-APR-1997 23:02:56.00 ML / Stegaurach.  Logic with c4lg and Cowley
C ***                           modified.  This could never have worked:
C ***                           c4lg(k) was modified first and later a test
C ***                           was made assuming an unmodified c4lg to set
C ***                           the actual broadeing gamma.
C ***                           Modified to use a logical variable.
C ***	30-APR-1997 16:42:46.63	ML / Bamberg.  Cleaned up He I stuff.
C ***	14-SEP-1997 17:48:25.00	ML / Stegaurach.  New lineprof stuff.
C ***	22-OCT-1997 15:17:11.44	ML / Bamberg.  He I Beauchamp et al.
C ***	31-OCT-1997 18:20:37.46	ML / Bamberg.  He II VCSSB.
C ***	13-MAR-1998 15:29:01.06	ML / Bamberg.  Small fix for lines above
C ***				ionization limit.  Can happen due to 
C ***				ionization potential lowering.
C ***	14-APR-1998 18:20:35.98	ML / Bamberg.  Moved boradening constants into
C ***				new subroutine GAM, which is called by READIN.
C ***                           This makes CALL KAPGAM(2) a noop.
C ***
C ******************************************************************************
C ***
	implicit none

C ***   Arguments
C ***
        integer mode

C ***
C ***   Global variables
C ***
	include 'LINLTE.INC'
        include 'IONS.INC'
        include 'STRUCT.INC'
        include 'PRES.INC'
        include 'TEFF.INC'
        include 'LINE.INC'
	include 'BROAD.INC'

C ***
C ***   Local variables
C ***

        integer j, n
        real w, x

	logical dd

        if( mode .eq. 1 ) then

C ***
C ***      Element dependent quantities
C ***

	   dd = .false.
           do j = 1, jma
              x = 83.808/wtj( j )
              do n = 1, nma
	         if( n .lt. nma ) then
	            if( xi(n) .ne. xi(n+1) ) then
                       dd = .true.
                    end if
                 end if
                 vdop( n, j ) = sqrt( xi(n)*xi(n) + x/theta(n) )/
     >                          299792.5
              end do
           end do
           w = 8.6724 + log10( 1. + he/2.4194 )
           do n = 1, nma
              x = log10( theta(n) )
              phlg( n ) = pglg( n ) + 0.3010 + zetaj( n, 1 )
              vdwlg( n ) = w + 0.7*x + phlg( n )
              eldplg( n ) = 7.76140961 + 0.83333333*x + pelg( n )
           end do
C ***
C ***	   for output later
C ***
	   if( dd ) xi( 1 ) = -1.
        end if
        end
