        SUBROUTINE LBLOVE(X,N,XLEFT,XRIGHT,DELTA,XC,NVAL,XL,XR)
C
C       COMPUTE NEW LABEL POSITIONS WITHOUT OVERLAPPING
C
C       INPUT ARGUMENTS
C       X       REAL*4  ORIGINAL POSITIONS
C       N       INTG*4  DIMENSION OF X
C       XLEFT   REAL*4  LEFT BOUNDARY
C       XRIGHT  REAL*4  RIGHT BOUNDARY
C       DELTA   REAL*4  SIZE OF LABEL
C       OUTPUT ARGUMENTS
C       XC      REAL*4  NEW POSITIONS
C       WORK SPACE
C       NVAL    INTG*4  -
C       XL, XR  REAL*4  -
C ***
C ***	 9-OCT-1997 11:56:03.43		ML / Bamberg.  Fixed array bound 
C ***					if N .eq. 1
C
        REAL*4          X(N), XC(N), XR(N), XL(N)
        INTEGER*4       NVAL(N)
        LOGICAL         IOVER
C
C ... assign initial values
C
        D2 = DELTA/2.
        DO I = 1, N
          XL(I)   = MAX(X(I)-D2, XLEFT)
          XR(I)   = MIN(X(I)+D2, XRIGHT)
          NVAL(I) = 1
          IF (XL(I) .EQ. XLEFT) XR(I) = XL(I) + DELTA
          IF (XR(I) .EQ. XRIGHT) XL(I) = XR(I) - DELTA
        ENDDO
C
C ... merge labels
C
        M     = N
10      CONTINUE
        IOVER = .FALSE.
        IF (M.EQ.1) GOTO 30
        I     = 2
20      CONTINUE
        IF (XR(I-1) .GT. XL(I)) THEN
          NVAL(I-1) = NVAL(I-1) + NVAL(I)
          L         = 0
          DO J = 1, M
            IF (J .NE. I) THEN
              J1 = J
              IF (J .GT. I) J1 = J1-1
              XAVE = 0.D0
              DO K = 1, NVAL(J)
                L    = L + 1
                XAVE = XAVE + X(L)
              ENDDO
              XAVE = XAVE/FLOAT(NVAL(J))
              D    = DELTA*FLOAT(NVAL(J))
              XL(J1)   = MAX(XAVE - D/2., XLEFT)
              XR(J1)   = MIN(XAVE + D/2., XRIGHT)
              NVAL(J1) = NVAL(J)
              IF (XL(J1) .EQ. XLEFT)  XR(J1) = XL(J1) + D
              IF (XR(J1) .EQ. XRIGHT) XL(J1) = XR(J1) - D
            ENDIF
          ENDDO
          M = M - 1
          IOVER = .TRUE.
        ENDIF
        I = I + 1
        IF (M.EQ.1) GOTO 30
        IF (I.LE.M) GOTO 20
        IF (IOVER)  GOTO 10
C
C ... assign final values
C
30      L = 0
        DO I = 1, M
          DO J = 1, NVAL(I)
            L     = L + 1
            XC(L) = XL(I) + (J-1)*DELTA+D2
          ENDDO
        ENDDO
        RETURN
        END
