C ****************************************************************************
C ***
C ***	LINLTE.INC
C ***
C	Parameterfile fuer LINLTE.FOR
C
C	Date:  7-OCT-1994 17:04:06.00 CET
C
C	NKMA    = Anzahl der Linien bei Synthese
C	IPKT    = Anzahl Punkte bei Synthese
C	NOBS	= Anzahl Punkte in Beobachtung
C	IDEL    = Anzahl der Kontinuumspunkte, max. Syntheseintervall in Angs.
C	NIONS   = Anzahl gleichzeitig analysierbarer Elemente, Ion'stufen...
C	NOPCON  = Anzahl der Opazitaeten in ATM.DAT
C	NDEPTH  = Anzahl der Tiefenpunkte in der Atmosphaere
C	NDEP    = Anzahl der NLTE-Niveaus
C	NELEM   = Anzahl Elemente in ATM.DAT
C	LAB_SIZ = Laenge der Levelbezeichnungen
C       NFIT    = Number of items to fit from spectrum
C
C       MX      = Some number derived from NOBS as
C                 mx = 2**int(log(real(nobs))/log(2.) + 1) )
C		  
C
C	STDOUT = Kanalnummer fuer Terminaloutput
C
	INTEGER NKMA, IPKT, IDEL, NIONS, NOPCON, NDEPTH, NDEP, LAB_SIZ
	INTEGER NELEM, NFIT, NOBS, MX
	PARAMETER( NKMA = 150000 )	! number of lines in synthesis
	PARAMETER( IPKT = 80010 )	! number of wavelength point in synth.
!	PARAMETER( NOBS = 200050 )      ! number of points in observation
	PARAMETER( NOBS = 20005 )      ! number of points in observation

!        PARAMETER( mx = 2**int(log(real(nobs))/log(2.) + 1) ) ! some Fortrans
        PARAMETER( mx = 65536/2 )                          ! take the expression
	
	
	PARAMETER( IDEL = 3500 )    ! # of continuum points, synth interval in 
	PARAMETER( NIONS = 120 )	! max number of ions in analysis
	PARAMETER( NOPCON = 1212 )	! number of opacities in ATM.DAT
	PARAMETER( NDEPTH = 50 )	! number of depth points
	PARAMETER( NDEP = 100 )		! number of NLTE levels
	PARAMETER( NELEM = 45 )		! number of elements in ATM.DAT
	PARAMETER( LAB_SIZ = 4 )	! number of chars in label of NLTE level
	PARAMETER( NFIT = 8 )		! number of items to fit from spectrum
C
	INTEGER STDOUT
	PARAMETER( STDOUT = 6 )
C
	CHARACTER*(*) DIMDAT
	PARAMETER( DIMDAT = ' 14-JUN-2004 01:22:33.55 CEST' )
