C	
************************************************************************
      SUBROUTINE LOCATE (XX, N, X, J)
C
      IMPLICIT NONE
      INTEGER N, J
      REAL XX(N), X
C
C-----------------------------------------------------------------------
C     Determines the element of XX, which corresponds to X. A simple 
C     bisection algorithm with a twist to defeat insidious roundoff error 
C     problem is used
C
C     Called by: 
C     CONTINUUM, FORK, ENDPOINTS, SHIFT, SPLINTGH
C-----------------------------------------------------------------------
C     Parameters:
C     XX:	Array
C     N:	Dimension of XX
C     X:	Argument
C     J:	Element of XX corresponding to X
C-----------------------------------------------------------------------
      INTEGER JL, JU, JM

      JL = 0
      JU = N+1
C
10    IF (JU-JL.GT.1) THEN
        JM = (JU +JL) /2
        IF (XX(N).GT.XX(1) .EQV. X.GT.XX(JM)) THEN     
          JL = JM
        ELSE
          JU = JM
        END IF
      GOTO 10
      ENDIF
C
      J = MAX (JL,1)        ! J = 1,.....,N-1
      J = MIN (J,N-1)
C
      END
