	subroutine newmicro( value )
C ***
C ******************************************************************************
C ***
C ***	Updates VDOP, ETA0, ALPHA for new microturbulence and abundances.
C ***	Sets OPINIT to .TRUE..
C ***
C ***	23-JUN-1992 17:41:08.73
C ***	 6-JUL-1995 15:03:35.00		ML / IoA.  Corrected for VCS and BCCS
C ***					lines, they don't have v_D in ETA0
C ***	30-APR-1997 16:44:23.67		ML / Bamberg.  HEBCSS -> HE1
C ***	14-SEP-1997 17:48:25.00		ML / Stegaurach.  New lineprof stuff.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	real value(*)

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'LINE.INC'
	include 'STRUCT.INC'
	include 'PRES.INC'
	include 'IONS.INC'
	include 'CALCUL.INC'
	include 'LINDAT.INC'

C ***
C ***	Local variables
C ***
	integer j, k, m, n
	real diff( nfit ), exp_diff( nfit ), di, edi, vd, x

C ***
C ***	Functions
C ***
	external deleta
	intrinsic sqrt


        opinit = .true.
        
	do m = 1, mfit
           if( fit_item(m) .eq. 55 ) then
              xi(1) = value( m )
              go to 1

	   end if

	end do
1	continue

        call deleta( value, diff, exp_diff )

        do k = 1, kma
           edi = 1.
           di = 0.
           do m = 1, mfit
              if( namk(k) .eq. fit_item(m) ) then
                 edi = exp_diff( m )
                 di = diff( m )
                 go to 2
           
              end if
           
           end do
           
2          continue
           do n = 1, nma
	      if( lprof(k) .ne. PVOIGT ) then
	         vd = 1.
	      else
                 vd = vdop( n, kj(k) )
	      end if
              alpha( n, k )  = alpha( n, k )*vd
              eta0( n, k ) = eta0( n, k )*vd*edi
	   end do
           gflg( k ) = gflg( k ) + di
        end do
        
        do j = 1, jma
           x = 83.808/wtj( j )
           do n = 1, nma
              vdop( n, j ) = sqrt( xi(1)*xi(1) +
     >                       x/theta(n) )/299792.5
           end do
        end do
        
	do n = 1, nma
           do k = 1, kma
	      if( lprof(k) .ne. PHY ) then
                 alpha( n, k )  = alpha( n, k )/vdop( n, kj(k) )
                 eta0( n, k ) = eta0( n, k )/vdop( n, kj(k) )
	      end if
           end do
        end do
        
	end
