	subroutine page( headlines, datalines, reqtit )
	implicit none
C ***
C ******************************************************************************
C ***
C ***	Determines if new page is to start
C ***
C ***	HEADLINES    >  (INTEGER)  number of lines in table header
C ***	DATALINES    >  (INTEGER)  minimum number of data lines to fit on page
C ***                              after header
C ***	REQTIT       >  (INTEGER)  id number of requested table header
C ***
C ***	Common Blocks:
C ***
C ***	using from /PRINT/ :
C ***   IP	    ><  (INTEGER)  page counter; set to 0 if new page started
C ***	CURTIT	    ><  (INTEGER)  current title; set to -1 if new page
C ***   MAXLINES     <  (INTEGER)  maximum number of lines per page
C ***
C ***	12-SEP-1992 06:13:32.22		ML / UT Austin
C ***
C ******************************************************************************
C ***

C ***
C ***	Arguments
C ***
	integer headlines, datalines, reqtit

C ***
C ***	Parameters
C ***
	integer LINES_PER_PAGE          	! per page
	integer PAGE_HEADER_LINES		! lines in page header
	parameter( PAGE_HEADER_LINES = 2, LINES_PER_PAGE = 60 )

C ***
C ***	Global variables
C ***
	include 'PRINT.INC'

C ***
C ***	Local variables
C ***
	character*132 zeile, form*4
	integer room, page_num, l, ohd
	save page_num
	data page_num /1/

	maxlines = LINES_PER_PAGE - PAGE_HEADER_LINES

	if( reqtit .eq. curtit ) then
	   room = ip + datalines
	else
	   room = ip + datalines + headlines
	end if
	if( room .gt. maxlines ) then
*	   ohd = len('LINFIT ') + len(' ') + len(date) + len(' ') + len('Page ')
*                       7             1         19          1             5
*          ohd = 33
	   L = int( log10( float(page_num) ) ) + 1  ! must not be greater than 3
	   ohd = 33 + L
	   zeile = 'LINFIT '
	   zeile( 7 + (132 - ohd - ihead)/2 + 1: ) = head(:ihead)
	   zeile( 132 - 19 - 1 - 1 - 5 - L + 1: ) = ' ' // date // ' '
     >                                              // 'Page '
	   write( form, '( ''(I'', i1, '')'' )' ) l
	   write( zeile(132-l+1:), form ) page_num

	   if( page_num .eq. 1 ) then
	      write( 3, '('' '', a, /)' ) zeile
	   else
	      write( 3, '(''1'', a, /)' ) zeile
	   end if
           curtit = -1
           ip = 0

	   page_num = page_num + 1
	end if

	end
