        function pol( x, a, b, mi, ma, l, extra )
	implicit none
C ***
C ******************************************************************************
C ***
C ***	Modifications:
C ***
C ***	20-FEB-1998 18:33:21.83		ML / Bamberg.  Moved some if blocks to
C ***					avoid accessing unvailable memory for
C ***					single point interpolations.
C ***
C ******************************************************************************
C ***

C ***
C ***	Arguments
C ***
	integer mi, ma, l
        real x, a( ma ), b( ma )
	logical extra

	real pol

C ***
C ***	Local variables
C ***
	integer ii, k
	real u, v, w, y, z
	save ii

        data ii /0/

	extra = ( x - a(mi) )*( x - a(ma) ) .gt. 0.
	if( ma .eq. mi ) then
C ***
C ***	   single point only
C ***
	   pol = b( ma )
        else
           if( (ii .le. mi) .or. (ii .ge. ma) ) ii = ( mi + ma )/2
           if( abs( x - a(ii) ) .le. abs( x - a(ii + 1) ) ) then
              do 1 k = ii, mi, -1
                 ii = k
                 if( ( x - a(k) )*( x - a(k + 1) ) .le. 0 ) go to 3
1            continue
           
           else
              do 2 k = ii + 1, ma, 1
                 ii = k - 1
                 if( ( x - a(k) )*( x - a(k - 1) ) .le. 0 ) go to 3
2             continue
           end if
           
3          continue
           
           if( (ma - mi .eq. 1) .or. extra .or. (l .eq. 1) ) then
              pol = b(ii) + ( b(ii + 1) - b(ii) )*( x - a(ii) )/
     >              ( a(ii + 1) - a(ii) )
           
           else
              if( ii .eq. ma - 1 ) ii = ii - 1
              u = x - a( ii )
              v = x - a( ii + 1 )
              w = x - a( ii + 2 )
              y = ( b(ii) - b(ii + 1) )/( v - u )
              z = ( b(ii + 1) - b(ii + 2) )/( w - v )
              if( y*z .le. 0. .and. (y .ne. 0. .or. z .ne. 0.) ) then
                 pol = b(ii) + u*( y + v*(y - z)/(w - u) )
           
              else if( b(ii) .eq. b(ii + 2) ) then
                 pol = b(ii)
           
              else
                 pol = b(ii) + u*y/( 1 - v*(y - z)/(b(ii) - b(ii + 2)) )
              end if
           
           end if
	end if

        end
