	function profvcs( dlam, depth, k )
C ***
C ******************************************************************************
C ***
C ***	Returns Hydrogen profile from convolution of VCS profile with Voigt
C ***	function.
C ***
C ***	dlam	>  R	distance from line center []
C ***	depth	>  I	depth point of interest
C ***	k  	>  I	number of blend line
C ***
C ***	Modifications:
C ***
C ***	 8-JUN-1994 15:14:56.00		ML / IoA Cambridge.  Created.
C ***	23-AUG-1994 12:31:59.00		ML / IoA.  Cleaned up.  Not tested!
C ***	13-JUN-1997 16:20:53.57		ML / Bamberg.  Exclude central part
C ***					from fudge convolution.
C ***   18-AUG-1997 15:17:21.12         ML / Bamberg.  Take out call to qagi
C ***                                   for stupid Fujitsu.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
        integer depth, k
	real dlam, profvcs

C ***
C ***	Global variables
C ***
        include 'LINLTE.INC'
	include 'STRUCT.INC'
	include 'PRES.INC'
	include 'LINE.INC'
	include 'LINDAT.INC'

	integer kk, ddepth
	real ddlam, gam2
	common /vcs_par/ kk, ddepth, ddlam, gam2


C ***
C ***	Local variables
C ***
	integer limit, lenw
	parameter( limit = 30, lenw=4*limit )

	real work( lenw )
	integer iwork( lenw )

	integer ier, last, cost
	real abserr


	real kboltz, c_light, pi
	parameter( kboltz = 1.38062e-16, c_light = 2.997925e18,
     >             pi = 3.14159265358979323846264 )

	real temp, ne, x, y, gam

C ***
C ***	Functions
C ***
        real vcs, exp10
	real vcscon
	external vcscon

	exp10( x ) = exp( 2.302585093*x )

C ***
C ***	Code
C ***

	temp = 5040./theta( depth )
	ne = exp10( pelg(depth) )*theta(depth)/5040./kboltz

	if( c4lg(k) .le. -1. - dlogc4 .and. rad(k) .eq. 0. ) then
C ***
C ***	   Ignore both resonance and radiative damping -> Doppler profile only
C ***
           profvcs = vcs( dlam, temp, ne, k )
	else
C ***
C ***	   Convolve with Lorentz profile
C ***
	   gam = alpha( depth, k )
           if( lo(k) .eq. -1 ) then
C ***
C ***         do quick and dirty fudge "convolution" by adding Lorentz
C ***         profile like in Kurucz's Balmer program
C ***         (don't know why it works)
C ***
              profvcs = vcs( dlam, temp, ne, k )
	      if( abs(dlam) .gt. 0.2 )
     >              profvcs = profvcs + gam/pi/( dlam*dlam + gam*gam )
           else
C ***
C ***         do convolution with qags
C ***
	      gam2 = gam*gam
	      ddlam = dlam
	      kk = k
	      ddepth = depth

              y = gam

              write( stdout, * ) 'PROFVCS>>  Full convolution '//
     >                           'not implemented in this version.'
              call exit
!	      call qagi( vcscon, -5000.*y, 2, 1e-4, 1e-4, profvcs,
!     >                   abserr, cost, ier, limit, lenw, last, iwork,
!     >                   work )

!	      profvcs = profvcs*gam/pi

	   end if
	end if

	end
 
	function vcscon( ds )
	implicit none

	real ds, vcscon

C ***
C ***	Global variables
C ***
        include 'LINLTE.INC'
	include 'STRUCT.INC'
	include 'PRES.INC'

	integer k, depth
	real dlam, gam2
	common /vcs_par/ k, depth, dlam, gam2


C ***
C ***	Local variables
C ***
	real kboltz
	parameter( kboltz = 1.38062e-16 )

	real temp, ne, x

C ***
C ***	Functions
C ***
        real vcs, exp10

	exp10( x ) = exp( 2.302585093*x )

C ***
C ***	Code
C ***

	temp = 5040./theta( depth )
	ne = exp10( pelg(depth) )*theta(depth)/5040./kboltz
                 
        vcscon = vcs(dlam + ds, temp, ne, k)/
     >              ( ds*ds + gam2 )

	end                                   
                  
