	function profvcssb( dlam, depth, k )
C ***
C ******************************************************************************
C ***
C ***	Returns Helium II profile from VCSSB tables.
C ***
C ***	dlam	>  R	distance from line center []
C ***	depth	>  I	depth point of interest
C ***	k  	>  I	number of blend line
C ***
C ***	Modifications:
C ***
C ***	31-OCT-1997 18:08:10.19		ML / Bamberg.  Made.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
        integer depth, k
	real dlam, profvcssb

C ***
C ***	Global variables
C ***
        include 'LINLTE.INC'
	include 'STRUCT.INC'
	include 'PRES.INC'

C ***
C ***	Local variables
C ***
	real kboltz, c_light, pi
	parameter( kboltz = 1.38062e-16, c_light = 2.997925e18,
     >             pi = 3.14159265358979323846264 )

	real temp, ne, x

C ***
C ***	Functions
C ***
        real vcssb, exp10

	exp10( x ) = exp( 2.302585093*x )

C ***
C ***	Code
C ***

	temp = 5040./theta( depth )
	ne = exp10( pelg(depth) )*theta(depth)/5040./kboltz

        profvcssb = vcssb( dlam, temp, ne, k )

	end
