        subroutine putout( mode )
C ***
C ******************************************************************************
C ***
C ***
C ***	24-NOV-1994 22:41:51.00		ML / IoA.  Found minor bug.  See Kse.
C ***	21-FEB-1995 19:18:27.00		ML / IoA.  Pagination of particle
C ***					concentration was wrong.
C ***	28-FEB-1995 17:03:40.00		ML / IoA.  Print more decimal places
C ***					in wavelength of continuum output, get
C ***                                   rid of (I or F) in same output
C ***	20-MAR-1995 16:36:02.00		ML / IoA.  Don't modify lascan(1).
C ***                                   Set kcontr=-1 in depth dep. output---
C ***                                   contrl gets overwritten
C ***	21-MAR-1995 19:09:57.00		ML / IoA.  Changed more with depth dep.
C ***                                   output.  Strange logic in putout(4).
C ***	24-JUL-1996 21:31:43.61		ML / Bamberg.  RV output.
C ***	 5-MAY-1997 21:57:47.75		ML / Bamberg.  Fixed division by zero
C ***                                   in synthesis output for lines outside
C ***                                   synthesis interval.
C ***	13-JUN-1997 18:15:15.75		ML / Bamberg.  Set WCAL = -1 for
C ***					important lines in synthesis.
C ***   15-AUG-1997 17:33:22.00		ML / Bamberg.  lib$get_foreign ->
C ***					lib_get_foreign to make it more
C ***					portable (no omitted arguments!).
C ***	 9-OCT 1997 12:06:42.12		ML / Bamberg.  `Minor' bug of
C ***					24-NOV-1994 22:41:51.00 causes accvio
C ***					under certain dimensioning.  Fixed.
C ***					No more `Kse'.
C ***	11-FEB-1998 18:53:11.38		ML / Bamberg.  RC output of synthesis
C ***					was depth, should be flux.
C ***    1-DEC-2003 23:27:00.00         ML / Stegaurach.  Output of fit errors.
C ***    4-DEC-2003 20:08:17.00         ML / Stegaurach.  More fit error output.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer mode

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'ELEM.INC'
	include 'IONS.INC'
	include 'OPCON.INC'
	include 'STRUCT.INC'
      	include 'PRES.INC'
      	include 'TEFF.INC'
      	include 'IF.INC'
      	include 'FLUSS.INC'
      	include 'FCON.INC'
	include 'DEPTH.INC'
      	include 'LINDAT.INC'
      	include 'LINE.INC'
      	include 'PROFIL.INC'
      	include 'CALCUL.INC'
	include 'NLTE.INC'
	include 'PRINT.INC'
	include 'OBS.INC'
	include 'FIT.INC'

C ***
C ***	Functions
C ***
	integer idx
	real dep, flux, pol

C ***
C ***	Local variables
C ***
	logical extra

        character adv, zeile*132, i_or_f
	integer i, j, k, l, iz, n, n0, n1, nma1
	integer headlines, datalines, reqtit
	real diff, f, flg, l1, tstr, w, y, xwcal, xmin, xmax

	data ip /0/

        tstr( w, f ) = 1.4388e8/w/log( 1. + 1.191e35/w**5/f )


        if( mode .eq. 1 ) then
C ***
C ***      Output  model
C ***
	   zeile = ' ATM-FEINANALYSE UND SPEKTRUM-SYNTHESE KIEL'

	   call datum( date )
	   call lib_get_foreign( head, ihead )
	   ihead = min( ihead, len(head) ) 	! lib$get_foreign broken
	   if( ihead .eq. 0 ) then
	      head = zeile
	      ihead = idx( head )
	   end if


	   ip = 9999
	   headlines = 3
	   datalines = 0
	   reqtit = 1
	   call page( headlines, datalines, reqtit )	


           write( 3, '(2a, //, '' Calculated on '', A, '' at '', A)' ) 
     >	     zeile(:idx(zeile)), '   Revision: 14-SEP-1997 20:54:59.00',
     >       date( :9 ), date( 11:19 )
           curtit = reqtit
	   ip = 3

           if( ifatm .ne. 0 ) then

              write( 3, '(//,'' Element abundances used for '',
     >	                  ''calculating concentrations'', //, 2X, I2, /,
     >	                  ( 1X, 9(I6, F6.2) ) )' )
     >	                           ima, ( nami(i), abui(i), i = 1, ima )
	      ip = ip + 5 + ima/9 + 1

	      reqtit = reqtit + 1
              datalines = 1
              headlines = 12
              call page( headlines, datalines, reqtit )
              write( 3, '( //, 
     >	        '' Particle'', /,
     >	        '' Ionization potential used for square radius'', /, 
     >	        '' Atomic or molecular weight'', /,
     >	        '' Particle concentration in ground state per '',
     >	                                                ''nucleus'',
     >	         // )' )
              ip = ip + 8
              curtit = reqtit

	      reqtit = reqtit + 1
              datalines = 1
              headlines = 6
              do 2 n0 = 1, jma, 14
                 n1 = min( jma, n0 + 13 )
                 do 1 n = 1, nma
                    call page( headlines, datalines, reqtit )
                    if( curtit .ne. reqtit ) then
                       if( curtit .ne. -1 ) then	! same page
                          write( 3, '(/)' )
                          ip = ip + 2
                       end if
                       write( 3, '(4x, 14i9)' )  ( namj(j), j = n0, n1 )
                       write( 3, '(4x, 14f9.3)' )( chij(j), j = n0, n1 )
                       write( 3, '(4x, 14f9.3)' ) ( wtj(j), j = n0, n1 )
                       write( 3, '(1x)' )
                       ip = ip + 4
                       curtit = reqtit
                    end if
                    write( 3, '(x, i3, 14f9.3)' ) n,
     >	                                     ( zetaj(n, j), j = n0, n1 )
	            ip = ip + 1
1                continue
                 reqtit = reqtit + 1
2             continue
              nma1 = nma
	   else
              nma1 = 1
           end if


C ***
C ***	   figure out if atmosphere table will fit completely on single page
C ***
	   i = 3 + 2 + nma1
	   if( ifatm .ne. 0 .and. rsu .lt. 0. ) i = i + 2
	   if( i .le. maxlines ) then
	      datalines = nma1
	      headlines = 5
	   else
              datalines = 1
	      headlines = 5 + 3
	   end if
	   reqtit = reqtit + 1
	   call page( headlines, datalines, reqtit )
           if( curtit .ne. reqtit ) then
	      if( ip .ne. 0 ) then
	         write( 3, '(''0'', /)' )
                 ip = ip + 3
              end if

              write( 3, '( 1x, a, f7.0, 4x, a, f7.2, 4x, a, f5.3, 4x, a,
     >	                   f7.2, a, 1p, e11.3, a, //)' ) 'Teff =', teff, 
     >	            'log g =', glog, 'He/H =', he, 'R/R(sun) =', rsu, 
     >	             '   (', r(1)*1e-5, ' km)'	
              ip = ip + 3                               ! 3 lines
              curtit = reqtit
	   end if

           if( ifatm .ne. 0 .and. rsu .lt. 0. ) then
              write( 3, '(a,/)' ) ' assuming constant log g'
              ip = ip + 2
           end if

           do 3 n = nma, 1, -1
              r( n ) = r( n )/r( 1 )
3          continue

           headlines = 2
	   datalines = 1
	   reqtit = reqtit + 1
	   do n = 1, nma1
	      call page( headlines, datalines, reqtit )
	      if( curtit .ne. reqtit ) then
                 write( 3, '(5x, ''tau('', i5, '' ) lg tau   '',
     >                ''theta   temp    lg pe   lg pg  micro  lg kref'',
     >                ''    R/R*'', /)' ) int(reflam)
                 ip = ip + 2
                 curtit = reqtit
	      end if
	      write( 3, '(x, i3, 0p, f11.7, f8.3, f8.4, f8.0, f8.3,
     >             f8.3, f7.2, f9.3, f9.4, i4) )' )
     >	           n, rtau(n), log10(max(1.e-36, rtau(n))),
     >            theta(n), 5040./theta(n), pelg(n), pglg(n), xi(n),
     >            log10(roptot(n)), r(n), n
	      ip = ip + 1
	   end do

           if( ifatm .ne. 0 ) then
              datalines = 1
	      headlines = 3 + 4
              do 5 n0 = 1, lma, 14
                 n1 = min( lma, n0 + 13 )
                 reqtit = reqtit + 1
                 call page( headlines, datalines, reqtit )
                 if( curtit .ne. reqtit ) then
                    if( ip .ne. 0 ) then
                       write( 3, '(//)' )
                       ip = ip + 3
                    end if
                    write( 3, '(a, //, 6x, 14f9.1)' )
     >                ' lg kappa cont', ( olam(l), l = n0, n1 )
                    write( 3, '()' )
                    ip = ip + 4
                    curtit = reqtit
                 end if
                 do 4 n = 1, nma
                    call page( headlines, datalines, reqtit )
                    if( curtit .ne. reqtit ) then
                       if( ip .ne. 0 ) then
                          write( 3, '(//)' )
                          ip = ip + 3
                       end if
                       write( 3, '(a, //, 6x, 14f9.1)' )
     >                   ' lg kappa cont', ( olam(l), l = n0, n1 )
                       write( 3, '()' )
                       ip = ip + 4
                       curtit = reqtit
                    end if

                    write( 3, '(x, i5, 14f9.3)' ) n,
     >	                                     ( alkl(n, l), l = n0, n1 )
	            ip = ip + 1
4                continue
5             continue
              datalines = 1
	      headlines = 3 + 4
              do 7 n0 = 1, lma, 14
                 n1 = min( lma, n0 + 13 )
                 reqtit = reqtit + 1
                 call page( headlines, datalines, reqtit )
                 if( curtit .ne. reqtit ) then
                    if( ip .ne. 0 ) then
                       write( 3, '(//)' )
                       ip = ip + 3
                    end if
                    write( 3, '(a, //, 6x, 14f9.1)' )
     >                ' lg sigma cont', ( olam(l), l = n0, n1 )
                    write( 3, '()' )
                    ip = ip + 4
                    curtit = reqtit
                 end if
                 do 6 n = 1, nma
                    call page( headlines, datalines, reqtit )
                    if( curtit .ne. reqtit ) then
                       if( ip .ne. 0 ) then
                          write( 3, '(//)' )
                          ip = ip + 3
                       end if
                       write( 3, '(a, //, 6x, 14f9.1)' )
     >                   ' lg sigma cont', ( olam(l), l = n0, n1 )
                       write( 3, '()' )
                       ip = ip + 4
                       curtit = reqtit
                    end if

                    write( 3, '(x, i5, 14f9.3)' ) n,
     >                                       ( alsl(n, l), l = n0, n1 )
	            ip = ip + 1
6                continue
7             continue
           end if

        else if( mode .eq. 2 ) then
C ***
C ***      Output continuum
C ***
	   reqtit = 8
           headlines = 3 + 0
	   datalines = 1
	   if( kcontr .ge. 0 ) then
C ***
C ***         keep `continuum: ...' and first three lines of depth dependent
C ***	      output on same page
C ***
	      headlines = headlines + 3
              datalines = datalines + 3
           end if
	   call page( headlines, datalines, reqtit )
	   if( curtit .ne. reqtit ) then
	      if( ip .ne. 0 ) then
	         write( 3, '(//)' )
	         ip = ip + 3
	      end if
	      curtit = reqtit
           end if
           if( costhe .ge. 0. ) then
              write( 3, '( ''    continuum'', 0p, f11.3, 
     >	                   '' A    cos theta ='', f6.2, 
     >	                   ''   IFSCAT ='', I3, ''   IFSPHA ='', I3, 
     >	                   ''   I lambda ='', 1p, e10.3,
     >	                   ''   lg (I lambda) ='', 0p, f7.3 )' )
     >           mlam, costhe, ifscat, ifspha, fclam, log10( fclam )
           else
              write( 3, '( ''    continuum'', 0p, f11.3, 
     >	                   '' A    IFSCAT ='', I3,
     >                     ''   IFSPHA ='', I3, 
     >	                   ''   F lambda ='', 1p, e10.3,
     >	                   ''   lg (F lambda) ='', 0p, f7.3 )' )
     >           mlam, ifscat, ifspha, fclam, log10( fclam )
           end if
           ip = ip + 1
           if( kcontr .ge. 0 ) then
C ***
C ***         Output continuum depth dependent quantities
C ***
	      reqtit = 9
	      headlines = 3
	      datalines = 3
	      call page( headlines, datalines, reqtit )
	      if( curtit .ne. reqtit ) then
                 write( 3, '( ''0    tau('', i5, '' ) lg tau  '',
     >             ''l tauc  temp   l etac l betac    slam'', 8x,
     >             ''blam'', 5x, ''cont'', 2x, ''Profile:  LASCAN  '',
     >             ''RSCAN  rad temp  F*(1-RSCAN)'', / )' ) int(reflam)
                 ip = ip + 3
                 curtit = reqtit
	      end if
              rscan( 1 ) = blam( ntmin )/fclam
              mma = 1	! why???

              n = 1
	      write( 3, '(1x, i3, 0p, f11.7, 16x, f7.0, f7.2, f8.2, 1p,
     >          e12.3, e12.3, 20x, ''rmax'', 0p, f7.3, f8.0, 1p, e13.3
     >          )' )
     >	        n, rtau( n ),
     >          5040./theta( n ), log10( etac(n) ), log10( beta(n) ),
     >          slam( n ), blam( n ), 1. - rscan( n ),
     >          tstr( mlam, rscan(1)*fclam ), rscan(1)*fclam
	      ip = ip + 1
                                    
	      n = 2
              write( 3, '(x, i3, 0p, f11.7, 2f8.3, f7.0, f7.2, f8.2,
     >	                  1p, 2e12.3, 0p, f6.1, t98, ''cont'', f7.3, 
     >	                  f8.0, 1p, e13.3)' )
     >             n, rtau( n ), log10( rtau(n) ), log10( taulac(n) ),
     >             5040./theta( n ), log10( etac(n) ), log10( beta(n) ),
     >             slam( n ), blam( n ), contrc( n ), 0.,
     >             tstr( mlam, fclam ), fclam
              ip = ip + 1


              headlines = 2
	      datalines = 1
              do 8 n = 3, nma
                 call page( headlines, datalines, reqtit )
                 if( curtit .ne. reqtit ) then
                    write( 3, '( ''    tau('', i5, '' ) lg tau  '',
     >                ''l tauc  temp   l etac l betac    slam'', 8x,
     >                ''blam'', 5x, ''cont'', 2x, ''Profile:  '',
     >                ''LASCAN  RSCAN  rad temp  F*(1-RSCAN)'', / )' )
     >                                                       int(reflam)
                    ip = ip + 2
                    curtit = reqtit
	         end if
                 write( 3, '(x, i3, 0p, f11.7, 2f8.3, f7.0, f7.2, f8.2,
     >	                   1p, 2e12.3, 0p, f6.1)' )
     >             n, rtau( n ), log10( rtau(n) ), log10( taulac(n) ),
     >             5040./theta( n ), log10( etac(n) ), log10( beta(n) ),
     >             slam( n ), blam( n ), contrc( n )
                 ip = ip + 1

8             continue
           end if

        else if( mode .eq. 3 ) then
C ***
C ***      Output line analysis
C ***

           if( ifnlte .eq. 1 ) write( stdout, '(A)' ) '  non-LTE'
	   if( costhe .ge. 0 ) then
	      i_or_f = 'I'
	   else
	      i_or_f = 'F'
	   end if

	   reqtit = 10
	   headlines = 3 + 3
           do 9 k = 1, kma

              y = 0.
              xwcal = 0.
              iz = 0
              if( boa(4) ) then
C ***
C ***             This piece of code doesn't work anymore as intended due to
C ***             the granularity in the new scheme for calculating total
C ***             opacities.  Leaving it like this wastes *lots* of CPU cycles.
C ***
*                 f = cont( lamk(k) )
*                 flg = log10( f )
*                 y = 1. - flux( dlk(k) )/f
C ***
C ***            Take RSCAN at closest wavelength instead.  Also, interpolate
C ***            continuous flux even continuous opacities are not granular.
C ***            This saves quite a bit more CPU cycles. 
C ***
	         flg = log10( max( 1e-37,	! if line's outside syn range
     >                    pol( lamk(k), alam, afclam, 1, nfc, 1, extra )
     >                           )
     >                      )
                 l = (dlk(k)/dellam + 0.5) + 1
                 l = min( max( 1, l ), iend )
                 y = rscan( l )
                 iz = it
C ***
C ***		 Contributing line?  set WCAL = -1
C ***
	         if( import(k) ) xwcal = -1.

              else

                 y = 1. - dep( dlk(k) )
                 flg = log10( fclam )
                 iz = it
                 if( k .eq. kma ) xwcal = wcal
                 if( blend(k) ) then
                    zeile = ' not iterated'
                 else
                    zeile = ' '
                 end if

                 write( stdout, '(1x, i3, i10, f10.3, i4, 2f8.2, a)' )
     >	           k, namk( k ), lamk( k ), iz, wobs, wcal, zeile( :13 )
              end if

              if( wcal .ge. wlim ) then

	         datalines = 1
	         if( k .eq. kma ) datalines = 2   ! make sure blank line at end
                                                  ! fits on same page
                 if( ifspha .eq. 1 .and. k .eq. 1 ) datalines =
     >                                                     datalines + 1
	         if( ifnlte .eq. 1 ) datalines = datalines + 1
       	         call page( headlines, datalines, reqtit )
	         if( curtit .ne. reqtit ) then
	            if( ip .ne. 0 ) then
	               write( 3, '(//)' )
	               ip = ip + 3
	            end if
                    write( 3, '(5a, //) ' )
     >                '        ion  mult   lambda    chi  lg gf ',
     >                '-lgC6  rru  rro  drrca -lgC4  rad micro lg eps',
     >                '  rc  lg gfe   W obs   W cal  lg ', i_or_f,
     >                '    mu SC IT'
                    ip = ip + 3
                    curtit = reqtit
                 end if
           
                 if( ifspha .eq. 1 .and. k .eq. 1 ) then
                    write( 3, '(A)' ) ' spherical approx.'
                    ip = ip + 1
                 end if

                 if( ifnlte .eq. 1 ) then
                    write( 3, '(1x, a, i4, 2x, 2a, i4, 2x, a)' )
     >                ' Level:  low=', low( k ), label( low(k) ),
     >                '  up=', up( k ), label( up(k) )
                    ip = ip + 1
                 end if

                 if( blend(k) .and. boa(2) ) then
                    adv = '*'
	         else if( boa(4) ) then
                    adv = 's'                     ! this line's not fitted
                    if( boa(2) ) then
C ***
C ***		       Find lambda point in fit_mask, which is on lamobs scale
C ***
	               if( lamk(k) .lt. lamobs(1) .or.
     >		           lamk(k) .gt. lamobs(mobs) ) then
                          l = 0 	     	  ! outside observation
                       else
	                  do i = 2, mobs
	                     if( lamk(k) .le. lamobs(i) ) then
	                        go to 901	  ! found it
	                     end if
	                  end do
901		          continue
                          l = fit_mask(i-1)       ! save fit_mask @ wavelength
	               end if
                       do i = 1, mfit
                          if( fit_item(i) .eq. namk(k) ) then
                             if( l .eq. 1 ) then
                                adv = 'F'         ! fitted within chi^2 range
                             else
                                adv = 'f'	  ! fitted through other lines
                             end if
                             go to 91
                       
                          end if
                       end do
91                     continue

                    end if
                 else
                    adv = ' '
                 end if

                 if( namk(k) .le. 9803 ) then
                    i = namk( k )/100
                    j = namk( k ) - 100*i
                    diff = dloggf( i, j )
                 else
                    diff = 0.
                 end if

                 write( 3, '(x, i10, i6, f10.3, f6.2, f7.3, f6.2, 2f5.0,
     >	                     f7.1, f6.2, f5.2, 2f6.2, f6.3, f7.3, 2f8.2,
     >	                     f7.3, f6.2, i2, i2, a)' ) namk( k ),
     >             mult( k ), lamk( k ), chik( k ), gflg( k ) - diff,
     >             c6lg( k ), rrcau( k ), rrcao( k ), drrca( k ),
     >             c4lg( k ), rad( k ), xi( 1 ), abuk( k ) + diff, y,
     >             abuk( k ) + gflg( k ), wnote( k ), xwcal, flg,
     >             costhe, ifscat, iz, adv
                 ip = ip + 1
              end if

9          continue

           if( wcal .ge. wlim ) then      ! fits on page
              write( 3, '(1x)' )
              ip = ip + 1
           end if

           write( stdout, '(1x)' )

        else if( mode .eq. 4 ) then
C ***
C ***      Output line analysis depth dependent quantities
C ***

	   k = abs( kcontr )
           kcontr = -1
           if( boa(4) ) then
C ***
C ***         Synthesis only: don't print the whole spectrum
C ***
              mma = 1
              l1  = lascan( isyn )
              rscan( 1 ) = flux( 1000.*(l1 - anflam) )/fclam
           else if( .not. (boa(1) .or. boa(2)) ) then
C ***
C ***         Curve of Growth only, except if boa(1), i.e. 20 5, but
C ***	                            what is that anyway?
C ***
              mma = 1
              l1  = 0.
              rscan( 1 ) = flux( 0. )/fclam
	   else
	      l1 = lascan( 1 )
           end if

	   reqtit = 11
	   headlines = 4
	   if( headlines + nma .le. maxlines ) then
	      datalines = nma
	   else
              headlines = headlines + 1
	      datalines = 3
           end if
	   call page( headlines, datalines, reqtit )

	   if( curtit .ne. reqtit ) then
	      if( ip .ne. 0 ) then
	         write( 3, '()' )
	         ip = ip + 1
	      end if
              
              if( boa(4) ) then
                 write( zeile, '(a19, i5, a4, f9.3)' )
     >             '  at wavelength no. ', isyn, '  [ ', lascan(isyn)
	         if( ifwave ) then
	            zeile(38:) = ' cm^-1 ]'
                    i = 45
	         else
	            zeile(38:) = ' A ]'
                    i = 41
                 end if
              else
                 zeile = ' '
                 i = 1
	      end if
	      write( 3, '(a, i10, i6, f10.3, a, //, a, i5, 3a, /)' )
     >          ' Printout for line ', namk(k), mult(k), lamk(k),
     >          zeile(:i),
     >        
     >          '     tau(', int(reflam), ' ) lg tau  l tauc  temp',
     >          '   l eta l alpha  core  cont         ',
     >          'Profile:   LASCAN  RSCAN rad temp  F*(1-RSCAN)'
              ip = ip + 4
              
	      curtit = reqtit
	   end if
        
           write( 3, '(x, i3, 0p, f11.7, 16x, f7.0, f7.2, f8.2, 29x, 
     >	               f9.3, f7.3, f8.0, 1p, e13.3)' ) 
     >	     1, rtau( 1 ), 5040./theta( 1 ), log10( eta0(1, k) ),
     >       log10( max(1.e-37,alpha(1, k)) ), l1,
     >       1. - rscan( 1 ), tstr( mlam, rscan(1)*fclam ),
     >       rscan(1)*fclam
	   ip = ip + 1

	   headlines = 2 + 1
	   datalines = 1
           do 10 n = 2, max( nma, mma + 1 )

	      call page( headlines, datalines, reqtit )
	      if( curtit .ne. reqtit ) then
	         if( ip .ne. 0 ) then
	            write( 3, '()' )
	            ip = ip + 1
	         end if
                 write( 3, '(a, i5, 3a, /)' ) '     tau(', int(reflam),
     >             ' ) lg tau  l tauc  temp   l eta l alpha  core  ',
     >             'cont         Profile:   LASCAN  RSCAN rad temp',
     >             '  F*(1-RSCAN)'
	         ip = ip + 2

	         curtit = reqtit
	      end if
           
              zeile = ' '
              write( zeile(:3), '(i3)' ) n

              if( n .le. nma ) write( zeile(4:64), 
     >	        '(0p, f11.7, 2f8.3, f7.0, f7.2, f8.2, 2f6.1)' )
     >          rtau( n ), log10( rtau(n) ), log10( taulac(n) ),
     >          5040/theta( n ), log10( eta0(n, k) ),
     >          log10( max( 1.e-37, alpha(n, k)) ), contrl( n ),
     >          contrc( n )
              i = 64

              if( n .lt. mma + 1 ) then
                 write( zeile(83:119), '(f8.3, f7.3, f8.0, 1p, e13.3)' )
     >	           lascan( n ), 1. - rscan( n ),
     >             tstr( mlam, rscan(n)*fclam ), rscan(n)*fclam
                 i = 119
              else if( n .eq. mma + 1 ) then
                 write( zeile(83:119), '(a, f7.3, f8.0, 1p, e13.3)' )
     >             '    CONT', 0., tstr( mlam, fclam ), fclam
                 i = 119
              end if

              write( 3, '(x, a)' ) zeile(:i)
              ip = ip + 1

10         continue

        else if( mode .eq. 5 ) then
C ***
C ***      Output departures
C ***
           if( ifdep .ne. 0 ) then
	      reqtit = 12
	      headlines = 4 + 3
	      datalines = 3
              do 12 n0 = 1, lmax, 10
                 n1 = min( lmax, n0 + 9 )
                 do 11 n = 1, nma
	            call page( headlines, datalines, reqtit )
                    if( curtit .ne. reqtit ) then
	               if( ip .ne. 0 ) then
                          write( 3, '(//)' )
                          ip = ip + 3
                       end if
                       
                       write( 3, '( '' Departures b for element:'', 
     >	                 i8, //, ''  N'', 10(4x, ''level'', i3) )' )
     >	                 atom, ( i, i = n0, n1 )
                       ip = ip + 3
                       
                       write( 3, '( 3x, 10(:, 6x, ''('', a, '')'') )' )
     >                   ( label(i), i = n0, n1 )
	               ip = ip + 1
                    
	               curtit = reqtit
                    end if

                    write( 3, '(1x, i2, 1p, 10e12.4)' ) n, 
     >	              ( b(n, i), i = n0, n1 )
	            ip = ip + 1
11               continue
                 reqtit = reqtit + 1
12            continue
              reqtit = 12	! because numbers are reserved
           end if
	   reqtit = 13
	   headlines = 0
	   datalines = 3
	   call page( headlines, datalines, reqtit )
	   write( 3, '(/, 1x, ''Departure coeffient identification:'',
     >                 /, 1x, a)' ) ident
	   ip = ip + 3
	else if( mode .eq. 6 ) then
C ***
C ***	   Output of fit ranges and radial velocity
C ***
	   j = 1
	   zeile = ' '
	   y = lamobs( 1 )
	   reqtit = 14
	   headlines = 3 + 2
	   datalines = 1
	   do i = 2, mobs
	      if( fit_mask(i) .ne. fit_mask(i-1) ) then
                 if( fit_mask(i) .eq. 0 ) then
	            if( j .ge. 130 ) then
                       call page( headlines, datalines, reqtit )
                       if( curtit .ne. reqtit ) then
                          if( ip .ne. 0 ) then
                             write( 3, '(/)' )
                             ip = ip + 2
                          end if
                          if( rvauto ) then
                             if( xrmin .eq. xrmax ) then
	                        xmin = max( lamobs(cbmin), anflam )
                                xmax = min( lamobs(cbmax), endlam )
                             else
                                xmin = xrmin
                                xmax = xrmax
                             end if
                             write( 3, '(a,f9.3,a,f9.3,a,f7.2,a,/)' )
     >                         ' Radial velocity (computed in [', xmin,
     >                         ', ', xmax, ']): ', rv, ' [km/s]'
                          else if( rv .ne. 0. ) then
                             write( 3, '(a,f7.2,a,/)' )
     >                         ' Radial velocity: ', rv, ' [km/s]'
                          end if
                          write( 3, '(a)' ) ' Fit ranges:'
                          ip = ip + 3
                          curtit = reqtit
                       end if
     	               write( 3, '(x,a)' ) zeile(:j-1)
                       ip = ip + 1
	               j = 1
	   	       zeile = ' '
	            else
	               write( zeile(j:j+25),
     >                        '(f11.3, '' - '', f11.3, x)' )
     >                   y, lamobs( i - 1 )
	               j = j + 26
	            end if
	         else
	            y = lamobs( i )
	         end if
	      end if
	   end do
	   if( j .ne. 1 ) then
              call page( headlines, datalines, reqtit )
              if( curtit .ne. reqtit ) then
                 if( ip .ne. 0 ) then
                    write( 3, '(/)' )
                    ip = ip + 2
                 end if
                 if( rvauto ) then
                    if( xrmin .eq. xrmax ) then
	               xmin = max( lamobs(cbmin), anflam )
                       xmax = min( lamobs(cbmax), endlam )
                    else
                       xmin = xrmin
                       xmax = xrmax
                    end if
                    write( 3, '(a,f9.3,a,f9.3,a,f7.2,a,/)' )
     >                ' Radial velocity (computed in [', xmin,
     >                ', ', xmax, ']): ', rv, ' [km/s]'
                 else if( rv .ne. 0. ) then
                    write( 3, '(a,f7.2,a,/)' )
     >                ' Radial velocity: ', rv, ' [km/s]'
                 end if
                 write( 3, '(a)' ) ' Fit ranges:'
                 ip = ip + 3
                 curtit = reqtit
              end if
	      write( 3, '(x,a)' ) zeile(:j-1)
              ip = ip + 1
	   end if

	else if( mode .eq. 7 ) then
C ***
C ***	   output of fit
C ***
	   reqtit = 15
	   headlines = 0 + 1
	   datalines = 1 + mfit + 1
	   do i = 1, mfit
              call page( headlines, datalines, reqtit )
              if( curtit .ne. reqtit ) then
                 if( ip .ne. 0 ) then
                    write( 3, '()' )
                    ip = ip + 1
                 end if
                 curtit = reqtit
              end if
              if( i .eq. 1 ) then
                 write( 3, '()' )
                 ip = ip + 1
              end if
              if( fit_item(i) .eq. 13 ) then
	         write( stdout, '(1x, a12, 1p, g15.7, a, g15.7)' )
     >             'xi macro: ',
     >             fit_value( i ), '+/-', fit_err(i)
	         write( 3, '(1x, a12, 1p, g15.7, a, g15.7)' )
     >             'xi macro: ',
     >             fit_value( i ), '+/-', fit_err(i)
              else if( fit_item(i) .eq. 14 ) then
	         write( stdout, '(1x, a12, 1p, g15.7, a, g15.7)' )
     >             'v sini: ',
     >             fit_value( i ), '+/-', fit_err(i)
	         write( 3, '(1x, a12, 1p, g15.7, a, g15.7)' )
     >             'v sini: ',
     >             fit_value( i ), '+/-', fit_err(i)
	      else if( fit_item(i) .eq. 55 ) then
	         write( stdout, '(1x, a12, 1p, g15.7, a, g15.7)' )
     >             'xi micro: ',
     >             fit_value( i ), '+/-', fit_err(i)
	         write( 3, '(1x, a12, 1p, g15.7, a, g15.7)' )
     >             'xi micro: ',
     >             fit_value( i ), '+/-', fit_err(i)
	      else
	         write( stdout, '(1x, i10, a, 1p, g15.7, a, g15.7)' )
     >             fit_item( i ), ': ',
     >             start_value( i ) + fit_value( i ), '+/-', fit_err(i)
	         write( 3, '(1x, i10, a, 1p, g15.7, a, g15.7)' )
     >             fit_item( i ), ': ',
     >             start_value( i ) + fit_value( i ), '+/-', fit_err(i)
	      end if
              ip = ip + 1
	   end do
C ***
C ***	   no page check here; previous call made sure there is room
C ***
	   write( stdout, '(1x, a12, 1p, g24.15e3, /)' ) 'chi^2: ',
     >       chisqr
	   write( 3, '(1x, a12, 1p, g24.15e3)' ) 'chi^2: ',
     >       chisqr
	   ip = ip + 1

	else

	   write( stdout, * ) 'Illegal argument to PUTOUT: ', mode
	   call exit

        end if

        end
