* Various subroutines to copy buffers and compute rms's, etc
	SUBROUTINE RRVECTOR(N,BUF1,BUF2)
* Copy a real buffer to another
        REAL*4 BUF1(1),BUF2(1)
	DO J = 1,N
	    BUF2(J) = BUF1(J)
	END DO
	RETURN
	END

	SUBROUTINE CCVECTOR(N,X1,X2)
* Copy a complex buffer to another
	COMPLEX*8 X1(1),X2(1)
	DO J = 1,N
	    X2(J) = X1(J)
	END DO
	RETURN
	END

	SUBROUTINE RCVECTOR(N,BUF,X)
* copy a real buffer to a complex one
	REAL*4 BUF(1)
	COMPLEX*8 X(1)
	DO J = N,1,-1
	    X(J) = CMPLX(BUF(J))
	END DO
	RETURN
	END

	SUBROUTINE CRVECTOR(N,X,BUF)
* copy a complex buffer to a real one
	REAL*4 BUF(1)
	COMPLEX*8 X(1)
	DO J = 1,N
	    BUF(J) = REAL(X(J))
	END DO
	RETURN
	END

	FUNCTION GETRMS(N,X)
* Compute the rms of a complex buffer and set it to RMS
* Assume a transform of a real function
	COMPLEX*8 X(1)
	GETRMS = CABS(X(1))*CABS(X(1))+CABS(X(N/2+1))*CABS(X(N/2+1))
	DO J = 2,N/2
	    GETRMS = GETRMS + 2 * CABS(X(J)) * CABS(X(J))
	END DO
	GETRMS = SQRT(GETRMS) / N ! since it is the transform
	RETURN
	END

	SUBROUTINE ASPART(N,K1,K2,K3,K4,SHIFT,X,ARMS,SRMS)
* Compute the anti and symmetric parts of a complex buffer, shifted by SHIFT
* Assume a transform of a real function, and a cosine bell of K1,K2,K3,K4.
	COMPLEX*8 X(N), PHASE
	PARAMETER( PI = 3.14159265 )

	ARMS = 0
	SRMS = 0
	DO K = K1,K4
	    ANGLE = -2*PI*K*SHIFT/N
	    PHASE = CMPLX(COS(ANGLE),SIN(ANGLE))
	    IF(K.EQ.0.OR.K.EQ.N/2) THEN
	        F = 1
	    ELSE
	        F = 2
	    END IF
	    IF(K.LT.K2) THEN
	    	ARG = PI * FLOAT(K-K1)/FLOAT(K2-K1)
	    	F = F * .25 * (1-COS(ARG)) * (1-COS(ARG))
	    ELSE IF(K.GT.K3) THEN
	    	ARG = PI * FLOAT(K-K3)/FLOAT(K4-K3)
	    	F = F * .25 * (1+COS(ARG)) * (1+COS(ARG))
	    END IF
	    ARMS = ARMS + F*AIMAG(PHASE*X(K+1))*AIMAG(PHASE*X(K+1))
	    SRMS = SRMS + F*REAL(PHASE*X(K+1))*REAL(PHASE*X(K+1))
	END DO
	ARMS = SQRT(ARMS) / N ! Since it is the transform
	SRMS = SQRT(SRMS) / N
	RETURN
	END

	SUBROUTINE SHIFTIT(N,SHIFT,X)
* Shift a complex buffer by -SHIFT
	COMPLEX*8 X(N), PHASE
	PARAMETER( PI = 3.14159265 )
	DO I = 1,N
	    IF(I-1.LE.N/2) THEN
	    	ANGLE = -2*PI*(I-1)*SHIFT/N
	    ELSE
	    	ANGLE = -2*PI*(I-1-N)*SHIFT/N
	    ENDIF
	    PHASE = CMPLX(COS(ANGLE),SIN(ANGLE))
	    X(I) = X(I) * PHASE
	ENDDO
	RETURN
	END
