	subroutine rvcorr
C ***
C ******************************************************************************
C ***
C ***   Corrects observed spectrum for radial velocity.  Either directly from
C ***   given RV or from cross correlation.
C ***
C ***	24-JUL-1996 19:26:55.85		ML / Bamberg.  Made.
C ***	16-JAN-1998 17:13:36.86		ML / Bamberg.  No change to yfit.
C ***	 9-FEB-1998 16:12:41.53		ML / Bamberg.  Fix nonsense with
C ***					wavelength overlap.  Has never worked.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***   Global variables
C ***
	include 'LINLTE.INC'
	include 'FIT.INC'
	include 'OBS.INC'
	include 'IF.INC'
	include 'CALCUL.INC'
	include 'PROFIL.INC'

C ***
C ***	Local variables
C ***
	logical extra
	integer j
	real xmin, xmax
	real fluxo(nobs)
	real clight
	parameter( clight = 2.99797e5 )

C ***
C ***	Functions
C ***
	real pol

C ***
C ***	Code
C ***

	if( rvauto ) then
C ***
C ***      do cross correlation
C ***
           if( xrmin .eq. xrmax ) then
	      xmin = max( lamobs(1), lascan(cbmin) )
              xmax = min( lamobs(mobs), lascan(cbmax) )
           else
              xmin = max( lascan(cbmin), xrmin )   ! xrmin checked in sfilop
              xmax = min( lascan(cbmax), xrmax )   ! xrmax checked in sfilop
           end if
           do j = 1, mobs
              fluxo(j) = fluxobs(j)	       ! scross destroys its arguments
           end do                              
           call scross( xmin, xmax, lamobs, fluxo, yfit, mobs, rv )
           rv = rv*2./(xmax + xmin)*clight     ! RV pixel -> km/s
	end if

        if( rv .ne. 0. ) then
           if( rvauto ) then
	      write( stdout, * ) 'Radial velocity computed in [', xmin,
     >                           ', ', xmax, ']: ', RV, ' [km/s]'
           else
	      write( stdout, * ) 'Radial velocity: ', RV, ' [km/s]'
           end if
           write( stdout, * )


        end if


C ***
C ***   Apply the actual correction to observation
C ***	
        do j = 1, mobs
	   lamobs(j) = lamobs(j)/(1. + rv/clight)
	end do

C ***
C ***   and to wavelength interpolated synthesis (starting solution)
C ***
        do j = 1, mobs
           yfit(j) = pol( lamobs(j), lascan, rstreu, 1, mma, 1, extra )
        end do

	end
