        subroutine sfilop
C ***
C ************************************************************************************
C ***
C ***	$Id: sfilop.f,v 1.2 2004/03/03 23:53:53 ai26 Exp $
C ***
C ***   File open routine for synthesis branch.
C ***
C ***
C ***   21-MAR-1995 17:00:19.00         ML / IoA.  Created.
C ***	25-JUL-1996 20:10:11.57		ML / Bamberg.  check xrmin, xrmax
C ***	10-MAR-1997 16:09:05.32		ML / Bamberg.  check xrmin, xrmax
C ***                                   against synthesis interval
C ***	11-JUN-1997 12:27:46.21		ML / Bamberg.  HE1/HEBCSS check fixed.
C ***   16-JUL-1997 22:10:45.00         ML / Stegaurach.  Check on IFABS commented
C ***                                   out.  Should work to give F_lam [.../]
C ***                                   Check caused trouble with combination option.
C ***   14-SEP-1997 18:28:48.00		ML / Stegaurach.  New linprof stuff,
C ***                                   allow to open VCS.DAT via logical
C ***	22-OCT-1997 15:29:24.10		ML / Bamberg.  BWB; VCS_DAT readonly
C ***	31-OCT-1997 18:59:29.85		ML / Bamberg.  VCSSB open
C ***	18-DEC-1997 17:27:48.32		ML / Bamberg.  iflimits .eq. 3
C ***    4-MAR-2004 00:32:13.01         ML / Stegaurach.  Try to cope with
C ***                                   readonly/shared via D lines.
C ***
C ************************************************************************************
C ***
        implicit none


C ***
C ***   Global variables
C ***
	include 'LINLTE.INC'
        include 'IF.INC'
	include 'CALCUL.INC'
	include 'FILES.INC'
	include 'IONS.INC'
	include 'PRES.INC'
	include 'STRUCT.INC'
	include 'LINE.INC'
	include 'OBS.INC'
	include 'LINDAT.INC'


C ***
C ***	Local variables
C ***
	logical limits_open, vcs_open, vcssb_open, bcss_open
	integer i, j, k, n, ist
	real average, x

C ***
C ***	Functions
C ***
	integer hebcss
	external hebcss

	save limits_open, vcs_open, vcssb_open, bcss_open
	data limits_open, vcs_open, bcss_open /3*.false./


C ***
C ***	Code
C ***
C ***	General checks and initializations
C ***

C ***   
C ***   Open VCS.DAT + BCSS_HE1.DAT + BCSS_4471.DAT here to crash if 
C ***   non-existent before doing lengthy computations.
C ***	Goes logically in VCS and BCSS though.
C ***       
        do k = 1, kma
           if( bcss_open .and. vcs_open ) go to 1 ! loop if everything done
           if( .not.vcs_open .and. lprof(k) .eq. PVCS ) then

              open( VCS_DAT, file = 'VCS', status = 'old'
d    >              , readonly, shared
     >              , iostat = ist )
	      if( ist .ne. 0 ) then
                 open( VCS_DAT, file = 'VCS.DAT', status = 'old' 
d    >                 , readonly, shared
     >               )
	      end if
              vcs_open = .true.

           else if( .not.bcss_open .and.
     >              lprof(k) .eq. PHEBCSS .and.
     >              hebcss(k) .gt. 0 ) then
              call inibcss
              bcss_open = .true.
           else if( .not.vcssb_open .and. lprof(k) .eq. PVCSSB ) then

              open( VCSSB_DAT, file = 'VCSSB', status = 'old'
d    >              , readonly, shared
     >              , iostat = ist )
	      if( ist .ne. 0 ) then
                 open( VCSSB_DAT, file = 'VCSSB.DAT', status = 'old' 
d    >                 , readonly, shared
     >               )
	      end if
              vcssb_open = .true.
	   end if

	end do
1	continue

        if( boa(4) ) then
C ***
C ***	   Checks for synthesis
C ***
!           if( ifabs .ne. 0 .and. ifwave ) then
!              write( stdout, * )
!     >          'LINLTE>> Sorry, wavenumbers + abs. intensities not ',
!     >          'yet implemented.'
!              call exit
!           end if
           
           if( boa(2) ) then
C ***      
C ***         some error checking and initialization for iteration
C ***      
              if( mfit .eq. 0 ) then
                 write( stdout, * )
     >             'LINLTE>> ERROR: Nothing to fit.'
                 write( stdout, * )
     >             '                Specify control flag 54 in',
     >             ' LINE.DAT!'
                 call exit
              end if
              do i = 1, mfit
                 if(       fit_item(i) .lt. 98
C ***                                       Abundance
           
     >               .and. fit_item(i) .ne. 13
C ***                                       macro turbulence
           
     >               .and. fit_item(i) .ne. 14
C ***                                       vsini
           
     >               .and. fit_item(i) .ne. 55
C ***                                       microturbulence
     >                                         ) then
           
                    write( stdout, * )
     >                'LINLTE>> ERROR: Unknown item to fit: ',
     >                fit_item( i )
                    write( stdout, * )
     >                '                Modify LINE.DAT flag 54!'
                    call exit
                 end if
                 if( fit_item(i) .eq. 55 ) then
                    if( xi(1) .ne. xi(2) ) then
                       write( stdout, * )
     >                   'LINLTE>> WARNING: Making depth dependent ',
     >                   'microturbulence depth independent for fit.'
                    
                       do j = 1, jma
                          x = 83.808/wtj( j )
                          do n = 1, nma
                             vdop( n, j ) = sqrt( xi(2)*xi(2) +
     >                                      x/theta(n) )/299792.5
                          end do
                       end do
                    
                    end if
           
                 end if
              end do
C ***      
C ***         Read observation
C ***         
              open( OBS_OUT, file = 'OBS.OUT', status = 'old'
d    >             , readonly, shared
     >            )
              read( OBS_OUT, * ) mobs
              if( mobs .gt. nobs ) then
                 write( stdout, * )
     >             'LINLTE>> ERROR: Too many data points in ',
     >             'observation.'
                 write( stdout, * )
     >             '                Not more than ', nobs, ', please.'
                 call exit
              end if
              average = 0.
              do i = 1, mobs
                 read( OBS_OUT, * ) lamobs( i ), fluxobs( i )
                 average = average + fluxobs( i )
              end do
              close( OBS_OUT )
           
              if( (lamobs(1) .gt. endlam) .or. 
     >            (lamobs(mobs) .lt. anflam) ) then
                 write( stdout, * )
     >             'LINLTE>> ERROR: No overlap of observation and',
     >             ' synthesis.'
                 write( stdout, * )
     >             '                Observation: ', lamobs(1), ' - ',
     >             lamobs(mobs)
                 write( stdout, * )
     >             '                Synthesis:   ', anflam, ' - ',
     >             endlam
                 write( stdout, * )
     >             '                Modify LINE.DAT flag 10!'
                 call exit
              end if
C ***      
C ***         Check if observation normalized to 1 or 10,000.
C ***      
              if( average/mobs .gt. 2. ) then
                  do i = 1, mobs
                     fluxobs( i ) = 0.0001*fluxobs( i )
                  end do
              end if
           
              if( rvauto ) then
C ***      
C ***            Check cross correlation limits for RV determination
C ***      
                 if( xrmin .ne. xrmax ) then
                    if( xrmin .lt. lamobs(1) .or.
     >                  xrmax .gt. lamobs(mobs) ) then
                       write( stdout, * )
     >                   'LINLTE>> ERROR: Wavelength limits for RV '//
     >                   'cross correlation incompatible'
                       write( stdout, * )
     >                   '                with observation:'
                       write( stdout, * )
                       write( stdout, * )
     >                   '                Observation:   ', lamobs(1),
     >                   ' - ', lamobs(mobs)
                       write( stdout, * )
     >                   '                x correlation: ', xrmin, 
     >                   ' - ', xrmax
                       write( stdout, * )
     >                   '                Modify LINE.DAT flag 15!'
                       call exit
                    else if( xrmin .lt. anflam .or.
     >                       xrmax .gt. endlam ) then
                       write( stdout, * )
     >                   'LINLTE>> ERROR: Wavelength limits for RV '//
     >                   'cross correlation incompatible'
                       write( stdout, * )
     >                   '                with synthesis interval:'
                       write( stdout, * )
                       write( stdout, * )
     >                   '                Synthesis:     ', anflam, 
     >                   ' - ', endlam
                       write( stdout, * )
     >                   '                x correlation: ', xrmin,
     >                   ' - ', xrmax
                       write( stdout, * )
     >                   '                Modify LINE.DAT flag 15!'
                       call exit
                    end if
                 end if
              end if
C ***      
C ***         Open LIMITS.DAT here to crash if non-existent before doing
C ***         lengthy computations.  Goes logically in SPEFIT though.
C ***      
C ***         Not sure if we do the right thing with new/old.  Iflimits
C ***         could change for next synthesis....
C ***      
              if( .not.limits_open ) then
                 if( iflimits .eq. 1 .or. iflimits .eq. 3 ) then
                    open( LIMITS_DAT, file = 'LIMITS.DAT',
     >                    status = 'new', iostat = ist )
                    if( ist .ne. 0 ) then
                       open( LIMITS_DAT, file = 'LIMITS.DAT',
     >                       status = 'unknown' )
                    end if
                 else if( iflimits .eq. 2 ) then
                    open( LIMITS_DAT, file = 'LIMITS.DAT',
     >                    status = 'old' )
                 end if
                 limits_open = .true.
              end if
           
           end if
C ***      
C ***      Open FALT.DAT here to crash if non-existent before doing
C ***      lengthy computations.  Goes logically in FALT though.
C ***          
           open( FALT_DAT, file = 'FALT.DAT', status = 'old'
d    >           , readonly, shared
     >         )


	end if

	end
