	subroutine synthesis( output )
C ***
C ******************************************************************************
C ***
C ***	Computes synthetic spectrum.
C ***
C ***	 6-MAY-1992 19:06:14.00
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	logical output

C ***
C ***	Local variables
C ***
	integer c, k, kcsave, m, nn
	real lambda, tanflam, ignore
	character*24 form

C ***
C ***	Functions
C ***
	real conopa, flux

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'

	include 'IF.INC'
	include 'FLUSS.INC'
	include 'FCON.INC'
	include 'CALCUL.INC'
	include 'PROFIL.INC'
	include 'LINE.INC'
	include 'LINDAT.INC'


	if( opinit ) then
	   do m = 1, iend
	      rscan( m ) = 1.
	   end do
	end if
	calflu(1) = .true.			! or we won't see any line
	c = 1
        kcsave = kcontr
        kcontr = -1
        wcal = 0.
	tanflam = 1000.*anflam
	ignore = conopa( alam(c) )
	fclam = afclam(c)
        do m = 1, iend

           if( m .eq. isyn ) kcontr = kcsave

	   lambda = 1000.*lascan(m) - tanflam
	   if( (lascan(m) .gt. alam(c) + 0.5) .and. (c .lt. nfc) ) then
	      c = c + 1
	      ignore = conopa( alam(c) )		! Continuous opacities
	      fclam = afclam(c)
	   end if

           if( calflu(m) ) then
              rscan( m ) = flux( lambda )/fclam
	   end if

           if( itv .eq. 1 ) then
              nn = max( 1, nint( 50.*(1. - rscan(m)) ) )
              write( form, '(a, i2, a)' ) '(', nn + 1,
     >                                    'x, f9.3, x, f7.5, i8)'
              do k = 1, kma
                 if( abs(dlk(k) - lambda) .lt. 20. ) then
                    write( stdout, form ) lascan( m ), 1. - rscan( m ),
     >                                    namk( k )
	            go to 1
	         end if
              end do

              write( stdout, form ) lascan( m ), 1. - rscan( m )

           end if

1	   continue

           kcontr = -1
           mma = m
        end do
        if( kcsave .gt. 0 ) kcontr = kcsave

        call falt( output )

	end
