	program mymongo
C ***
C ******************************************************************************
C ***
C ***	(c) 1996-2002 Michael Lemke
C ***
C ***	Modifications:
C ***
C ***	 4-JUN-1996 18:26:17.43		ML / Bamberg.  Created.
C ***	11-JUN-1996 12:07:33.37		ML / Bamberg.  Styles added.
C ***	26-JUN-1996 14:39:24.61		ML / Bamberg.  Title added.
C ***	 2-APR-1997 17:47:54.74		ML / Bamberg.  Variable column input.
C ***	18-APR-1997 19:39:50.83		ML / Bamberg.  Colors.
C ***	29-APR-1997 16:02:48.93		ML / Bamberg.  Colors. Integer. Damn it!
C ***    3-NOV-1999 14:39:23.00		ML / Stegaurach.  Axis labelling.
C ***    9-AUG-2000 16:08:00.00		ML / Stegaurach.  More curves.
C ***	 3-OCT-2001 22:46:00.00		ML / Stegaurach.  plotout -> plotoutend
C ***    5-OCT-2001 21:18:00.00		ML / Stegaurach.  Dynamic memory.
C ***    4-NOV-2002 23:54:38.00         ML / Stegaurach.  Pass dynamic
C ***                                   char variables with %ref.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Local variables
C ***
	integer nf
        parameter( nf = 10 )

	integer i, ncurv, status
	real d

	logical more, garbage
	real colour


! curve structure:
!	integer first(nf), xcol(nf), ycol(nf), color(nf)
!	real ltyp(nf)
!	character file(nf)*255

	integer pi_first, pi_xcol, pi_ycol, pi_color
	integer pr_ltyp
	integer pc_file_a, pc_file_l

	integer sizeof_curve
	parameter( sizeof_curve = 6*4 + 255 )
	integer mem_curv
! end curve structure

        character xlab*255, ylab*255, title*132

	real xpmin, xpmax, ypmin, ypmax

C ***
C ***	Functions
C ***
        integer idx
        integer ml_malloc, ml_realloc
	real deref
	external idx, null, ml_malloc, ml_realloc, deref

C ***
C ***	Code
C ***

	xpmin = 0
	xpmax = 0
	ypmin = 0
	ypmax = 0
	
        call prgid( 'mymongo', ' 4-NOV-2002 23:58:07.00' )
	call gpinit( 'mymongo.cmd', ' ', 0, d, d, d, d, d )

	mem_curv = nf
	pi_first = ml_malloc( mem_curv*sizeof_curve )
	if( pi_first .eq. 0 ) then
	   print *, 'MYMONGO>> couldn''t get memory.'
	   call exit
	end if
	pi_xcol = pi_first + 4
	pi_ycol = pi_xcol + 4
	pi_color = pi_ycol + 4
	pr_ltyp = pi_color + 4
	pc_file_a = pr_ltyp + 4
	pc_file_l = pc_file_a + 255

        more = .true.
	ncurv = 0
        do while( more )
           ncurv = ncurv + 1
	   if( mod( ncurv, nf ) .eq. 0 ) then
C ***	      get next chunk of memory
	      mem_curv = mem_curv + nf
	      pi_first = ml_realloc( pi_first, mem_curv*sizeof_curve )
	      if( pi_first .eq. 0 ) then
	         print *, 'MYMONGO>> couldn''t get more memory.'
	         call exit
	      end if
	      pi_xcol = pi_first + 4
	      pi_ycol = pi_xcol + 4
	      pi_color = pi_ycol + 4
	      pr_ltyp = pi_color + 4
	      pc_file_a = pr_ltyp + 4
	      pc_file_l = pc_file_a + 255
	   end if
           call gfile( %ref('Data file'), 
     >                 %val(pc_file_a+sizeof_curve*(ncurv-1)), 
     >                 %ref('.dat'), %val(9), %val(255), %val(4) )
	   call igpar( %ref('First line with data'), 1, 
     >                 %val(pi_first+sizeof_curve*(ncurv-1)), d,
     >                 d, d, d, %val(20),%val(255) )
	   call igpar( %ref('Column with X data'), 1, 
     >                 %val(pi_xcol+sizeof_curve*(ncurv-1)), d, d,
     >                 d, d, %val(18), %val(255) )
	   call igpar( %ref('Column with Y data'), 1, 
     >                 %val(pi_ycol+sizeof_curve*(ncurv-1)), d, d,
     >                 d, d, %val(18),%val(255) )
           call gparny( 'Ignore trailing non-numeric data', garbage )
	   call gpar( %ref('Line style, color index'), 2, 
     >                %val(pr_ltyp+sizeof_curve*(ncurv-1)),
     >                colour, d, d, d, %val(23), %val(255) )
	   call iderefass( int(colour), 
     >                     %val(pi_color+sizeof_curve*(ncurv-1)), 1 )
           if( ncurv .eq. 1 ) then
              call gpar( 'Plot limits (xmin, xmax, ymin, ymax),'//
     >                   ' zeros for automatic', 4, xpmin, xpmax, ypmin,
     >                   ypmax, d )
              call gtext( 'Label x-axis', xlab )
              call gtext( 'Label y-axis', ylab )
              call gtext( 'Header text', title )
           end if
	   call gparny( 'More files', more )
        end do
        call gpclos


	do i = 1, ncurv
           if( deref(%val( pr_ltyp + sizeof_curve*(i-1)),1) .eq. -100. 
     >         .or. 
     >         deref(%val( pr_ltyp + sizeof_curve*(i-1)),1) .eq. -101. )
     >     then
	      call linid( %val( pc_file_a + sizeof_curve*(i-1)), 
     >                    %val( pi_first + sizeof_curve*(i-1)), 
     >                    %val( pi_xcol + sizeof_curve*(i-1)), 
     >                    %val( pi_ycol + sizeof_curve*(i-1)), 
     >                    %val( pr_ltyp + sizeof_curve*(i-1)), 
     >                    %val(255) )

	   else
	      call plotdata( %val( pi_first + sizeof_curve*(i-1) ),
     >                       %val( pi_xcol + sizeof_curve*(i-1) ),
     >                       %val( pi_ycol + sizeof_curve*(i-1) ),
     >                       %val( pi_color + sizeof_curve*(i-1) ),
     >                       %val( pr_ltyp + sizeof_curve*(i-1) ),
     >                       %val( pc_file_a + sizeof_curve*(i-1) ),
     >                       garbage,
     >                       %val(255) )
           end if

	end do

	call resize_fsetup( xpmin, xpmax, ypmin, ypmax,
     >                      xlab, ylab, title )

	call re_paint
	call resize( null, status )
	call plotoutend

	end

