	subroutine plotdata( first, xcol, ycol, color, ltyp, file,
     >                       garbage )
	implicit none
C ***
C ***	Arguments
C ***
	integer first, xcol, ycol, color
	real ltyp
	character file*(*)
	logical garbage

C ***
C ***	Local variables
C ***
	integer np, max_rec_len
        parameter( np = 512, max_rec_len = 255 )
	integer j, k, status
	logical error
	character line*(max_rec_len)
	real d, xd, yd
	integer pr_xdata, pr_ydata
	integer mem_data

C ***
C ***	Functions
C ***
	integer idx, ml_malloc, ml_realloc
	external idx, ml_malloc, ml_realloc

C ***
C ***	Code
C ***
	open( 1, file = file, status = 'old'
*     >        , readonly, shared 
     >      )
        do j = 1, first - 1
           read( 1, '()')
	end do

	mem_data = np
	pr_xdata = ml_malloc( mem_data*4 )
	pr_ydata = ml_malloc( mem_data*4 )

        j = 1
	do while( .true. )
	   read( 1, '(a)', end = 1 ) line
           read( line, *, iostat = status ) (d, k = 1, xcol-1), xd
           error = .false.
           if( status .ne. 0 ) then
              write( 6, * ) 'MYMONGO>> Error reading X data from'//
     >                      ' column ', xcol, ', line #', j
              write( 6, * ) '          in file ',
     >                      file(:idx(file)), ':'
              write( 6, '()' )
              write( 6, * ) line(:idx(line))
              if( garbage .and. status .gt. 0 ) then
                 write( 6, * ) '          Continuing...'
                 error = .true.
              else
                 call exit
              end if
           end if
	   read( line, *, iostat = status ) (d, k = 1, ycol-1), yd
           if( status .ne. 0 ) then
              write( 6, * ) 'MYMONGO>> Error reading Y data from'//
     >                      ' column ', ycol, ' in line #', j
              write( 6, * ) '          in file ',
     >                      file(:idx(file)), ':'
              write( 6, '()' )
              write( 6, * ) line(:idx(line))
              if( garbage .and. status .gt. 0 ) then
                 write( 6, * ) '          Continuing...'
                 error = .true.
              else
                 call exit
              end if
           end if
	   call derefass( xd, %val( pr_xdata ), j )
	   call derefass( yd, %val( pr_ydata ), j )
           j = j + 1
	   if( mod( j, np ) .eq. 1 ) then
	      mem_data = mem_data + np
	      pr_xdata = ml_realloc( pr_xdata, mem_data*4 )
	      if( pr_xdata .eq. 0 ) then
	         print * , 'MYMONGO>> Couldn''t get more memory.'
	         call exit
	      end if
	      pr_ydata = ml_realloc( pr_ydata, mem_data*4 )
	      if( pr_ydata .eq. 0 ) then
	         print * , 'MYMONGO>> Couldn''t get more memory.'
	         call exit
	      end if
	   end if
           if( error ) j = j - 1
	end do

1	close( 1 )

	j = j - 1
	pr_xdata = ml_realloc( pr_xdata, j*4 )	! shrink memory
	pr_ydata = ml_realloc( pr_ydata, j*4 )

        call resize_add_data( %val(pr_xdata), %val(pr_ydata), j, ltyp,
     >                        color )

	end
