	program abuplt
c ***
c *************************************************************************
c ***
c *** 	Plottet Haeufigkeiten LOG EPS vs. W OBS oder
c ***		 	      LOG EPS vs. W CAL oder
c ***			      LOG EPS vs. CHI LOW
c ***
c ***	Input: LINE.DAT		aus LINFOR
c ***	       FOR003.DAT	aus LINFOR 
c ***		  und, wenn log eps vs. w cal 
c ***	       FOR003.CAL	FOR003.DAT aus LINFOR mit w cal, d.h. 20 1
c ***
c ***	Die FOR003.* - Files muessen mit demselben LINE.DAT erzeugt werden
C ***
C ***
C ***	Statistik ist fr Blends mit einem Element in mehreren Ionisationsstufen
C ***	problematisch:                                       
C ***
C ***	Wird z.Z. der Ionisationsstufe zugerechnet, deren Linie als erste auf-
C ***	tritt. 
C ***
C ***	 7-OCT-1997 18:10:23.22		ML / Bamberg.  Disable gpos.  Didn't
C ***					work anyway.
C ***	15-JAN-1998 13:38:00.81		ML / Bamberg.  Changed roman numbers to
C ***					work if > 3.
C ***	 7-MAY-2000 23:18:59.52		ML / Stegaurach.  plot vs log(w/lambda)
C ***    5-OCT-2000 15:54:00.00		ML /McA.  Make it work with g77:
C ***					removed D lines, commented readonly,
C ***					some format changes x -> 1x etc.i,
C ***					type -> print
C ***
c ***
c *************************************************************************
c ***
	integer for003, line_dat, eps_dat, cal_fil
	parameter( line_dat = 21, for003 = 22, eps_dat = 23, cal_fil =
     >	  24 )

	parameter( reamax = 1.e30 )
	parameter( nelem = 40, nelem1 = nelem + 1, kma_max = 100 )
	character lptzei*132, title*120, atm*120, elem(58)*2, roman*3,
     >	  micro*5, calfil*27, method*3, date*19, elerom*6, tit*112, 
     >	  vor*1, blend*1, symbol*255, ident*132, ans*5
	real lggfe, lggf, lgeps, lamda, lamda1, lamda2
	logical first, cal, error, regr, farbe, equplt, lamwlam
	logical new_form(for003:cal_fil)
	dimension inum( nelem1 ), x( nelem1 ), xx( nelem1 ), 
     >	  xy( nelem1 ), y( nelem1 ), yy( nelem1 ), n( nelem1 ), 
     >	  iblend( kma_max )
	data ip/ 0 /
	data inum/ nelem1*0 /
	data x, xx, xy, y, yy, n/ nelem1*0., nelem1*0., nelem1*0., 
     >	  nelem1*0., nelem1*0., nelem1*0 /
	data ionmax, numion/ 1, 1 /
	data kma_read/ 0 /
	data elem/ 'H', 'He', 'Li', 'Be', 'B', 'C', 'N', 'O', 'F', 'Ne',
     >	  'Na', 'Mg', 'Al', 'Si', 'P', 'S', 'Cl', 'Ar', 'K', 'Ca', 'Sc',
     >	  'Ti', 'V', 'Cr', 'Mn', 'Fe', 'Co', 'Ni', 'Cu', 'Zn', 'Ga', 
     >	  'Ge', 'As', 'Se', 'Br', 'Kr', 'Rb', 'Sr', 'Y', 'Zr', 'Nb', 
     >	  'No', 'Tc', 'Ru', 'Rh', 'Pd', 'Ag', 'Cd', 'In', 'Sn', 'Sb', 
     >	  'Te', 'I', 'Xe', 'Cs', 'Ba', 'La', 'Ce'/
	data xl, yl/ 24., 16. /

	yreg(xxx) = slope*xxx + b
C ***
*        call prglog( 'SYS$USER6:[SUPAS059]ABUPLT.USE', lptzei )
	call prgid( 'ABUPLT', ' 5-OCT-2000 16:11:00.00 CDT' )
	call datum( date )
	call gpinit( 'abuplt.cmd', ' ', 0, d, d, d, d, d )
	call gmenu( '('' Select 1) Plot vs Equivalent Width''/'//
     >               '''        2) Plot/Stats vs log(EW/lambda)''/'//
     >               '''        3) Plot vs chi'')' )
	call gtext(     '1, 2, or 3', ans )
	equplt = index( ans, 'y' ) .eq. 1 .or. 
     >           index( ans, 'Y' ) .eq. 1 .or.
     >           ans .eq. '1' .or.
     >           ans .eq. '2'
	lamwlam = ans .eq. '2'
	call gtext( 'File name with theor. EQW ( <return>:'//
     >              ' no W cal )', calfil )
	call gtext( 'Title', title )
	call igpar( 'Labelling: 0 none, 1 automatic', 1, ib,
     >	  i, i, i, i )
	call gparny( 'Fit of straight line', regr )
	call gparny( 'Color plot', farbe )
	call gpar( 'Scale factors (x,y)', 2, fx, fy,
     >	  i, i, i )
	call igpar( 'Which element (e.g., 2600: Fe I; 0: everything )',
     >    1, ielep, i, i, i, i )
	call gpar( 'Eps min, max', 2, epsmin, epsmax, i, i, i )
	call gpclos

C ***
C ***	Read Wlam min,max from DCL symbols
C ***
C ***		ABUPLT$X_MIN, ABUPLT$X_MAX
C ***
C ***	VAX specific!
C ***
        wlmin = 0.
	wlmax = 200.
	if( lamwlam ) then
	   wlmin = -6.5
	   wlmax = -3.
	end if
	chimin = -0.1
	chimax = 10.1
     	iret = 0
	call lib$get_symbol( 'ABUPLT$X_MIN', symbol, iret )
	if( iret .gt. 0 ) then
	   read( symbol(:iret), * ) wlmin
	   if( .not.equplt ) chimin = wlmin
	end if
	iret = 0
	call lib$get_symbol( 'ABUPLT$X_MAX', symbol, iret )
	if( iret .gt. 0 ) then
	   read( symbol(:iret), * ) wlmax
	   if( .not.equplt ) chimax = wlmax
	end if
	   
	ident = ' '

	iltit = idx( title )
	miltit = min( iltit + 3, 120 )
	iltit = min( miltit + 23, 120 )
	title( miltit: ) = '&n'//date
	tit = title                        
	i = 1
	do j = 1, 112
	   if( tit(i:i) .eq. '&' ) then
	      if( tit(i+1:i+1) .eq. '&' .or. tit(i+1:i+1) .eq. '#' ) 
     >	        then
		 tit = tit( :i-1 )//tit( i+1: )
	      else 
	         tit = tit( :i-1 )//tit( i+2: )
	         i = i - 1
	      end if
	   else if( tit(i:i) .eq. '#' ) then
	      tit = tit( :i-1 )//tit( i+1: )
	      i = i - 1
	   end if
	   i = i + 1
	end do
	if( equplt ) then
	   dx = (wlmax - wlmin)/xl
	else
	   dx = (chimax - chimin)/xl
	end if
	dy = (epsmax - epsmin)/yl 

	cal = calfil .ne. ' '

	open( line_dat, file = 'LINE.DAT', status = 'old'
*     >        , readonly
     >      )
	open( for003, file = 'FOR003.DAT', status = 'old'
*     >        , readonly
     >      )
	open( eps_dat, file = 'EPS.DAT', status = 'new', iostat = ist
     >        ,form = 'print'
     >      )
	if( ist .ne. 0 ) open( eps_dat, file = 'EPS.DAT', status =
     >                         'unknown'
     >                         , form = 'print'
     >                       )
	if( cal ) open( cal_fil, file = calfil, status = 'old'
*     >                 , readonly
     >                )

	first = .true.
1	continue
	   read( for003, '(x,a)' ) lptzei
	   call grossb( lptzei, lptzei )
	   if( first ) then
	      if( index( lptzei, 'ATM-FEINANALYSE' ) .eq. 0 ) then
	         backspace for003
	         go to 11
	      end if
	      first = .false.
	   end if
	   if( index( lptzei, 'MICRO' ) .ne. 0 ) then
	      read( for003, '()' )
	      read( for003, '(57x, a5)' ) micro
	   end if	
	   if( index( lptzei, 'TEFF' ) .ne. 0 )
     >	     atm = lptzei(:1)//'&Teff&M'//lptzei(5:17)//'log g'//
     >	     lptzei(23:53)//'&Tsun&M'//lptzei(59:90)//
     >	     '#x#&Tmicro&M ='
!	   if( index( lptzei, 'Departure coefficient ident' ) .ne. 0 )
	   if( index( lptzei, 'DEPARTURE COEFF' ) .ne. 0 )
     >     then
	      read( for003, '(a)' ) lptzei
	      if( lptzei(:1) .eq. ' ' ) then	! skip CC char if necessary
                 ident = lptzei(2:)
	      else
	         ident = lptzei
	      end if
	   end if
	if( index( lptzei, '    ION  MULT   LAMBDA' ) .eq. 0 ) go to 1
	new_form(for003) = index( lptzei, 'LGC4' ) .ne. 0

	new_form(cal_fil) = .false.
	if( cal ) then
8	   continue
	      read( cal_fil, '(x,a)' ) lptzei
	      call grossb( lptzei, lptzei )
	   if( index( lptzei, '    ION  MULT   LAMBDA' ) .eq. 0 ) 
     >	     go to 8
	   new_form(cal_fil) = index( lptzei, 'LGC4' ) .ne. 0
	end if

	atm( idx(atm) + 1: ) = micro
11	continue
 	call pltbg( 1, idev, fx*(xl + 4.5), fy*(yl + 5.) )
        call pltsyn( .true. )
 	call dfact( fx, fy )
 	call plot( 3.25, 2.05, -3 )
 	call cplot( 0.5, 0.5, 997 )
 	call cplot( xl-.5, yl-.5, 998 )

	read( line_dat, * ) i
	read( line_dat, * ) ( j, k = 1, i )
	kma = 1
C ***
C ***
C ***	Start des eigentlichen Einlesens fr jede Linie
C ***	LINE.DAT Teil 2
C ***
C ***
C ***
3	read( line_dat, * ) ion1
	   if( ion1 .eq. 30 ) then
	      backspace line_dat
	      read( line_dat, * ) d, kma
	      kma_read = 0
	      do i = 1, kma_max
	         iblend( i ) = 0
	      end do
	   else if( ion1 .eq. -5 ) then
	      go to 99
	   end if
	   if( kma .gt. 1 ) then
	      blend = 'B'
	   else
	      blend = ' ' 
	   end if
	if( ion1 .lt. 98 ) go to 3
	backspace line_dat
C ***
C ***	berspringen von Leerzeilen, NLTE etc. in FOR003.DATs (Daten und
C ***	Calfile
C ***
	ife = for003
	if( cal ) ife = cal_fil
	do if = for003, ife, 2
2	   read( if, '(a)' ) lptzei
	   call grossb( lptzei, lptzei )
	   if( lptzei .eq. ' ' .or. lptzei(:9) .eq. '  NON-LTE' .or. 
     >	     lptzei(:8) .eq. '  LEVEL:' .or. lptzei .eq. '1' .or.
     >	     index( lptzei, '    ION  MULT   LAMBDA' ) .ne. 0 .or.
     >       index( lptzei, 'PAGE' ) .ne. 0 .or. 
     >       lptzei(2:11) .eq. '       102' ) go to 2
	   backspace if                     
	end do

7	continue
	   read( for003, '(a)' ) lptzei
	   call grossb( lptzei, lptzei )
	if( lptzei(:9) .eq. '  NON-LTE' .or. 
     >	  lptzei(:8) .eq. '  LEVEL:' .or. lptzei .eq. '1' .or.
     >	  index( lptzei, '    ION  MULT   LAMBDA' ) .ne. 0 .or.
     >    index( lptzei, 'PAGE' ) .ne. 0 ) go to 7
	if( .not.new_form(for003) ) then
	   read( lptzei, '(x, i10, i6, f10.3, f6.2, 57x, f7.3, f8.2)' ) 
     >	     ion, mult, lamda, chi, lggfe, wobs	
	else
	   read( lptzei, '(x, i10, i6, f10.3, f6.2, 42x, a5, 12x, f7.3,
     >       f8.2)' ) ion, mult, lamda, chi, micro, lggfe, wobs	
           atm(111:) = micro
	end if

	if( cal ) then
9	   read( cal_fil, '(a)' ) lptzei
	   call grossb( lptzei, lptzei )
	   if( lptzei(:9) .eq. '  NON-LTE' .or. 
     >	     lptzei(:8) .eq. '  LEVEL:' .or. lptzei .eq. '1' .or.
     >	     index( lptzei, '    ION  MULT   LAMBDA' ) .ne. 0 .or.
     >       index( lptzei, 'PAGE' ) .ne. 0 ) go to 9
	   if( .not.new_form(cal_fil) ) then
	      read( lptzei, '(x, i10, i6, f10.3, 78x, f8.2)' ) ion2,
     >	        mult2, lamda2, wcal
	   else
	      read( lptzei, '(x, i10, i6, f10.3, 72x, f8.2)' ) ion2,
     >	        mult2, lamda2, wcal
	   end if
	end if

	read( line_dat, * ) ion1, mult1, lamda1, d, lggf
	if( cal ) then
	   error = ion1 .ne. ion .or. mult1 .ne. mult .or. lamda1 .ne.
     >	     lamda .or. ion2 .ne. ion .or. mult2 .ne. mult .or. lamda2 
     >	     .ne. lamda .or. kma .gt. kma_max
	else
	   error = ion1 .ne. ion .or. mult1 .ne. mult .or. lamda1 .ne.
     >	     lamda .or. kma .gt. kma_max
	end if
	if( error ) then
 	   call pltend
	   if( kma .le. kma_max ) then
	      print '(x, a, /, t19, a, i10, x, 2i11, /, t18, a, i10, x, 
     >	        2i11, /, t16, a, f10.3, 2f11.3 )', 
     >	        'Error in input files:  LINE.DAT  FOR003.DAT  '//calfil,
     >	        'ION', ion, ion1, ion2, 'MULT', mult, mult1, mult2, 
     >	        'LAMBDA', lamda, lamda1, lamda2
	   else
	      print *, 'ABUPLT>> Error: Not more than ', kma_max, 
     >	        'blend lines.'
	   end if
	   stop 
	end if

	if( ion .ne. inum( numion ) ) then
	   do numion = 1, ionmax
	      if( ion .eq. inum( numion ) ) go to 4
	   end do
	   inum( ionmax ) = ion
	   numion = ionmax
	   ionmax = ionmax + 1
	end if

4	numion = min( nelem, numion )
C ***                
C ***	Wegfiltern von Blends
C ***
	iatom = ion/100
	if( kma_read .ge. kma ) then
	   kma_read = 0
	   do i = 1, kma_max
	      iblend( i ) = 0
	   end do
	end if
	kma_read = kma_read + 1
	do i = 1, kma_read
	   if( iatom .eq. iblend( i ) ) go to 3
 	end do
	iblend( kma_read ) = iatom
	if( kma .gt. 1 ) then
 	   if( kma_read .eq. 1 .and. (blend .eq. 'B') ) then
	      lptzei_read = 0
	      line_read = 1
71	      read( ife, '(a)' ) lptzei
	         call grossb( lptzei, lptzei )
	         lptzei_read = lptzei_read + 1

	      if( lptzei(:9) .eq. '  NON-LTE' .or. 
     >	        lptzei(:8) .eq. '  LEVEL:' .or. lptzei .eq. '1' .or.
     >	        index( lptzei, '    ION  MULT   LAMBDA' ) .ne. 0 ) 
     >	        go to 71

	         if( .not.new_form(ife) ) then
	            read( lptzei, '(97x, f8.2)' ) w
	         else
	            read( lptzei, '(99x, f8.2)' ) w
	         end if

	         line_read = line_read + 1
	      if( line_read .lt. kma ) go to 71
	      do i = 1, lptzei_read
	         backspace ife
	      end do
	   end if
 	else
 	   w = wobs
 	   if( cal ) w = wcal
 	end if

	lgeps = lggfe - lggf

	if( ielep .ne. 0 ) then
	   if( ion1 .ne. ielep ) go to 3
	end if

	if( mod(ip,42) .eq. 0 ) then 
	   write( eps_dat, '(2a)' ) '1', tit(:56)
           do i = 1, 132, 56
	      if( ident(i:min(i+55,132)) .ne. ' ' ) then
                 write( eps_dat, '(1x,a)' ) ident(i:min(i+55,132))
                 ip = ip + 1
	      end if
	   end do
	   if( cal ) then
	      write( eps_dat, 5 ) ' Teff', atm(9:35), 
     >	        '    Xi micro', atm(109:), 'cal'
	   else
	      write( eps_dat, 5 ) ' Teff', atm(9:35), 
     >	        '    Xi micro', atm(109:), 'obs'
	   end if
	end if
5	format( 4a,//,'        Ion  Mult    lambda lg gfe  ',
     >          'lg gf lg eps   W ', a, '  lg W/l',/ )
	write( eps_dat, 6 ) ion, mult, lamda, lggfe, lggf, lgeps, w,
     >                      log10(wobs*1e-3/lamda), blend
6	format( 1x, i10, i6, f10.3, 3f7.3, f8.2, f8.3, 3x, a )
	ip = ip + 1
	wobs = w
	if( lamwlam ) then
	   wobs = log10( wobs*1e-3/lamda )
	end if

	x( numion ) = x( numion ) + wobs
	xx( numion ) = xx( numion ) + wobs*wobs
 	xy( numion ) = xy( numion ) + wobs*lgeps
	y( numion ) = y( numion ) + lgeps
	yy( numion ) = yy( numion ) + lgeps*lgeps
	n( numion ) = n( numion ) + 1

	if( equplt ) then
	   xp = (wobs - wlmin)/dx
	else
	   xp = (chi - chimin)/dx
	end if
	yp = (lgeps - epsmin)/dy
 	if( farbe ) call newpen( numion + 1 )
 	call censym( xp, yp, numion + 8, .3, .3, 0. )
	xp = xp + 0.2
	yp = yp - 0.1
!d	if( ib .eq. 2 ) call gpos( xp, yp, xp, yp, idev )
 	if( ib .ne. 0 ) call number( xp, yp, .2, lamda, 0., 1 )

	go to 3

99	linhd = 6         
	ifree = mod(ip,42)
	if( ifree .eq. 0 ) ifree = 42
	ifree = dim( 42 - ifree, linhd )
	irem = dim( ionmax - 1, ifree )
	if( (ifree .gt. 3) .and. (irem .gt. 3 .or. irem .eq. 0) ) then
	   vor = '0'
	else
	   vor = '1'
	end if
	ip = 0
	do 14 i = 1, ionmax - 1
	   if( ( ielep .ne. 0 ) .and. ( inum(i) .ne. ielep ) .or. 
     >	     n(i) .eq. 0 ) go to 14
	   ielem = inum(i)/100
	   ionst = (float( inum(i) )/100. - float(ielem) )*100. + 1.5
	   if( ionst .le. 3 ) then
              do j = 1, ionst
                 roman(j:j) = 'I'
              end do
	   else if( ionst .eq. 4 ) then
	      roman = 'IV'
	   else if( ionst .eq. 5 ) then
	      roman = 'V'
	   else
	      roman = '***'
	   end if
	   yp = yl - 1. - i*0.5
	   elerom = elem( ielem )//' '//roman(:ionst)
 	   if( farbe ) call newpen( i + 1 )
 	   call censym( xl - 2.5, yp, i + 8, .3, .3, 0. )
 	   if( farbe ) then
 	      call newpen( 1 )
 	      if( i .eq. 1 ) call symblk( xl - 2., yp - 0.15, 0.3, 
     >	        elerom, 0., 3 + ionst )
 	   end if
 	   call symblk( xl - 2., yp - 0.15, 0.3, 
     >	     elerom, 0., 3 + ionst )

c ***	   Statistics

           if( n(i) .gt. 1 ) then
              sigeps = sqrt( dim( yy(i), y(i)*y(i)/n(i) )/(n(i)-1.) )
              if( xx(i) - x(i)*x(i)/n(i) .ne. 0. ) then
                 slope = ( xy(i) - x(i)*y(i)/n(i) )/( xx(i) -
     >             x(i)*x(i)/n(i) )
              else
                 slope =  reamax
              end if
           else
              slope =  reamax
              sigeps = 0.
           end if
	   b = ( y(i) - slope*x(i) )/n(i)
           epsmea = y( i )/n( i )

	   if( mod(ip,42) .eq. 0 ) then
	      if( .not.lamwlam ) then
	         write( eps_dat, 12 ) vor, tit(:56), 
     >	           ' Teff', atm(9:35), '    Xi micro', atm(109:)
	      else
	         write( eps_dat, 121 ) vor, tit(:56), 
     >	           ' Teff', atm(9:35), '    Xi micro', atm(109:)
	      end if
	      vor = '1'
	   end if
12	   format( 2a, /, 4a, //,
     >	   ' Ion    lg eps     s eps     m reg   n     [x]       [x^2]',
     >      / )
121	   format( 2a, /, 4a, //,
     >	   ' Ion    lg eps     s eps     m reg   n     [x]       [x^2]',
     >     /,
     >     '                        (lg EW/lam)',
     >      / )
	   write( eps_dat, 13 ) elerom, epsmea, sigeps, slope, n(i), y(i), 
     >	     yy(i)
13	   format( 1x, a, 1x, f6.2, '  +/-', f5.2, 1x, 1pe9.2, 1x, i3, 2x, 
     >	     0pf7.3, 1x, f10.4 )
	   ip =ip + 1
 	   if( regr .and. equplt ) then
 	      if( farbe ) call newpen( i + 1 )
 	      call cplot( 0., (yreg(wlmin) - epsmin)/dy, 3 )
 	      call cplot( xl, (yreg(wlmax) - epsmin)/dy, 2 )
 	   end if

14	continue
	if( cal ) then
	   method = 'cal'
	else
	   method = 'obs'
	end if
 	if( farbe ) call newpen( 1 )
 	if( equplt ) then
 	   if( lamwlam ) then
              call achse( 0., 0., 'log(W&T#l# '//method//'&M/#l#)', -21,
     >	                  xl, 0., wlmin, 0., wlmax )
 	   else
               call achse( 0., 0., 'W&T#l# '//method//'&M [mA]', -17,
     >	                   xl, 0., wlmin, 0., wlmax )
 	   end if
 	else
            call achse( 0., 0., '#c#&T low&M [eV]', -16, xl, 
     >	     0., chimin, 0., chimax )
 	end if
         call achse0( xl, 0., -1, yl, 90., epsmin, 0., epsmax )
 	if( equplt ) then
            call achse0( 0., yl, 1, xl, 0., wlmin, 0., wlmax )
 	else
            call achse0( 0., yl, 1, xl, 0., chimin, 0., chimax )
 	end if
         call achse( 0., 0., 'log&T10&M #e#', 13, yl, 90., epsmin, 0.,
     >	  epsmax )
 	ilatm = max( 1, idx( atm ) )
 	if( ilatm .gt. 80 ) then
 	   call symblk( 0., yl + 0.3, 0.3, atm(:80), 0., ilatm )
 	   call symblk( 999., 999., 0.3, atm(81:ilatm), 0., ilatm )
 	else
 	   call symblk( 0., yl + 0.3, 0.3, atm(:ilatm), 0., ilatm )
 	end if
 	ilatm = idx( ident )
 	if( ilatm .gt. 80 ) then
 	   call symblk( 0., yl + 0.8, 0.3, ident(:80), 0., ilatm )
 	   call symblk( 999., 999., 0.3, ident(81:ilatm), 0., ilatm )
           yl = yl + 0.5
 	else if( ilatm .gt. 0 ) then
 	   call symblk( 0., yl + 0.8, 0.3, ident(:ilatm), 0., ilatm )
 	   yl = yl + 0.5
 	end if
 	call symblk( 0., yl + 0.8, 0.3, title(:iltit), 0., iltit )
 	call pltend
	call exit(0)
	end
