        program aburel
c ***
c ******************************************************************************
c ***
c ***   Plottet Haeufigkeiten relativ zu einem Referenzstern:
c ***           log (gfeps / gfeps ref) vs. w obs
c ***
c ***   Input:  Referenzfile    ( FOR03.DAT von LINFOR )
c ***           Datenfile       ( FOR03.DAT von LINFOR )
c ***
c ***    1-MAR-1991 23:18:09.30
c ***
C ***
C ***	Modifications:
C ***
C ***	 2-FEB-1993 22:12:51.38		ML / UT Austin.  Added support for
C ***                                   new FOR003.DAT format from LINFIT.
C ***
C *** 	 6-SEP-1993 22:56:54.47	        ML / IoA Cambs.  Added printout of
C ***                                   DEPART.DAT id string
C ***
C *** 	10-FEB-1994 12:50:36.01		ML / IoA Cambs.  Fixed plotting of
C *** 					short id string.  Added call to
C *** 					gpclos.
C ***
C ***	14-APR-1994 22:04:22.00		ML / IoA Cambs.  DY wasn't set for
C ***					automatic scaling.
C ***
C ***    3-MAY-1994 10:58:01.00         ML / IoA Cambs.  Make it work for
C ***                                   hlinop lines.
C ***
C ***	 4-OCT-1994 20:06:42.00		ML / IoA.  Replaced $ with _ in
C ***                                   environment variable names.  First
C ***                                   try $ version, though.
C ***
C ***	31-OCT-1994 13:53:45.00		ML / IoA.  Made automatic limits
C ***					include all ions.  Was using
C ***					first stage only.
C ***
C ***	14-MAR-1996 15:00:17.45		ML / Bamberg.  Changed slope to 0
C ***                                   for single line case.  Was reamax
C ***                                   causing overflow.
C ***
C ***	 7-OCT-1997 18:20:04.21		ML / Bamberg.  Removed gpos.
C ***
C ***	15-JAN-1998 13:38:00.81		ML / Bamberg.  Changed roman numbers to
C ***					work if > 3.
C ***
C ***   28-NOV-2999 17:06:10.00		ML / McA.  Commented readonly in OPEN
C ***					for newer g77, which don't take it 
C ***					anymore; fixed a few formats: x -> 1x
C ***					Activated D lines to get plot.
C ***
c ******************************************************************************
c ***
        parameter( xl = 23., yl = 15. )
        parameter( maxlin = 100, maxion = 10 )
        parameter( reamax = 1.e38 )

        logical farbe, regr, first, equplt

        real lamda, lggfe, kma

        character lptzei*132, title*120, atm(2)*120, elem(58)*2,
     >    roman*3, micro*5, reffil*255, datfil*255, date*19, elerom*6,
     >    tit*112, filnam*255, moddef(2)*5, vor*1, symbol*255, ident*132

        dimension ion(maxlin,2), mult(maxlin,2), lamda(maxlin,2),
     >    lggfe(maxlin,2), chi(maxlin), wobs(maxlin,2), filnam(2),
     >    lin(2), sort(maxlin,4), w1(3), w2(3), ionchg(0:maxion),
     >	  kma(maxlin)
        dimension x( maxion ), xx( maxion ),
     >    xy( maxion ), y( maxion ), yy( maxion ), n( maxion )
	logical new_form(2)


        equivalence (filnam(1), reffil), (filnam(2), datfil), (lin(1),
     >    linref), (lin(2), lindat), (sort(1,2), wobs(1,1)),
     >    (sort(1,1), ion(1,2)), (sort(1,4), kma(1))

        data (sort(i,1), i = 1, maxlin)/ maxlin*1.e38 /
	data kma/ maxlin*0. /
        data elem/ 'H', 'He', 'Li', 'Be', 'B', 'C', 'N', 'O', 'F', 'Ne',
     >    'Na', 'Mg', 'Al', 'Si', 'P', 'S', 'Cl', 'Ar', 'K', 'Ca', 'Sc',
     >    'Ti', 'V', 'Cr', 'Mn', 'Fe', 'Co', 'Ni', 'Cu', 'Zn', 'Ga',
     >    'Ge', 'As', 'Se', 'Br', 'Kr', 'Rb', 'Sr', 'Y', 'Zr', 'Nb',
     >    'No', 'Tc', 'Ru', 'Rh', 'Pd', 'Ag', 'Cd', 'In', 'Sn', 'Sb',
     >    'Te', 'I', 'Xe', 'Cs', 'Ba', 'La', 'Ce' /
        data moddef/ 'Ref: ', 'Mod: ' /
        data ip/ 0 /
        data x/ maxion*0. /
        data xx/ maxion*0. /
        data xy/ maxion*0. /
        data y/ maxion*0. /
        data yy/ maxion*0. /
        data n/ maxion*0 /

        yreg(var) = slope*var + b

        call prgid( 'ABUREL', ' 14-MAR-1996 15:01:20.89' )
        call datum( date )
        call gpinit( 'aburel.cmd', ' ', 0, d, d, d, d, d )
	call gparny( 'Plot vs. Equivalent Width', equplt )
        call gfile( 'Reference file', reffil, '.DAT' )
        call gfile( 'Data file', datfil, '.DAT' )
        call gtext( 'Title', title )
	call gparny( 'Fit of straight line', regr )
	call igpar( 'Labelling: 0 none, 1 automatic', 1, ib,
     >	  i, i, i, i )
	call gparny( 'Color plot', farbe )
	call gpar( 'Scale factors (x,y)', 2, fx, fy,
     >	  i, i, i )
	call igpar( 'Which element (e.g., 2600: Fe I; 0: everything )',
     >    1, ielep, i, i, i, i )

	ident = ' '

	epsmin = -0.84375
	epsmax = 0.84375
	call gpar( 'Eps min, max /-0.84375, 0.84375/', 2, epsmin,
     >	  epsmax, i, i, i )
	call gpclos
	if( equplt ) then
	   wlmin = 0.
	   wlmax = 200.
	else
	   wlmin = -0.1
	   wlmax = 10.1
	end if
C ***
C ***	Read Wlam min,max from DCL symbols
C ***
C ***		ABUREL$X_MIN, ABUREL$X_MAX
C ***
C ***	VAX specific!
C ***
     	iret = 0
	call lib$get_symbol( 'ABUREL$X_MIN', symbol, iret )
        if( iret .eq. 0 ) then 	! try again
	   call lib$get_symbol( 'ABUREL_X_MIN', symbol, iret )
        end if
	if( iret .gt. 0 ) then
	   read( symbol(:iret), * ) wlmin
	end if
	iret = 0
	call lib$get_symbol( 'ABUREL$X_MAX', symbol, iret )
        if( iret .eq. 0 ) then 	! try again
	   call lib$get_symbol( 'ABUREL_X_MAX', symbol, iret )
        end if
	if( iret .gt. 0 ) then
	   read( symbol(:iret), * ) wlmax
	end if
C ***
        dx = (wlmin - wlmax)/xl

        iltit = idx( title )
        miltit = min( iltit + 3, 120 )
        iltit = min( miltit + 23, 120 )
        title( miltit: ) = '&n'//date
        tit = title
        i = 1
        do 100 j = 1, 112
           if( tit(i:i) .eq. '&' ) then
              if( tit(i+1:i+1) .eq. '&' .or. tit(i+1:i+1) .eq. '#' )
     >          then
                 tit(i:) = tit( i+1: )
              else
                 tit(i:) = tit( i+2: )
                 i = i - 1
              end if
           else if( tit(i:i) .eq. '#' ) then
              tit(i:) = tit( i+1: )
              i = i - 1
           end if
           i = i + 1
100     continue

        open( 21, file = reffil, status = 'old'
*     >        , readonly 
     >      )
        open( 22, file = datfil, status = 'old'
*     >        , readonly
     >      )
        open( 23, file = 'epsrel.dat', status = 'new', iostat = junk
*     >        ,form = 'print'
     >      )
	if( junk .ne. 0 ) open( 23, file = 'epsrel.dat', status = 'old'
*     >        ,form = 'print'
     >      )


c ***   Einlesen des Atmosphaerenteils soweit notwendig fuer beide Files:

        do 2 i = 21, 22
           first = .true.
1          read( i, '(x,a)' ) lptzei
           call grossb( lptzei, lptzei )
           if( first ) then
              if( index( lptzei, 'ATM-FEINANALYSE' ) .eq. 0 ) then
                 backspace i
                 go to 2
              end if
              first = .false.
           end if
           if( index( lptzei, 'MICRO' ) .ne. 0 ) then
              read( i, '()' )
              read( i, '(57x, a5)' ) micro
           end if
           if( index( lptzei, 'TEFF' ) .ne. 0 )
     >       atm(i-20) = lptzei(:1)//'&Teff&M'//lptzei(5:17)//'log g'//
     >       lptzei(23:53)//'&Tsun&M'//lptzei(59:90)//
     >       '#x#&Tmicro&M ='
           if( index( lptzei, 'DEPARTURE COEFF' ) .ne. 0 ) then
	      read( i, '(a)' ) lptzei
	      if( lptzei(:1) .eq. ' ' ) then
	         ident = lptzei(2:)
	      else
	         ident = lptzei
	      end if
	   end if
           if( index( lptzei, '    ION  MULT   LAMBDA' ) .eq. 0 )
     >       go to 1
	   new_form(i-20) = index( lptzei, 'LGC4' ) .ne. 0

           atm(i-20)( idx(atm(i-20)) + 1: ) = micro
2       continue


c ***   Linien einlesen

        do 101 j = 21, 22
           jj = j - 20
	   kma_line = 1
           do 102 i = 1, maxlin
3             read( j, '(a)', end = 4 ) lptzei
              call grossb( lptzei, lptzei )
              if( lptzei .eq. ' ' .or. lptzei(:9) .eq. '  NON-LTE'
     >          .or. lptzei(:8) .eq. '  LEVEL:' .or. lptzei .eq. '1'
     >          .or. index( lptzei, '    ION  MULT   LAMBDA' ) .ne. 0
     >          .or. index( lptzei, 'PAGE' ) .ne. 0 .or.
     >          lptzei(2:11) .eq. '       102' ) go to 3
              if( .not.new_form(jj) ) then
                 read( lptzei, '(x, i10, i6, f10.3, f6.2, 57x, f7.3,
     >                 f8.3 )' ) ion(i,jj), mult(i,jj), lamda(i,jj),
     >                 chi(i), lggfe(i,jj), wobs(i,jj)
              else
                 read( lptzei, '(x, i10, i6, f10.3, f6.2, 42x, a5, 12x,
     >                 f7.3, f8.3 )' ) ion(i,jj), mult(i,jj),
     >                 lamda(i,jj), chi(i), micro, lggfe(i,jj),
     >                 wobs(i,jj)
                 atm(jj)(111:) = micro
              end if
              if( ielep .ne. 0 ) then
                 if( ion(i,jj) .ne. ielep ) go to 3
              end if
              if( wobs(i,jj) .eq. 0. ) then
		 kma_line = kma_line + 1
              else
                 do 103 k = 1, kma_line - 1
                    wobs(i-k,jj) = wobs(i,jj)
103              continue
	         kma( i-kma_line+1 ) = kma_line
		 kma_line = 1
              end if
102        continue
           read( j, '(a)', end = 4 ) lptzei
           write( 6, * ) '%ARLFCL File', filnam(jj)(:idx(filnam(jj))),
     >       ' contains more lines than read in.'
4          close( j )
           lin( jj ) = i - 1
101     continue
        do 104 i = 1, lindat
           wobs(i,1) = 1234567890.
104     continue

c ***   Linien suchen und vergleichen.

        ip = 0
        do 105 i = 1, lindat
           do 106 j = 1, linref
              if( (ion(j,1) .eq. ion(i,2)) .and. (mult(j,1) .eq.
     >          mult(i,2)) .and. (lamda(j,1) .eq. lamda(i,2)) ) then
                 wobs(i,1) = lggfe(i,2) - lggfe(j,1)
                 if( mod(ip,42) .eq. 0 ) then
	            write( 23, '(2a)' ) '1', tit(:56)
	            do k = 1, 132, 56
	               if( ident(k:min(k+55,132)) .ne. ' ' ) then
	                  write( 23, '(1x, a)' ) ident(k:min(k+55,132))
                          ip = ip + 1
	               end if
	            end do
	            write( 23, 5 )
     >                moddef(2), 'Teff', atm(2)(9:35), '    Xi micro',
     >                atm(2)(109:), moddef(1), 'Teff', atm(1)(9:35),
     >                '    Xi micro', atm(1)(109:)
	         end if
                 write( 23, 6 ) ion(i,2), mult(i,2), lamda(i,2),
     >             wobs(i,1), wobs(i,2)
	         if( .not.equplt )  wobs(i,2) = chi(i)
                 mult( j, 1 ) = 99999999 ! Doppelident. verhindern
                 mult( i, 2 ) = 88888888 ! Doppelident. verhindern
                 ip = ip + 1
              end if
106        continue
105     continue
5       format( 1x,5a,/,1x,5a,//,'        Ion  Mult    lambda ',
     >    'lg eps/ref   W obs',/ )
6       format( 1x, i10, i6, f10.3, f11.3, f8.2 )

c ***   Sortieren

        do 107 i = 1, lindat
           sort(i,1) = ion(i,2)
107     continue
	ifail = 0
        call m01aef( sort, maxlin, 4, 1, w1, w2, ifail )
        oldion = sort(1,1)
        j = 1
        do 108 i = 1, lindat
           if( sort(i,1) .ne. oldion ) then
              ionchg(j) = i
              oldion = sort(i,1)
              j = min(j + 1, maxion)
           end if
108     continue
        ionchg(0) = 1
        ionchg(j) = lindat + 1

        linhd = 7
        ifree = mod(ip,42)
        if( ifree .eq. 0 ) ifree = 42
        ifree = dim( 42 - ifree, linhd )
        irem = dim( j, ifree )
        if( (ifree .gt. 3) .and. (irem .gt. 3 .or. irem .eq. 0) ) then
           vor = '0'
        else
           vor = '1'
        end if
        ip = 0

c ***   Plotten:
c ***   x - Array: wobs(i,2), i = 1, lindat. Ist gemessene Aequivalentbreite.
c ***   y - Array: wobs(i,1), i = 1, lindat. Ist lg ( eps/eps ref ).

        if( farbe ) then
           icol = 2
        else
           icol = 1
        end if
        sym = -9.

c ***   Erstes Ion

*** plot
       call pltbg( 1, idev, fx*(xl + 5.), fy*(yl + 5.) )
       call pltsyn( .true. )
       call dfact( fx, fy )
       call plot( 4., 2.05, -3 )
       if( equplt ) then
 	  lptzei = 'W&T#l# obs&M [mA]'
       else
 	  lptzei = '#c#&tlow&m [eV]'
       end if
 	if( epsmin .eq. epsmax ) then
 	   epsmin = 1e37
 	   epsmax = -1e37
 	   do i = 1, lindat
 	      epsmin = min( epsmin, wobs(i,1) )
 	      epsmax = max( epsmax, wobs(i,1) )
 	   end do
 	   h = epsmax - epsmin
 	   epsmax = epsmax + 0.1*h
 	   epsmin = epsmin - 0.1*h
 	end if
       call diagr( 0., 0., xl, yl, wlmin, wlmax, epsmin, epsmax,
     >          0., 0., lptzei,
     >	        'log&T10&M( #e#/#e#&tref&M )',
     >          ' ', 1, icol, wobs(1,2), wobs(1,1), ionchg(1)-1, sym )
*** end plot
        dy = (epsmax - epsmin)/yl
        do 109 i = 1, 2
           ilatm = idx( atm(i) )
*** plot
          call symblk( 0., yl + i*0.4, 0.28, moddef(i), 0., 5 )
          call symblk( 1.1, yl + i*0.4, 0.28, atm(i)(:min(80,ilatm)),
     >	    0., ilatm )
 	  if( ilatm .gt. 80 ) call symblk( 999., 999., 0.28,
     >	    atm(i)(81:ilatm), 0., ilatm )
*** end plot
109     continue
        ilatm = idx( ident )
	i = 3
        if( ilatm .gt. 80 ) then
*** plot
           call symblk( 0., yl + i*0.4, 0.28, ident(:80), 0., 80 )
           call symblk( 999., 999., 0.28, ident(81:ilatm), 0., ilatm )
*** end plot
	   i = i + 1
	else if( ilatm .gt. 0 ) then
*** plot
           call symblk( 0., yl + i*0.4, 0.28, ident(:ilatm), 0., ilatm )
*** end plot
	   i = i + 1
	else
           i = 2
	end if
*** plot
 	call symblk( 0., yl + i*0.4, 0.28, title(:min(80,iltit)), 0.,
     >	  iltit )
 	if( iltit .gt. 80 ) call symblk( 999., 999., 0.28,
     >	  title(81:iltit), 0., iltit )
*** end plot



c ***   Weitere Ionen

        do 110 i = 0, j - 1
           l = i + 1
           if( farbe ) then
              icol = icol + 1
*** plot
             call newpen( icol )
*** end plot
           end if
           sym = sym - 1.
           nn = ionchg(i+2) - ionchg(l)
*** plot
 	   if( nn .gt. 0 ) call over( wobs(ionchg(l),2),
     >       wobs(ionchg(l),1), nn, sym )
*** end plot

c ***      Beschriftung:  x Fe I / + Fe II etc.

           ielem = int(sort(ionchg(i),1))/100
           ionst = ( sort(ionchg(i),1)/100. - float(ielem) )*100. + 1.5
	   if( ionst .le. 3 ) then
              do k = 1, ionst
                 roman(k:k) = 'I'
              end do
	   else if( ionst .eq. 4 ) then
	      roman = 'IV'
	   else if( ionst .eq. 5 ) then
	      roman = 'V'
	   else
	      roman = '***'
	   end if
           yp = yl - 1. - i*0.5
           elerom = elem( ielem )//' '//roman(:ionst)
*** plot
           if( farbe ) call newpen( icol - 1 )
           call censym( xl - 2.5, yp, int(abs(sym+1)), .3, .3, 0. )
           if( farbe ) then
              call newpen( 1 )
              if( i .eq. 0 ) call symblk( xl - 2., yp - 0.15, 0.3,
     >                                    elerom, 0., 3 + ionst )
           end if
           call symblk( xl - 2., yp - 0.15, 0.3,
     >                  elerom, 0., 3 + ionst )
*** end plot

c ***      Statistik

           do 112 k = ionchg(i), ionchg(l) - 1
              if( wobs(k,1) .ne. 1234567890. .and. kma(k) .ne. 0. ) then
                 x( l ) = x( l ) + wobs(k,2)
                 xx( l ) = xx( l ) + wobs(k,2)*wobs(k,2)
                 xy( l ) = xy( l ) + wobs(k,2)*wobs(k,1)
                 y( l ) = y( l ) + wobs(k,1)
                 yy( l ) = yy( l ) + wobs(k,1)*wobs(k,1)
                 n( l ) = n( l ) + 1
              end if
112        continue
	   if( n(l) .gt. 0 ) then
              epsmea = y( l )/n( l )
              if( n(l) .gt. 1 ) then
                 sigeps = sqrt( (yy(l) - y(l)*y(l)/n(l))/(n(l)-1.) )
              else
                 sigeps = 0.
              end if
              if( xx(l) - x(l)*x(l)/n(l) .ne. 0. ) then
                 slope = ( xy(l) - x(l)*y(l)/n(l) )/( xx(l) -
     >             x(l)*x(l)/n(l) )
              else
                 slope =  0.
              end if
              b = ( y(l) - slope*x(l) )/n(l)
	   end if

           if( mod(ip,42) .eq. 0 ) then
              write( 23, 12 ) vor, tit(:56),
     >          moddef(2), 'Teff', atm(2)(9:35), '    Xi micro',
     >          atm(2)(109:), moddef(1), 'Teff', atm(1)(9:35),
     >          '    Xi micro', atm(1)(109:)
           end if
12         format( 2a, /, 1x, 5a, /, 1x, 5a, //,
     >     ' Ion    lg eps     s eps     m reg   n     [x]       [x^2]',
     >      / )
	   if( equplt ) then
              write( 23, 13 ) elerom, epsmea, sigeps, slope, n(l), y(l),
     >          yy(l)
13            format( 1x, a, 1x, f6.2, '  +/-', f5.2, 1x, 1pe9.2, 1x,
     >          i3, 2x, 0pf7.3, 1x, f10.4 )
	   else
              write( 23, 14 ) elerom, epsmea, sigeps, n(l), y(l),
     >          yy(l)
14            format( 1x, a, 1x, f6.2, '  +/-', f5.2, 12x, i3,
     >          2x, 0pf7.3, 1x, f10.4 )
	   end if
           ip =ip + 1
*** plot
           if( regr ) then
              if( farbe ) call newpen( icol - 1 )
              call cplot( 0., (yreg(wlmin) - epsmin)/dy, 3 )
              call cplot( xl, (yreg(wlmax) - epsmin)/dy, 2 )
           end if
*** end plot
110     continue
        if( ib .ne. 0 ) then
           do 113 i = 1, lindat
*** plot
              xp = xcm(wobs(i,2)) + 0.2
              yp = ycm(wobs(i,1)) - 0.1
!d            if( ib .eq. 2 ) call gpos( xp, yp, xp, yp, idev )
              call number( xp, yp, .2, lamda(i,2), 0., 1 )
*** end plot
113        continue
        end if
*** plot
        call pltend
*** end plot
        end
