      SUBROUTINE BACLRT(IID,C,icol)
C***********************************************************************
C
C-----------------------------------------------------------------------
C     COMPUTES COLLISION FREQUENCIES C(I,J) for Barium.
C     USES COLLISION CROSS-SECTIONS COLL(IC), COLNEU(IC) DEFINED BY COLS
C     INTEGRATES ENERGY RESOLVED CROSS-SECTIONS SCOLL/ECOLL AND SCOLLN/E
C ***
C ***		 14-MAY-1991 18:03:51.60
C ***
C ***	13-MAY-1995 17:19:10.00		ML / IoA.  Changed xp(zetah) to
C ***					zetah, include files.
C ***	29-APR-1996 18:08:42.17		ML / Bamberg.  New ion stuff.
C ***	17-MAY-1996 14:00:39.22		ML / Bamberg.  ICOL
C ***
C-----------------------------------------------------------------------
C


C ***
C ***	Arguments
C ***
	integer iid, icol
	real c(icol,icol)

      INCLUDE 'MOD_SIZ.INC'

      REAL NE, NHIO
C
      include 'NNS.INC'
      include 'MODEL.INC'
      INCLUDE 'POP.INC'
      include 'LEVEL.INC'
      include 'LINE.INC'

C--- NCOLL=(NLEVEL-OVER-2) LMAX=MAX. NUMBER OF TRANSITIONS WITH ENERGY R
C--- CROSS-SECTIONS NMAX=MAX. NUMBER OF POINTS IN ENERGY RESOLVED CROSS-
      INCLUDE 'COLIS.INC'
      DIMENSION X(NMAX),FX(NMAX),FINT(NMAX)
C
      DIMENSION UIJ(26),PSI2(26)
C
      DATA UIJ/1.0E-5,1.0E-4,1.0E-3,1.0E-2,1.0E-1,4.0E-1,1.0,1.5,2.0,
     1         3.0,4.0,6.0,8.0,10.0,12.0,14.0,16.0,18.0,20.0,22.0,
     2         24.0,26.0,28.0,30.0,40.0,50.0/
      DATA PSI2/1.116E+1,8.852,6.532,4.164,1.790,7.285E-1,2.210E-1,
     1          1.098E-1,6.130E-2,2.068E-2,6.914E-3,8.733E-4,1.139E-4,
     2          1.508E-5,2.010E-6,2.691E-7,3.611E-8,4.855E-9,6.534E-10,
     3          8.807E-11,1.188E-11,1.602E-12,2.163E-13,2.920E-14,
     4          1.315E-18,5.941E-23/
C
      XP(XX)=EXP(XX*2.30258)
      F00(W)=W*EXP(-W)
      F1(W,BE)=4.0*W/(1.0+W)*EXP(-W)*
     1         (1.0/(20.0+W)+ALOG((1.0+W)/W*1.25*BE))
      PSI(W)=(1.0+2.0/W)/(1.0+(1.08808E-3/W)**2.0)*EXP(-W)
C
      GG(A,CH,BE)=A*(BE+1.0)/(BE+CH)*SQRT(BE)
C
      ID=IID
      T=TEMP(ID)
      TEV=8.6171E-5*T
      NE=XP(PELG(ID))/T/1.38062E-16
      NHIO=2.0*RHO(ID)/AVEMAS*ZETAH(ID)
      ACON=NE*5.8875E-9*SQRT(TEV)*FELBB
      AICON=NE*5.8875E-9*SQRT(TEV)*FELBF
      BCON=NHIO*5.93095E-13*SQRT(TEV*WEI*(WEI+1.008))*FH1BB
      BICON=NHIO*5.93095E-13*SQRT(TEV*WEI*(WEI+1.008))*FH1BF
C
C--- INITIALIZE C-ARRAY ----
      DO 2 I=1,NK
      DO 1 J=1,NK
      C(I,J)=0.0
    1 CONTINUE
    2 CONTINUE
C
      IC=0
      DO 7 I=1,NL
      DO 6 J=1,NK
      IF(I.GE.J)GOTO 6
      IC=IC+1
C
      IF(J.GE.NXTION(I))GOTO 4
C--- BOUND-BOUND TRANSITIONS OF BA II AND BA III ---
      W=(EPS(J)-EPS(I))/TEV
C--- ELECTRON COLLISIONS ---
      IF(ICIND(IC).EQ.0)THEN
      IF(COLL(IC).LT.0.0)THEN
         A1=ACON*ABS(COLL(IC))*1.64*F00(W)
      ELSE IF(COLL(IC).GE.0.0)THEN
         DUM=MAP1(UIJ,PSI2,26,W,F2,1)
         A1=ACON*ABS(COLL(IC))*3.31*W*F2
      END IF
      ELSE IF(ICIND(IC).GT.0)THEN
      KMAX=NINT(ABS(COLL(IC)))
      DO 10 K=1,KMAX
      X(K)=ECOLL(ICIND(IC),K)
      EPSKT=ECOLL(ICIND(IC),K)/TEV
   10 FX(K)=EPSKT*EXP(-EPSKT)*SCOLL(ICIND(IC),K)
      CALL INTEGR(X,FX,FINT,KMAX,0.0)
      A1=6.342372E-7*NE/SQRT(T)*FINT(KMAX)*FELBB
      ELSE
      STOP 'ERR-01'
      END IF
C--- SPECIAL CROSS-SECTIONS (BORN-COULOMB CALCULATIONS OF SOBELMAN) ---
      IF(I.EQ.1 .AND. J.EQ.2)THEN
         A=0.498
         CHI=0.916
         XLL=1.0
      ELSE IF((I.EQ.3 .OR. I.EQ.4) .AND. J.EQ.5)THEN
         A=4.38
         CHI=0.212
         XLL=3.0
      ELSE IF((I.EQ.3 .OR. I.EQ.4) .AND. J.EQ.6)THEN
         A=23.4
         CHI=0.172
         XLL=3.0
      ELSE IF(I.EQ.5 .AND. J.EQ.6)THEN
         A=2.05
         CHI=0.828
         XLL=1.0
      ELSE
         GOTO 15
      END IF
C
      EE1=CHI_J(1)-EPS(J)
      EE0=CHI_J(1)-EPS(I)
      DE=EPS(J)-EPS(I)
      RYD=13.605
      QKAP=1.0
      VSIG=1.0E-8*(RYD/DE)**1.5*(EE1/EE0)**1.5*QKAP/XLL*
     1     EXP(-W)*GG(A,CHI,W)
      A1=NE*FELBB*VSIG
   15 CONTINUE
C
C--- NEUTRAL PARTICLE COLLISIONS ---
      IF(ICINDN(IC).EQ.0)THEN
      B1=BCON*COLNEU(IC)*PSI(W)
      ELSE IF(ICINDN(IC).GT.0)THEN
      KMAX=NINT(ABS(COLNEU(IC)))
      DO 11 K=1,KMAX
      X(K)=ECOLLN(ICINDN(IC),K)
      EPSKT=ECOLLN(ICINDN(IC),K)/TEV
   11 FX(K)=EPSKT*EXP(-EPSKT)*SCOLLN(ICINDN(IC),K)
      CALL INTEGR(X,FX,FINT,KMAX,0.0)
      B1=1.485515E-8*NHIO*SQRT(1.0/1.008+1.0/WEI)/SQRT(T)*FINT(KMAX)*
     1 FH1BB
      ELSE
      STOP 'ERR-02'
      END IF
      C(I,J)=A1+B1
      GOTO 5
C
C--- BOUND-FREE TRANSITIONS OF BA II AND BA III ---
    4 IF(I.LT.NXTION(1))THEN
      W=(CHI_J(1)-EPS(I)+EPS(J)+DI(I))/TEV
      BETA=1.25
      ELSE IF(I.GE.NXTION(1))THEN
      W=(CHI_J(2)-EPS(I)+DI(I))/TEV
      BETA=1.4
      END IF
C--- ELECTRON COLLISIONS ---
      IF(ICIND(IC).EQ.0)THEN
      A1=AICON*ABS(COLL(IC))*F1(W,BETA)
      ELSE IF(ICIND(IC).GT.0)THEN
      KMAX=NINT(ABS(COLL(IC)))
      DO 12 K=1,KMAX
      X(K)=ECOLL(ICIND(IC),K)
      EPSKT=ECOLL(ICIND(IC),K)/TEV
   12 FX(K)=EPSKT*EXP(-EPSKT)*SCOLL(ICIND(IC),K)
      CALL INTEGR(X,FX,FINT,KMAX,0.0)
      A1=6.342372E-7*NE/SQRT(T)*FINT(KMAX)*FELBF
      ELSE
      STOP 'ERR-03'
      END IF
C--- NEUTRAL PARTICLE COLLISIONS ---
      IF(ICINDN(IC).EQ.0)THEN
      B1=BICON*COLNEU(IC)*PSI(W)
      ELSE IF(ICINDN(IC).GT.0)THEN
      KMAX=NINT(ABS(COLNEU(IC)))
      DO 13 K=1,KMAX
      X(K)=ECOLLN(ICINDN(IC),K)
      EPSKT=ECOLLN(ICINDN(IC),K)/TEV
   13 FX(K)=EPSKT*EXP(-EPSKT)*SCOLLN(ICINDN(IC),K)
      CALL INTEGR(X,FX,FINT,KMAX,0.0)
      B1=1.485515E-8*NHIO*SQRT(1.0/1.008+1.0/WEI)/SQRT(T)*FINT(KMAX)*
     1 FH1BF
      ELSE
      STOP 'ERR-04'
      END IF
      C(I,J)=A1+B1
C
C--- SCALED DOWNWARD RATES ---
    5 C(J,I)=C(I,J)*N(ID,I)/N(ID,J)
C
    6 CONTINUE
    7 CONTINUE
C
      END
