	subroutine datum( dt )
c ***
c ******************************************************************************
c ***
c ***	Gibt das aktuelle Datum und Uhrzeit im VAX-Format dd-mmm-yy hh:mm:ss 
c ***	im String dt der Mindestlaenge 19 zurueck.
C ***
C ***	Sun version
c ***
c ***	 7-JAN-1991 22:00:14.23
C ***
C ***	Modifications:
C ***
C ***	29-SEP-1992 12:21:08.00		ML / UT Austin.  Added general
C ***                                   conversion of Unix dates to VAX format
C ***                                   and support for variable `precision'
C ***                                   depending on declared length of DT; see
C ***                                   VAX_DATE.
C ***	13-AUG-1997 19:59:59.44		ML / Bamberg.  Fortan 90 version.  All
C ***					standard now.
c ***
c ******************************************************************************
c ***
	implicit none
	character (len=*), intent(out) :: dt

	character vxdt*23

	call vax_date( vxdt )
	if( len(dt) .le. 19 ) then
	   dt = vxdt(:7)//vxdt(10:20)
	else if( len(dt) .le. 22 ) then
	   dt = vxdt(:20)
	else
	   dt = vxdt
	end if


	contains

	subroutine vax_date( dt )
	character (len=*) :: dt
	intrinsic date_and_time
	character :: date*8, time*10
	character (len=3), dimension(12), parameter :: month =
     >        (/'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug',
     >          'Sep', 'Oct', 'Nov', 'Dec' /)
	integer :: m

	call date_and_time( date, time )
	read( date(5:6), * ) m
	dt = date(7:8)//'-'//month(m)//'-'//date(:4)//' '//
     >        time(:2)//':'//time(3:4)//':'//time(5:9)
	end subroutine
	end subroutine
