        SUBROUTINE DN(DNI,DNJ,DZ,MODE,ITR)
C ***
C ******************************************************************************
C ***
C ***   Dimension of array DNDZ changed; should now be consistent with all the
C ***   other dimensioning.
C ***   Old value produced problems with Sven Stuerenburg's Carbon model.
C ***
C ***   Also comments and layout changed
C ***
C ***   10-JAN-1991 17:17:47.46                            M.L.
C ***
C ***   Modifications:
C ***
C ***   16-MAR-1993 02:09:20.96 Well, DNDZ was not properly dimensioned.  Try
C ***                           again.  Also, IMPLICIT NONE added.
C ***                           M. Lemke/UT Austin
C ***   16-MAR-1993 05:19:58.25 And DZ is crap, too.  But should be harmless,
C ***                           second dimension was off.  M. Lemke, UT/Austin
C ***	11-MAY-1995 20:38:08.00	ML / IoA.  Removed LABEL from /NNS/.  Was
C ***				inconsistent with rest of LINEAR.
C ***
C ******************************************************************************
C ***
        implicit none
C ***
C ***   Global variables
C ***
        include 'MOD_SIZ.INC'

        integer nl, nk, ndepth, nj, nt, nf1, low, up
        real gr
        common /nns/ nl, nk, ndepth, nj, nt, nf1(m_lines), low(m_lines),
     >               up(m_lines), gr(m_lines)

C ***
C ***   Arguments
C ***
        real dni( m_depth ), dnj( m_depth ), dz( m_depth, m_lines )
        integer mode, itr

C ***
C ***   Local variables
C ***
        integer f_dnidzt
        parameter( f_dnidzt = 22 )

        real dndz( m_lines, m_levels, m_depth ), sum1, sum2
        integer i, j, id, ik, il, it, ijt( m_levels ), itt, ntt1, ntt2
        save

C ***
C ***   Code
C ***
        go to ( 1, 2, 5, 5 ), mode
C ***                         ====
C ***

C ***
C ***   Vorbereitung, readin array
C ***
1       continue
        open( unit = f_dnidzt, file = 'DNIDZT', form = 'UNFORMATTED' )
        rewind f_dnidzt
        call re1( f_dnidzt, ijt, nk )
        do id = 1, ndepth
           do il = 1, nk
              ik = ijt(il)
              if( ik .gt. 0 ) call re1( f_dnidzt, dndz(1,ik,id), nt )
           end do
        end do
        rewind f_dnidzt
        close( f_dnidzt )
        return
C ***
C ***   Ableitung der Besetzungszahlen des unteren und oberen Niveaus
C ***   nach der net radiative bracket des Uebergangs I-J
C ***
2       continue
        it = itr
        i = ijt( low(it) )
        j = ijt( up(it) )
        do id = 1, ndepth
           dni(id) = dndz(it,i,id)
        end do
        do id = 1, ndepth
           dnj(id) = dndz(it,j,id)
        end do
        return
C ***
C ***   Summe der Ableitungen multipliziert mit Delta net radiative bracket
C ***   jedes Niveau nach jedem Uebergang ausser I-J
C ***   MODE = 4: Einschliesslich Uebergang I-J
C ***
5       continue
        it = itr
        i = ijt( low(it) )
        j = ijt( up(it) )
        ntt1 = it - 1
        ntt2 = ntt1 + 2
        if( mode .eq. 4 ) ntt2 = ntt1 + 1
        do id = 1, ndepth
           sum1 = 0.
           sum2 = 0.
           if( ntt1 .gt. 0 ) then
              do itt = 1, ntt1
                 sum1 = sum1 + dz(id,itt)*dndz(itt,i,id)
                 sum2 = sum2 + dz(id,itt)*dndz(itt,j,id)
              end do
           end if
           if( ntt2 .le. nt ) then
              do itt = ntt2, nt
                 sum1 = sum1 + dz(id,itt)*dndz(itt,i,id)
                 sum2 = sum2 + dz(id,itt)*dndz(itt,j,id)
              end do
           end if
           dni(id) = sum1
           dnj(id) = sum2
        end do
        return
        end
