      SUBROUTINE IONDIS(TEMP,PELE,MODE,IPRINT,PGAS,DENSNC)
C ***
C ******************************************************************************
C ***
C ***	25-APR-1996 17:28:27.76		ML / Bamberg.  Added 5th ion stage.
C ***	 2-DEC-1996 13:34:31.63		ML / Bamberg.  Fixed a few oversights
C ***					with 5th ion stage...
C ***   10-JUN-2004 22:04:00.00         ML / Stegauarch.  Error message for
C ***                                   missing input abundances.
C ***
C ***   $Id: iondis.f,v 1.2 2004/06/13 21:39:02 michael Exp $
C ***
C ******************************************************************************
C ***
      implicit none
C
C     Arguments
C
      INTEGER IPRINT, MODE
      REAL DENSNC, PELE, PGAS, TEMP

C ***
C *** Parameters
C ***
      real reamin
      PARAMETER( REAMIN = 1.E-37 )

C
C     Global variables
C
      include 'OPALION.INC'

      REAL ALN10, BOLTZK, CLIGHT, HPLANC
      COMMON /CONST/ ALN10, BOLTZK, HPLANC, CLIGHT

C
C     Local variables
C
      INTEGER I, I1, IATIJ(max_ion), IT, ITER, ITMA, J, J1, J2, J3, J4,
     >        j5, JA, JB, K
      REAL A, A1, A2, A3, A4, A5, A6, A7, ANORM, AS, B, DELTA, EFFMY,
     >     FRACEL, FRACJ2(max_ion), FRACJL(max_ion), FREEJ(max_ion),
     >     PNUC, SA, TH, TN, U, V, W, X, X1, X2, X3, X4, x5, Y, Z

C
C     Functions
C
      EXTERNAL NCHARG
      INTEGER NCHARG

C ***
C *** Data
C ***
      DATA FRACJ2 /max_ion*REAMIN/, FREEJ /max_ion*REAMIN/, 
     >     FRACJL /max_ion*REAMIN/


C ***
C *** Code
C ***
C
C     IONISATION RATIO SAHAJ:NJ/SUM(NJ),ELEMENT I
C     five STAGES PER ELEMENT:I,II,III,IV,V
C ***
      TH=5040./TEMP
      TN=-TH*ALN10
      JATI=0
      CALL QATI1(TEMP)
      IF(MODE.EQ.2)CALL QATI2(TEMP)
      CALL DCHI(TH,PELE)
      SA=1.2023E09/TH/TH/SQRT(TH)/PELE
      I1=JATI/5
      DO 10 I=1,I1
         J1=5*I-4
         J2=J1+1
         J3=J2+1
         J4=J3+1
         J5=J4+1
         K=NAMJ(J1)/100
         JIZ(K)=J1
         X1=PARTFJ(J1)
         X2=PARTFJ(J2)
         X3=PARTFJ(J3)
         X4=PARTFJ(J4)
         X5=PARTFJ(J5)
         A2=SA*EXP(TN*CHIJ(J1))/X1*X2
         A3=A2*SA*EXP(MAX(-400.,TN*CHIJ(J2)))/X2*X3
         A4=A3*SA*EXP(MAX(-400.,TN*CHIJ(J3)))/X3*X4
         A5=A4*SA*EXP(MAX(-400.,TN*CHIJ(J4)))/X4*X5
         AS=1.+A2+A3+A4+a5
         SAHAJ(J1)=1./AS
         SAHAJ(J2)=A2/AS
         SAHAJ(J3)=MAX(REAMIN,A3/AS)
         SAHAJ(J4)=MAX(REAMIN,A4/AS)
         SAHAJ(J5)=MAX(REAMIN,A5/AS)
   10 continue
C
C     NEGATIVE IONS:IONISATION RATIO SAHAJ,RENORMALISATION
      J=JATI
C     H MINUS
      J=J+1
      NAMJ(J)=-101
      CHIJ(J)=0.754
      PARTFJ(J)=1.
      J1=JIZ(1)
      A1=PARTFJ(J)/PARTFJ(J1)/SA/EXP(CHIJ(J)*TN)*SAHAJ(J1)
      X=1.+A1
      SAHAJ(J)=A1/X
      SAHAJ(J1)=SAHAJ(J1)/X
      SAHAJ(J1+1)=SAHAJ(J1+1)/X
C     C MINUS
      J=J+1
      NAMJ(J)=-601
      CHIJ(J)=1.25
      PARTFJ(J)=4.
      J1=JIZ(6)
      A1=PARTFJ(J)/PARTFJ(J1)/SA/EXP(CHIJ(J)*TN)*SAHAJ(J1)
      X=1.+A1
      SAHAJ(J)=A1/X
      SAHAJ(J1)=SAHAJ(J1)/X
      SAHAJ(J1+1)=SAHAJ(J1+1)/X
      SAHAJ(J1+2)=SAHAJ(J1+2)/X
      SAHAJ(J1+3)=SAHAJ(J1+3)/X
      SAHAJ(J1+4)=SAHAJ(J1+4)/X
C     O MINUS
      J=J+1
      NAMJ(J)=-801
      CHIJ(J)=1.46
      PARTFJ(J)=6.
      J1=JIZ(8)
      A1=PARTFJ(J)/PARTFJ(J1)/SA/EXP(CHIJ(J)*TN)*SAHAJ(J1)
      X=1.+A1
      SAHAJ(J)=A1/X
      SAHAJ(J1)=SAHAJ(J1)/X
      SAHAJ(J1+1)=SAHAJ(J1+1)/X
      SAHAJ(J1+2)=SAHAJ(J1+2)/X
      SAHAJ(J1+3)=SAHAJ(J1+3)/X
      SAHAJ(J1+4)=SAHAJ(J1+4)/X
      JNEGI=J
C
C     PARTITION FUNCTIONS:MOLECULES
C     DISSOCIATION CONSTANTS SAHAJ=P(A)*P(B)/P(AB)
      CALL QMOL(TEMP)
C
C     CROSS-REFERENCE TABLE IATIJ
C     ELEMENT INDEX I OF ATOM OR ION J
      DO 30 J=1,JNEGI
         J1=IABS(NAMJ(J))
         J2=(J1/100)*100
         DO 40 I=1,MAI
            IF(NAMI(I).EQ.J2)GO TO 31
   40    CONTINUE
         write( stdout, '()' )
         write( stdout, * ) 'IONDIS>> ERROR: No abundance found for ',
     >                      'element ', j2
         write( stdout, * ) '         Add it to file ABU'
         call exit
   31    IATIJ(J)=I
   30 continue
      J1=JNEGI+1
      DO 32 J=J1,JMOL2
         IATIJ(J)=0
   32 continue
C     ATOMIC WEIGHT OF ATOM OR ION J
      DO 36 J=1,JNEGI
         WTJ(J)=WTI(IATIJ(J))
   36 continue
C
C     STARTING GUESS FRACTIONAL ABUNDANCES
C     ATOMS,POS.IONS,ELECTRONS:MOLECULES AND NEG.IONS SUPPRESSED
      FRACEL=0.
      DO 50 J=1,JATI
         FRACJ(J)=SAHAJ(J)*FRACI(IATIJ(J))
         FRACEL=FRACEL+FRACJ(J)*NCHARG(NAMJ(J))
   50 continue
      PNUC=PELE/FRACEL
      J1=JATI+1
C     STARTING GUESS MOLECULES
      J1=JNEGI+1		! Hm, strange, cancelling line before...
      DO 70 J=J1,JMOL2
         CALL DECOM2(NAMJ(J),JA,JB)
         Z=FRACJ(JA)*FRACJ(JB)*PNUC/SAHAJ(J)
         FRACJ(J)=Z
         A=FRACI(IATIJ(JA))
         B=FRACI(IATIJ(JB))
         IF(Z.LT.A.AND.Z.LT.B)GO TO 70
C        SECOND GUESS IF MOLECULE FORMATION IS EXHAUSTIVE
         IF(JA.EQ.JB)GO TO 72
         IF(A.LE.B)GO TO 74
         GO TO 76
   72    J2=JA
         A1=SQRT(A/Z)/3.
         GO TO 78
   74    J2=JA
         A1=A/Z*0.5
         GO TO 78
   76    J2=JB
         A1=B/Z*0.5
         GO TO 78
   78    FRACJ(J2)=FRACJ(J2)*A1
         FRACJ(J2+1)=FRACJ(J2+1)*A1
         FRACJ(J2+2)=FRACJ(J2+2)*A1
         FRACJ(J2+3)=FRACJ(J2+3)*A1
         FRACJ(J2+4)=FRACJ(J2+4)*A1	! ?
         FRACJ(J)=FRACJ(JA)*FRACJ(JB)*PNUC/SAHAJ(J)
   70 CONTINUE
C     SECOND GUESS ELECTRONS,PNUC;ANORM
      FRACEL=0.
      ANORM=0.
      DO 80 J=1,JATI
         FRACEL=FRACEL+FRACJ(J)*NCHARG(NAMJ(J))
         ANORM=ANORM+FRACJ(J)
   80 continue
      J1=JNEGI+1
      DO 90 J=J1,JMOL2
         FRACEL=FRACEL+FRACJ(J)*NCHARG(NAMJ(J))
         ANORM=ANORM+2.*FRACJ(J)
   90 continue
      PNUC=PELE/FRACEL
C
C     MAXIMUM NUMBER OF ITERATIONS;CONVERGENCE CRITERION
      ITMA=30
      DELTA=0.01
C
C     FRACTIONAL ABUNDANCES FRACJ OF DIATOMIC MOLECULES
C     GIVEN FRACTIONAL ABUNDANCES FRACJ OF ATOMS
      IT=0
  100 ITER=0
      IT=IT+1
      J1=JNEGI+1
      DO 110 J=J1,JMOL2
         CALL DECOM2(NAMJ(J),JA,JB)
         FRACJ(J)=FRACJ(JA)*FRACJ(JB)*PNUC/SAHAJ(J)
  110 continue
C
C     FRACTIONAL ABUNDANCES FRACJ2 OF ATOMS AND POS.IONS
C     GIVEN FRACTIONAL ABUNDANCES FRACJ OF DIATOMIC MOLECULES
      DO 120 J=1,JATI
         I1=IATIJ(J)
         X=0.
         J2=JNEGI+1
         DO 130 J1=J2,JMOL2
            CALL DECOM2(NAMJ(J1),JA,JB)
            IF(IATIJ(JA).EQ.I1)X=X+FRACJ(J1)
            IF(IATIJ(JB).EQ.I1)X=X+FRACJ(J1)
  130    CONTINUE
         FREEJ(J)=MAX(1.-X/FRACI(I1),REAMIN)
         FRACJ2(J)=SAHAJ(J)*FRACI(I1)*FREEJ(J)
  120 CONTINUE
C     DUMMY FRACJ2,FREEJ FOR MOLECULES
      J1=JNEGI+1
      DO 140 J=J1,JMOL2
         FREEJ(J)=REAMIN
         FRACJ2(J)=REAMIN
  140 continue
C     FRACTIONAL ABUNDANCES FRACJ=FRACJ2 OF NEGATIVE IONS
C     GIVEN DISSOCIATION FRACTION FREEJ OF ATOMS
      J1=JATI+1
      DO 60 J=J1,JNEGI
         IF(IT.EQ.1)FRACJL(J)=REAMIN
         IF(IT.GT.1)FRACJL(J)=FRACJ(J)
         I1=IATIJ(J)
         J1=JIZ(NAMI(I1)/100)
         FREEJ(J)=FREEJ(J1)
         X=SAHAJ(J)*FRACI(I1)*FREEJ(J)
         FRACJ(J)=X
         FRACJ2(J)=X
   60 CONTINUE
C
C     CONVERGENCE CHECK (NEUTRAL ATOMS)
C     WHEN IT=1 CHECK IF FRACJ AND FRACJ2 AGREE
C     WHEN IT>1 CHECK IF FRACJ AND FRACJL (=FRACJ OF LAST IT.) AGREE
      IF(IT.EQ.ITMA)GO TO 151
      DO 150 J=1,JATI,5
         IF(IT.EQ.1)Z=FRACJ2(J)
         IF(IT.GT.1)Z=FRACJL(J)
         IF(Z.LE.REAMIN)GO TO 150
         IF(DELTA.LT.ABS(FRACJ(J)/Z-1.))ITER=1
  150 CONTINUE
  151 CONTINUE
C
C     ITERATION OF FRACTIONAL ABUNDANCES FRACJ:ATOMS,POS.IONS
C     THREE POSITIVE IONS PER NEUTRAL ATOM
      IF(ITER.nE.0) then
         Z=1.
         IF(TEMP.LT.3360..AND.PELE.GT.1.26)Z=0.1
         IF(TEMP.LT.3360..AND.PELE.GT.0.10)Z=0.3
         IF(TEMP.LT.5600..AND.PELE.GT.100.)Z=0.3
         J1=JATI-4
         DO 160 J=1,J1,5
            FRACJL(J)=FRACJ(J)
            FRACJL(J+1)=FRACJ(J+1)
            FRACJL(J+2)=FRACJ(J+2)
            FRACJL(J+3)=FRACJ(J+3)
            FRACJL(J+4)=FRACJ(J+4)
            U=FRACJ(J)
C           NEUTRAL ATOMS
            IF(U.LT.REAMIN)U=REAMIN
            V=FRACJ2(J)
            W=V/U
            X=FREEJ(J)
            IF(V.LT.REAMIN)GO TO 170
            IF(W.LT.2.)GO TO 172
            A1=FRACI(IATIJ(J))
            IF(W.LT.1.E-5.AND.A1.GT.0.2)GO TO 174
            IF(X.LT.0.2.AND.A1.LE.0.2)GO TO 174
            IF(A1.GT.0.2)GO TO 176
            IF(A1.LE.0.2.AND.X.LT.0.99)GO TO 177
            GO TO 178
  170       FRACJ(J)=U*0.95
            GO TO 180
  172       FRACJ(J)=U+(V-U)*X/1.5
            GO TO 180
  174       FRACJ(J)=U*(1.+Z*X)
            GO TO 180
  176       FRACJ(J)=U*(1.+1.5*X)
            GO TO 180
  177       FRACJ(J)=U*(1.+2.5*Z*X)
            GO TO 180
  178       FRACJ(J)=U*5.
            GO TO 180
  180       A=FRACJ(J)/FRACJL(J)
C           POSITIVE IONS
            FRACJ(J+1)=FRACJL(J+1)*A
            FRACJ(J+2)=FRACJL(J+2)*A
            FRACJ(J+3)=FRACJL(J+3)*A
            FRACJ(J+4)=FRACJL(J+4)*A
  160    CONTINUE
      end if
C
C     COLLECTIVE QUANTITIES,SOME SERVING AS INPUT FOR NEXT ITERATION
      FRACEL=0.
      PGAS=0.
      ANORM=0.
      DO 192 J=1,JNEGI
         FRACEL=FRACEL+FRACJ(J)*NCHARG(NAMJ(J))
         ANORM=ANORM+FRACJ(J)
  192 continue
      J1=JNEGI+1
      DO 200 J=J1,JMOL2
         FRACEL=FRACEL+FRACJ(J)*NCHARG(NAMJ(J))
         ANORM=ANORM+2.*FRACJ(J)
  200 continue
      IF(FRACEL.lt.REAMIN) then
         IF(IT.GT.3)FRACEL=REAMIN
         IF(IT.LE.3)FRACEL=ABS(FRACEL)*0.9
      end if
  210 PNUC=PELE/FRACEL
C     EXIT TO NEXT ITERATION
      IF(IT.LT.ITMA.AND.ITER.EQ.1)GO TO 100
      X=0.
      Y=0.
      DO 220 J=1,JMOL2
         A=FRACJ(J)
         ZETAJ(J)=A/PARTFJ(J)
         IF(A.LE.REAMIN)ZETAJ(J)=REAMIN
         X=X+A
         Y=Y+WTJ(J)*A
  220 continue
      X=X+FRACEL
      Y=Y+FRACEL/1822.
      PGAS=PNUC*X
      EFFMY=Y/X
      DENSNC=PNUC/BOLTZK/TEMP
      IF( IPRINT .Eq.2 ) then
C
C        PRINTOUT IONDIS
 9998    FORMAT(3X,5HTHETA,5X,4HTEMP,5X,6HLOG PE,4X,6HLOG PG,
     *   4X,6HLOG PN,5X,5HEFFMY,5X,5HANORM,2X,2HIT,6X,6HDENSNC)
 9997    FORMAT(1X,F7.4,F10.0,3F10.3,F10.4,F10.4,I4,1PE12.3/)
 9996    FORMAT(4X,1HJ,5X,4HNAMJ,7X,3HWTJ,6X,4HCHIJ,
     *   2X,8HL PARTFJ,3X,7HL SAHAJ,3X,7HL FRACJ,2X,8HL FRACJ2,3X,
     *   7HL FREEJ,2X,8HL FRACJL,3X,7HL ZETAJ,1X,5HIATIJ,1X,
     >   14HFREE EL CONTR./)
 9995    FORMAT(1X,I4,I9,9F10.3,I4,I7)
         WRITE(6,9998)
         A1 = LOG10( MAX( REAMIN, PELE ) )
         A2 = LOG10( MAX( REAMIN, PGAS ) )
         A3 = LOG10( MAX( REAMIN, PNUC ) )
         WRITE(6,9997)TH,TEMP,A1,A2,A3,EFFMY,ANORM,IT,DENSNC
         WRITE(6,9996)
         J=-1
         A2 = LOG10( REAMIN )
         A3=1./1823.
         A1=LOG10(FRACEL)
         WRITE(6,9995)J,J,A3,A2,A2,A2,A1
         DO 9901 J = 1, JMOL2
            A1 = LOG10( MAX( REAMIN, PARTFJ(J) ) )
            A2 = LOG10( MAX( REAMIN, SAHAJ(J) ) )
            A3 = LOG10( MAX( REAMIN, FRACJ(J) ) )
            A4 = LOG10( MAX( REAMIN, ZETAJ(J) ) )
            A5 = LOG10( MAX( REAMIN, FRACJ2(J) ) )
            A6 = LOG10( MAX( REAMIN, FREEJ(J) ) )
            A7 = FRACJL(J)
            IF( IT .EQ. 1 .OR. A7 .LE. REAMIN ) A7 = REAMIN
            A7 = LOG10( A7 )
            I = IATIJ(J)
            A = NCHARG(NAMJ(J))*FRACJ(J)/FRACEL*1000.
            K = IFIX(A)
            WRITE(6,9995) J, NAMJ(J), WTJ(J), CHIJ(J), A1, A2, A3, A5,
     >                    A6, A7, A4, I, K
 9901    CONTINUE
      end if
      END
