      SUBROUTINE MERSON(Y,YE)
C   INTEGRATES THE SYSTEM OF DIFFERENTIAL EQUATIONS:
C   D LOG(P) / D LOG(TAU) = Z(LOG(TAU),LOG(P),R)
C   D R/D LOG(TAU)        = F(LOG(TAU),LOG(P))
      COMMON/CONST/ALN10,BOLTZK,HPLANC,CLIGHT
        INCLUDE 'INT.INC'
C
      DIMENSION Y(8),YE(8),W(8),Y0(8)
C
      LOGICAL INCR,FIRST
C
      HC=YE(4)-Y(4)
      NLOC=1
      LOC=0
      EPS=.001
      FIRST=.TRUE.
      DO 1 K=1,8
    1 Y0(K)=Y(K)
  100 DO 2 K=1,8
    2 W(K)=Y0(K)
      IF( .NOT. FIRST ) GOTO 13
      AK=EXP(ALN10*W(6))+EXP(ALN10*W(7))
      F0=-ALN10*EXP(ALN10*W(4))/(AK*W(8))
   13 Z0=Z(W)
      Y1=Y0(1)+HC*Z0/3.
      RR1=Y0(5)+HC*F0/3.
      W(1)=Y1
      W(5)=RR1
      W(4)=Y0(4)+HC/3.
      CALL FIT(W)
      F1=F(W)
      Z1=Z(W)
      Y1=Y0(1)+HC*Z0/6.+HC*Z1/6.
      RR1=Y0(5)+HC*F0/6.+HC*F1/6.
      W(1)=Y1
      W(5)=RR1
      CALL FIT(W)
      F1=F(W)
      Z1=Z(W)
      Y1=Y0(1)+HC*Z0/8.+3.*HC*Z1/8.
      RR1=Y0(5)+HC*F0/8.+3.*HC*F1/8.
      W(1)=Y1
      W(5)=RR1
      W(4)=Y0(4)+HC/2.
      CALL FIT(W)
      F2=F(W)
      Z2=Z(W)
      Y1=Y0(1)+HC*Z0/2.-3.*HC*Z1/2.+2.*HC*Z2
      RR1=Y0(5)+HC*F0/2.-3.*HC*F1/2.+2.*HC*F2
      W(1)=Y1
      W(5)=RR1
      W(4)=Y0(4)+HC
      CALL FIT(W)
      F1=F(W)
      Z1=Z(W)
      Y2=Y0(1)+HC*Z0/6.+2.*HC*Z2/3.+HC*Z1/6.
      RR2=Y0(5)+HC*F0/6.+2.*HC*F2/3.+HC*F1/6.
      INCR=.TRUE.
      ERROR=ABS(.2*(Y1-Y2))
      IF(ERROR.LE.EPS)GOTO 30
      FIRST=.TRUE.
      HC=HC/2.
      NLOC=NLOC*2
      LOC=LOC*2
      GOTO 100
   30 IF(64.*ERROR.GT.EPS)INCR=.FALSE.
      LOC=LOC+1
      NSTEP=NSTEP+1
      FIRST=.FALSE.
      Y0(4)=Y0(4)+HC
      Y0(1)=Y2
      Y0(5)=RR2
      Y0(3)=W(3)
      CALL FIT(Y0)
      F0=F(Y0)
      IF(LOC.EQ.NLOC)GOTO 50
      LLOC=LOC/2
      IF(INCR.AND.(LOC.EQ.2*LLOC))GOTO 40
      GOTO 100
   40 HC=2.*HC
      LOC=LLOC
      NLOC=NLOC/2
      GOTO 100
   50 DO 20 K=1,8
   20 YE(K)=Y0(K)
      RETURN
      END
