*From:  UTADNX::UTSPAN::OZ::GIGAS        "Detlef Gigas, NASA Goddard Space Flight Center" 21-MAY-1992 13:45:51.98
*To:    UTSPAN::UTADNX::IO::MICHAEL
*CC:    
*Subj:  COLRAT.FOR
*
      SUBROUTINE MGCLRT(IID,C,icol)
C***********************************************************************
C
C-----------------------------------------------------------------------
C     COMPUTES COLLISION FREQUENCIES C(I,J)
C     USES COLLISION CROSS-SECTIONS COLL(IC), COLNEU(IC) DEFINED BY COLS
C     INTEGRATES ENERGY RESOLVED CROSS-SECTIONS SCOLL/ECOLL AND SCOLLN/E
C     COLRAT IS CALLED ONCE FOR EACH DEPTH POINT
C ***
C *** Modified common blocks to match current version
C ***
C *** ML / UT Austin    21-MAY-1992 22:47:32.67
C ***	13-MAY-1995 17:43:40.00		ML / IoA.  Include files, zetah
C ***	 8-MAR-1996 13:04:02.54		ML / Bamberg.  Fixed bug leftover
C ***                                   from ENCODE/DECODE conversion.
C ***	29-APR-1996 16:48:19.21		ML / Bamberg.  New ion stuff.
C ***	17-MAY-1996 13:58:08.69		ML / Bamberg.  ICOL
C ***
C-----------------------------------------------------------------------
C

C ***
C ***	Arguments
C ***
	integer iid, icol
	real c(icol,icol)

      INCLUDE 'MOD_SIZ.INC'               
      REAL A(11,10,44), CHI(11,10,44)
      REAL NE,NHIO,NE0,NE1,NEFF(10),DNEFF(44)
      LOGICAL IEX1,IEX2,JEX1,JEX2,INTCOM,ALLOWD
      character*4 intern
C
      include 'LINE.INC'
      include 'NNS.INC'
      include 'MODEL.INC'
      include 'LEVEL.INC'
      INCLUDE 'POP.INC'
C
C--- NCOLL=(NLEVEL-OVER-2) LMAX=MAX. NUMBER OF TRANSITIONS WITH ENERGY R
C--- CROSS-SECTIONS NMAX=MAX. NUMBER OF POINTS IN ENERGY RESOLVED CROSS-
C
      INCLUDE 'COLIS.INC'
C
      DIMENSION X(NMAX), FX(NMAX), FINT(NMAX)
C
      SAVE IREAD, A, CHI
C
      DIMENSION UIJ(26),PSI2(26),PSI3(26)
C
      DATA CHIHYD/13.60583/
      DATA IREAD/0/
C
      DATA UIJ/1.0E-5,1.0E-4,1.0E-3,1.0E-2,1.0E-1,4.0E-1,1.0,1.5,2.0,
     1         3.0,4.0,6.0,8.0,10.0,12.0,14.0,16.0,18.0,20.0,22.0,
     2         24.0,26.0,28.0,30.0,40.0,50.0/
C
      DATA PSI2/1.116E+1,8.852,6.532,4.164,1.790,7.285E-1,2.210E-1,
     1          1.098E-1,6.130E-2,2.068E-2,6.914E-3,8.733E-4,1.139E-4,
     2          1.508E-5,2.010E-6,2.691E-7,3.611E-8,4.855E-9,6.534E-10,
     3          8.807E-11,1.188E-11,1.602E-12,2.163E-13,2.920E-14,
     4          1.315E-18,5.941E-23/
C
      DATA PSI3/ 6.6655E-6, 6.6575E-5, 6.5983E-4, 6.2129E-3, 4.3480E-3,
     1           8.0092E-2, 6.2433E-2, 4.0640E-2, 2.5022E-2, 8.9304E-3,
     2           3.0993E-3, 3.6726E-4, 4.3720E-5, 5.2614E-6, 6.3984E-7,
     3           7.8568E-8, 9.7264E-9, 1.2126E-9, 1.521E-10, 1.918E-11,
     4           2.429E-12, 3.089E-13, 3.942E-14, 5.049E-15, 1.818E-19,
     5           6.760E-24/
C
      DATA NEFF/0.5,1.0,1.5,2.0,2.5,3.0,3.5,4.0,4.5,5.0/
C
      DATA DNEFF/0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,
     1           1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,
     2           2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,
     3           3.1,3.2,3.3,3.4,3.5,3.6,3.7,3.8,3.9,4.0,
     4           4.1,4.2,4.3,4.4/
C
      XP(XX)=EXP(XX*2.30258)
      F0(W) = 4.0 * W * (EXP(-W) - W*EXPINT(W))
      F00(W) = W * EXP(-W)
      F1(W,BE)=4.0*W/(1.0+W)*EXP(-W)*
     1         (1.0/(20.0+W)+ALOG((1.0+W)/W*1.25*BE))
      PSI(W)=(1.0+2.0/W)/(1.0+(1.08808E-3/W)**2.0)*EXP(-W)
C
      G0(W,AA,CH) = AA * SQRT(W*(W+3.0)) / (W+CH)
      G1(W,AA,CH) = AA * SQRT(W*(W+3.0)) / (W+CH) * ALOG(16.0 + 1.0/W)
      G7(W,AA,CH) = AA * W**1.5 / SQRT(W+1.0) / (W+CH)
C
      ID=IID
      T=TEMP(ID)
      TEV=8.6171E-5*T
      NE=XP(PELG(ID))/T/1.38062E-16
      NHIO=2.0*RHO(ID)/AVEMAS*ZETAH(ID)
C
      ACON=NE*5.8875E-9*SQRT(TEV)*FELBB
      AICON=NE*5.8875E-9*SQRT(TEV)*FELBF
      BCON=NHIO*5.93095E-13*SQRT(TEV*WEI*(WEI+1.008))*FH1BB
      BICON=NHIO*5.93095E-13*SQRT(TEV*WEI*(WEI+1.008))*FH1BF
C
C
C--- INITIALIZE COLLISION-ARRAY ---
      DO 2 I=1,NK
      DO 1 J=1,NK
      C(I,J)=0.0
    1 CONTINUE
    2 CONTINUE
C
C--- READ IN BORN DATA (SOBELMAN-TABLE) ---
      IF (IREAD.EQ.1) GOTO 3
      OPEN(UNIT=3,FILE='BORNDAT')
      REWIND 3
      DO 4 K=1,11
      READ(3,*) ((A(K,I,J),I=1,10),J=1,44)
      READ(3,*) ((CHI(K,I,J),I=1,10),J=1,44)
    4 CONTINUE
      CLOSE(3)
      IREAD=1
C
C
C
    3 IC=0
C=== LOOP OVER ALL POSSIBLE TRANSITIONS STARTS HERE ====================
C
      DO 7 I=1,NL
      DO 6 J=1,NK
C
      IF(I.GE.J) GOTO 6
      IC=IC+1
C
C
C$$$ BOUND-BOUND COLLISIONS OF MG I $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C    ==============================
C
C*** ELECTRON COLLISIONS ***********************************************
C    -------------------
C
      IF (I.LT.NXTION(1) .AND. J.LT.NXTION(1)) THEN
C
         W=(EPS(J)-EPS(I))/TEV
C
C+++++++ INTEGRATION OF ENERGY-RESOLVED CROSS-SECTION +++++
C
    8    IF (ICIND(IC).GT.0) THEN
            KMAX=NINT(ABS(COLL(IC)))
            DO 10 K=1,KMAX
            X(K)=ECOLL(ICIND(IC),K)
            EPSKT=ECOLL(ICIND(IC),K)/TEV
   10       FX(K)=EPSKT*EXP(-EPSKT)*SCOLL(ICIND(IC),K)
            CALL INTEGR(X,FX,FINT,KMAX,0.0)
            A1=6.342372E-7*NE/SQRT(T)*FINT(KMAX)*FELBB
C
C+++++++ COLLISION RATES WITH GIVEN THRESHOLD CROSS-SECTIONS +++++
C
         ELSE IF (ICIND(IC).EQ.0) THEN
C.......... DETERMINE DELTA S .....
            write( intern, '(a4)' ) LABEL(I)
	    read( intern, 100 ) MI
            write( intern, '(a4)' ) LABEL(j)
	    read( intern, 100 ) Mj
  100       FORMAT(3X,I1)
            INTCOM=.TRUE.
            IF( (MI-MJ).EQ.0 .OR. MI.EQ.4 .OR. MJ.EQ.4) INTCOM=.FALSE.
            ALLOWD=.TRUE.
            IF (COLL(IC).LT.0.0) ALLOWD=.FALSE.
C.......... OPTICALLY ALLOWED TRANSITIONS .....
            IF (ALLOWD) THEN
               A1=ACON*0.8278*ABS(COLL(IC))*F1(W,1.0)
C.......... OPTICALLY DISALLOWED TRANSITIONS WITH DELTA S = 0 .....
            ELSE IF (.NOT.ALLOWD .AND. .NOT.INTCOM) THEN
               A1=ACON*ABS(COLL(IC))*F0(W)
C.......... OPTICALLY DISALLOWED WITH DELTA S.NE.0,
C                                FROM GROUND STATE .....
            ELSE IF (.NOT.ALLOWD .AND. INTCOM .AND. I.EQ.1) THEN
               DUM=MAP1(UIJ,PSI3,26,W,F3,1)
               A1=ACON*5.38*ABS(COLL(IC))*W*F3
C.......... OPTICALLY DISALLOWED WITH DELTA S.NE.0,
C                                NOT FROM GROUND STATE .....
            ELSE IF (.NOT.ALLOWD .AND. INTCOM .AND. I.NE.1) THEN
               A1=ACON*ABS(COLL(IC))*F00(W)
            END IF
C
C+++++++ COLLISION RATES TO BE COMPUTED FROM BORN-TABLES +++++
C
         ELSE IF (ICIND(IC).EQ.-1) THEN
C
C.......... PREPARATION OF COMPUTATION .....
            LI=LGET(LABEL(I))
            LJ=LGET(LABEL(J))
C
C.......... CHECK WHETHER DATA ARE AVAILABLE FOR BOTH L-VALUES .....
            IF (LI.EQ.0 .AND. LJ.EQ.0) THEN
               KAP1=0
               KAP2=-99
               ITAB1=1
               ITAB2=-99
            ELSE IF (LI.EQ.0 .AND. LJ.EQ.1) THEN
               KAP1=1
               KAP2=-99
               ITAB1=2
               ITAB2=-99
            ELSE IF (LI.EQ.0 .AND. LJ.EQ.2) THEN
               KAP1=2
               KAP2=-99
               ITAB1=3
               ITAB2=-99
            ELSE IF (LI.EQ.1 .AND. LJ.EQ.0) THEN
               KAP1=1
               KAP2=-99
               ITAB1=4
               ITAB2=-99
            ELSE IF (LI.EQ.1 .AND. LJ.EQ.1) THEN
               KAP1=0
               KAP2=2
               ITAB1=5
               ITAB2=6
            ELSE IF (LI.EQ.1 .AND. LJ.EQ.2) THEN
               KAP1=1
               KAP2=3
               ITAB1=7
               ITAB2=8
            ELSE IF (LI.EQ.2 .AND. LJ.EQ.0) THEN
               KAP1=2
               KAP2=-99
               ITAB1=9
               ITAB2=-99
            ELSE IF (LI.EQ.2 .AND. LJ.EQ.1) THEN
               KAP1=1
               KAP2=3
               ITAB1=10
               ITAB2=11
            ELSE
               STOP 'ERR-000'
            END IF
C
C.......... SET GEOMETRIC FORM FACTORS QKAP .....
            IF (I.EQ.1) THEN
               QKAP1=2.0
               QKAP2=0.0
            ELSE
               QKAP1=1.0
               QKAP2=1.0
            END IF
C
C.......... DETERMINE EFFECTIVE QUANTUM NUMBERS .....
            NE0=SQRT(CHIHYD/(CHI_J(0) -EPS(I)))
            NE1=SQRT(CHIHYD/(CHI_J(0) -EPS(J)))
            DNE=NE1-NE0
            DEPS=EPS(J)-EPS(I)
            FACTOR=1.0E-8 * (CHIHYD/DEPS)**1.5 *
     1             ((CHI_J(0) -EPS(J))/(CHI_J(0) -EPS(I)))**1.5 *
     2             EXP(-W) / (2.0*FLOAT(LI)+1.0)
C
C.......... SET DEFAULT EXTRAPOLATION INDICES .....
            IEX1=.FALSE.
            IEX2=.FALSE.
            JEX1=.FALSE.
            JEX2=.FALSE.
C
C.......... DETERMINE IF EXTRAPOLATION CAN BE PERFORMED .....
            IF ( (NE0.LE.FLOAT(LI)) .OR. (NE0.GE.5.5) .OR.
     1           (DNE.LE.0.0) .OR. (DNE.GE.5.0) .OR.
     2           (NE1.LT.FLOAT(LJ)+0.1 .AND. LI.LT.LJ) ) THEN
               ICIND(IC) = 0
               GOTO 8
            END IF
C
C.......... FIND POSITION IN TABLE .....
            IPOS=ISRCHFGE(10,NEFF,1,NE0)
            JPOS=ISRCHFGE(44,DNEFF,1,DNE)
            IP1=IPOS
            IP2=IPOS
            JP1=JPOS
            JP2=JPOS
C
C.......... SET EXTRAPOLATION PARAMETERS .....
            IF (NE0.GT.LI .AND. NE0.LE.LI+0.5) THEN
               IP1=2*LI+2
               IP2=2*LI+2
               IEX1=.TRUE.
               IEX2=.TRUE.
            END IF
            IF (LI.LT.LJ) THEN
               IF(NE1.LE.FLOAT(LJ)+1.1 .AND. NE1.GT.FLOAT(LJ)+0.6) THEN
                  IF (A(ITAB1,IPOS-1,JPOS).EQ.0.0) THEN
                     IP1=IPOS+1
                     IP2=IPOS+1
                     IEX1=.TRUE.
                     IEX2=.TRUE.
                  ELSE
                     IP1=IPOS
                     IP2=IPOS
                  END IF
               ELSE IF (NE1.LE.FLOAT(LJ)+0.6 .AND.
     1                  NE1.GT.FLOAT(LJ)+0.1) THEN
                  IF (A(ITAB1,IPOS,JPOS).EQ.0.0) THEN
                     IP1=IPOS+2
                     IP2=IPOS+2
                  ELSE
                     IP1=IPOS+1
                     IP2=IPOS+1
                  END IF
                  IEX1=.TRUE.
                  IEX2=.TRUE.
               END IF
               IF (DNE.GT.0.0 .AND. DNE.LT.0.1) THEN
                  JP1=2
                  JP2=2
                  JEX1=.TRUE.
                  JEX2=.TRUE.
               END IF
            ELSE IF (LI.EQ.LJ) THEN
               IF (LI.EQ.0) THEN
                  IF (DNE.GT.0.0 .AND. DNE.LE.0.6) THEN
                     JP1=7
                     JP2=7
                     JEX1=.TRUE.
                     JEX2=.TRUE.
                  END IF
               ELSE IF (LI.EQ.1) THEN
                  IF (DNE.GT.0.0 .AND. DNE.LE.0.6) THEN
                     JP1=7
                     JEX1=.TRUE.
                  END IF
                  IF (DNE.GT.0.0 .AND. DNE.LE.0.1) THEN
                     JP2=2
                     JEX2=.TRUE.
                  END IF
               END IF
            ELSE IF (LI.GT.LJ) THEN
               IF (DNE.GT.0.0 .AND. DNE.LE.0.1) THEN
                  JP1=2
                  JP2=2
                  JEX1=.TRUE.
                  JEX2=.TRUE.
               END IF
            END IF
            IF (NE0.GE.5.0 .AND. NE0.LT.5.5) THEN
               IP1=10
               IP2=10
               IEX1=.TRUE.
               IEX2=.TRUE.
            END IF
            IF (DNE.GE.4.4 .AND. DNE.LT.5.0) THEN
               JP1=44
               JP2=44
               JEX1=.TRUE.
               JEX2=.TRUE.
            END IF
C
C.......... LINEAR INTERPOLATION .....
C.......... FIRST TABLE .....
            ILEFT=IP1-1
            IRIGHT=IP1
            JLEFT=JP1-1
            JRIGHT=JP1
            AX1=A(ITAB1,ILEFT,JLEFT)+
     1          (A(ITAB1,IRIGHT,JLEFT)-A(ITAB1,ILEFT,JLEFT))/0.5*
     2          (NE0-NEFF(ILEFT))
            AX2=A(ITAB1,ILEFT,JRIGHT)+
     1          (A(ITAB1,IRIGHT,JRIGHT)-A(ITAB1,ILEFT,JRIGHT))/0.5*
     2          (NE0-NEFF(ILEFT))
            CHIX1=CHI(ITAB1,ILEFT,JLEFT)+
     1            (CHI(ITAB1,IRIGHT,JLEFT)-CHI(ITAB1,ILEFT,JLEFT))/0.5*
     2            (NE0-NEFF(ILEFT))
            CHIX2=CHI(ITAB1,ILEFT,JRIGHT)+
     1           (CHI(ITAB1,IRIGHT,JRIGHT)-CHI(ITAB1,ILEFT,JRIGHT))/0.5*
     2           (NE0-NEFF(ILEFT))
C
            AX=AX1 + (AX2-AX1)/0.1*(DNE-DNEFF(JLEFT))
            CHIX=CHIX1 + (CHIX2-CHIX1)/0.1*(DNE-DNEFF(JLEFT))
C
            IF (AX.LT.0.0 .OR. CHIX.LT.0.0) THEN
               ICIND(IC) = 0
               GOTO 8
            END IF
C
            IF (ITAB2.LE.0) GOTO 5
C
C.......... SECOND TABLE .....
            ILEFT=IP2-1
            IRIGHT=IP2
            JLEFT=JP2-1
            JRIGHT=JP2
            AY1=A(ITAB2,ILEFT,JLEFT)+
     1          (A(ITAB2,IRIGHT,JLEFT)-A(ITAB2,ILEFT,JLEFT))/0.5*
     2          (NE0-NEFF(ILEFT))
            AY2=A(ITAB2,ILEFT,JRIGHT)+
     1          (A(ITAB2,IRIGHT,JRIGHT)-A(ITAB2,ILEFT,JRIGHT))/0.5*
     2          (NE0-NEFF(ILEFT))
            CHIY1=CHI(ITAB2,ILEFT,JLEFT)+
     1            (CHI(ITAB2,IRIGHT,JLEFT)-CHI(ITAB2,ILEFT,JLEFT))/0.5*
     2            (NE0-NEFF(ILEFT))
            CHIY2=CHI(ITAB2,ILEFT,JRIGHT)+
     1           (CHI(ITAB2,IRIGHT,JRIGHT)-CHI(ITAB2,ILEFT,JRIGHT))/0.5*
     2           (NE0-NEFF(ILEFT))
C
            AY=AY1 + (AY2-AY1)/0.1*(DNE-DNEFF(JLEFT))
            CHIY=CHIY1 + (CHIY2-CHIY1)/0.1*(DNE-DNEFF(JLEFT))
C
            IF (AY.LT.0.0 .OR. CHIY.LT.0.0) THEN
               ICIND(IC) = 0
               GOTO 8
            END IF
C
    5       CONTINUE
C
C.......... COMPUTATION OF BORN COLLISION RATES .....
            IF (KAP2.LT.0) THEN
               IF (KAP1.EQ.1) THEN
                  S1=FACTOR*QKAP1*G1(W,AX,CHIX)
                  S2=0.0
               ELSE
                  S1=FACTOR*QKAP1*G0(W,AX,CHIX)
                  S2=0.0
               END IF
            ELSE IF (KAP2.GE.0) THEN
               IF (KAP1.EQ.1) S1=FACTOR*QKAP1*G1(W,AX,CHIX)
               IF (KAP1.NE.1) S1=FACTOR*QKAP1*G0(W,AX,CHIX)
               IF (KAP2.EQ.1) S2=FACTOR*QKAP2*G1(W,AY,CHIY)
               IF (KAP2.NE.1) S2=FACTOR*QKAP2*G0(W,AY,CHIY)
            END IF
C
            VSIG=S1+S2
            A1=NE*VSIG*FELBB
C
C+++++++ ERROR IN ICIND(IC) DATA +++++
C
         ELSE
            STOP 'ERR-01'
         END IF
C
C+++++++ SPECIAL COLLISION RATES (SOBELMAN TABLE 6.7) +++++
C
         IF (I.EQ.1 .AND. (J.EQ.4 .OR. J.EQ.13)) THEN
            DEPS=EPS(J)-EPS(I)
            FACTOR= 1.0E-8 * (CHIHYD/DEPS)**1.5 *
     1              ((CHI_J(0) -EPS(J))/(CHI_J(0) -EPS(I)))**1.5 *
     2              EXP(-W) / 1.0
            IF (J.EQ.4) THEN
               XA=0.86
               XCHI=0.28
            ELSE IF (J.EQ.13) THEN
               XA=24.5
               XCHI=0.70
            END IF
            QKAP=1.5
            VSIG=FACTOR*QKAP*G7(W,XA,XCHI)
            A1=NE*VSIG*FELBB
         END IF
C
C
C***** NEUTRAL PARTICLE COLLISIONS *************************************
C      ---------------------------
C
C+++++++ INTEGRATION OF ENERGY-RESOLVED CROSS-SECTION +++++
C
         IF (ICINDN(IC).GT.0) THEN
            KMAX=NINT(ABS(COLNEU(IC)))
            DO 11 K=1,KMAX
            X(K)=ECOLLN(ICINDN(IC),K)
            EPSKT=ECOLLN(ICINDN(IC),K)/TEV
   11       FX(K)=EPSKT*EXP(-EPSKT)*SCOLLN(ICINDN(IC),K)
            CALL INTEGR(X,FX,FINT,KMAX,0.0)
            B1=1.485515E-8*NHIO*SQRT(1.0/1.008+1.0/WEI)/SQRT(T)*
     1         FINT(KMAX)*FH1BB
C
C+++++++ COLLISION RATES WITH GIVEN THRESHOLD CROSS-SECTIONS +++++
C
         ELSE IF (ICINDN(IC).EQ.0) THEN
            B1=BCON*COLNEU(IC)*PSI(W)
C
C+++++++ ERROR IN ICINDN(IC) DATA +++++
C
         ELSE
            STOP 'ERR-02'
         END IF
C
C
C$$$ BOUND-BOUND COLLISIONS OF MG II $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C    ===============================
C
C*** ELECTRON COLLISIONS ***********************************************
C    -------------------
C
      ELSE IF (I.GE.NXTION(1) .AND. (J.GE.NXTION(1) .AND. J.LT.NK)) THEN
C
         W=(EPS(J)-EPS(I))/TEV
C
C+++++++ INTEGRATION OF ENERGY-RESOLVED CROSS-SECTION +++++
C
         IF (ICIND(IC).GT.0) THEN
            KMAX=NINT(ABS(COLL(IC)))
            DO 12 K=1,KMAX
            X(K)=ECOLL(ICIND(IC),K)
            EPSKT=ECOLL(ICIND(IC),K)/TEV
   12       FX(K)=EPSKT*EXP(-EPSKT)*SCOLL(ICIND(IC),K)
            CALL INTEGR(X,FX,FINT,KMAX,0.0)
            A1=6.342372E-7*NE/SQRT(T)*FINT(KMAX)*FELBB
C
C+++++++ COLLISION RATES WITH GIVEN THRESHOLD CROSS-SECTIONS +++++
C
         ELSE IF (ICIND(IC).EQ.0) THEN
            ALLOWD=.TRUE.
            IF (COLL(IC).LT.0.0) ALLOWD=.FALSE.
C.......... OPTICALLY ALLOWED TRANSITIONS .....
            IF (ALLOWD) THEN
               DUM=MAP1(UIJ,PSI2,26,W,F2,1)
               A1=ACON*3.31*ABS(COLL(IC))*W*F2
C......... OPTICALLY DISALLOWED TRANSITIONS .....
            ELSE
               A1=ACON*ABS(COLL(IC))*F00(W)
            END IF
C
C+++++++ ERROR IN ICIND(IC) DATA +++++
C
         ELSE
            STOP 'ERR-03'
         END IF
C
C
C***** NEUTRAL PARTICLE COLLISIONS *************************************
C      ---------------------------
C
C+++++++ INTEGRATION OF ENERGY-RESOLVED CROSS-SECTION +++++
C
         IF (ICINDN(IC).GT.0) THEN
            KMAX=NINT(ABS(COLNEU(IC)))
            DO 13 K=1,KMAX
            X(K)=ECOLLN(ICINDN(IC),K)
            EPSKT=ECOLLN(ICINDN(IC),K)/TEV
   13       FX(K)=EPSKT*EXP(-EPSKT)*SCOLLN(ICINDN(IC),K)
            CALL INTEGR(X,FX,FINT,KMAX,0.0)
            B1=1.485515E-8*NHIO*SQRT(1.0/1.008+1.0/WEI)/SQRT(T)*
     1         FINT(KMAX)*FH1BB
C
C+++++++ COLLISION RATES WITH GIVEN THRESHOLD CROSS-SECTIONS +++++
C
         ELSE IF (ICINDN(IC).EQ.0) THEN
            B1=BCON*COLNEU(IC)*PSI(W)
C
C+++++++ ERROR IN ICINDN(IC) DATA +++++
C
         ELSE
            STOP 'ERR-04'
         END IF
C
C
C$$$ BOUND-FREE COLLISIONS OF MG I AND MG II $$$$$$$$$$$$$$$$$$$$$$$$$$$
C    =======================================
C
C*** ELECTRON COLLISIONS ***********************************************
C    -------------------
C
      ELSE IF ( (I.LT.NXTION(1) .AND. J.EQ.NXTION(I)) .OR.
     1          (I.GE.NXTION(1) .AND. J.EQ.NK) ) THEN
C
         IF (I.LT.NXTION(1)) THEN
            BETA=1.00
            W=(CHI_J(0) +EPS(J)+DI(I)-EPS(I))/TEV
         ELSE
            BETA=1.25
            W=(CHI_J(1)+DI(I)-EPS(I))/TEV
         END IF
C
C+++++++ INTEGRATION OF ENERGY-RESOLVED CROSS-SECTION +++++
C
         IF (ICIND(IC).GT.0) THEN
            KMAX=NINT(ABS(COLL(IC)))
            DO 14 K=1,KMAX
            X(K)=ECOLL(ICIND(IC),K)
            EPSKT=ECOLL(ICIND(IC),K)/TEV
   14       FX(K)=EPSKT*EXP(-EPSKT)*SCOLL(ICIND(IC),K)
            CALL INTEGR(X,FX,FINT,KMAX,0.0)
            A1=6.342372E-7*NE/SQRT(T)*FINT(KMAX)*FELBF
C
C+++++++ COLLISION RATES WITH GIVEN THRESHOLD CROSS-SECTIONS +++++
C
         ELSE IF (ICIND(IC).EQ.0) THEN
            A1=AICON*ABS(COLL(IC))*F1(W,BETA)
C
C+++++++ DATA ERROR IN ICIND(IC) DATA +++++
C
         ELSE
            STOP 'ERR-05'
         END IF
C
C
C***** NEUTRAL PARTICLE COLLISIONS *************************************
C      ---------------------------
C
C+++++++ INTEGRATION OF ENERGY-RESOLVED CROSS-SECTION +++++
C
         IF (ICINDN(IC).GT.0) THEN
            KMAX=NINT(ABS(COLNEU(IC)))
            DO 15 K=1,KMAX
            X(K)=ECOLLN(ICINDN(IC),K)
            EPSKT=ECOLLN(ICINDN(IC),K)/TEV
   15       FX(K)=EPSKT*EXP(-EPSKT)*SCOLLN(ICINDN(IC),K)
            CALL INTEGR(X,FX,FINT,KMAX,0.0)
            B1=1.485515E-8*NHIO*SQRT(1.0/1.008+1.0/WEI)/SQRT(T)*
     1         FINT(KMAX)*FH1BF
C
C+++++++ COLLISION RATES WITH GIVEN THRESHOLD CROSS-SECTIONS +++++
C
         ELSE IF (ICINDN(IC).EQ.0) THEN
            B1=BICON*COLNEU(IC)*PSI(W)
C
C+++++++ ERROR IN ICINDN(IC) DATA +++++
C
         ELSE
            STOP 'ERR-06'
         END IF
C
C
C$$$ PHYSICALLY NON-EXISTENT TRANSITIONS $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C    ===================================
C
      ELSE
         GOTO 6
      END IF
C
C
C--- TOTAL COLLISION RATES ----------------------
      C(I,J) = A1 + B1
C
C--- SCALED DOWNWARD RATES -----------------------
      C(J,I) = C(I,J) * N(ID,I) / N(ID,J)
C
    6 CONTINUE
    7 CONTINUE
C=== LOOP OVER ALL POSSIBLE TRANSITIONS ENDS HERE ======================
C
      END

