*From:	UTADNX::UTSPAN::OZ::GIGAS        "Detlef Gigas, NASA Goddard Space Flight Center" 21-MAY-1992 14:47:44.01
*To:	UTSPAN::UTADNX::IO::MICHAEL
*CC:	
*Subj:	COLSEC.FOR
*
      SUBROUTINE MGCSC
C***********************************************************************
C
C-----------------------------------------------------------------------
C
C     SETS DEFAULT CROSS-SECTIONS FOR ELECTRON AND NEUTRAL PARTICLE COLL
C     READS IN SPECIAL VALUES FOR COLLISION CROSS-SECTIONS
C     DETERMINES MINIMUM AND MAXIMUM CROSS-SECTIONS
C     PRINTS TABLE OF COLLISION CROSS-SECTIONS
C ***
C ***	13-MAY-1995 17:46:02.00		ML / IoA.  Include files
C ***	29-APR-1996 16:49:12.47		ML / Bamberg.  New ion stuff.
C ***	17-MAY-1996 13:39:09.33		ML / Bamberg.  COMMON V, and related
C ***                                   dimensioning.
C
C-----------------------------------------------------------------------
C
      INCLUDE 'MOD_SIZ.INC'
      include 'NNS.INC'
      include 'LEVEL.INC'

*      COMMON V(20000)
*      EQUIVALENCE (V(1),INIC(1)), (V(5000),ICLOW(1)),
*     1            (V(10000),ICUP(1)), (V(15000),CCS(1))
C--- NCOLL=(NLEVEL-OVER-2) LMAX=MAX. NUMBER OF TRANSITIONS WITH ENERGY R
C--- CROSS-SECTIONS NMAX=MAX. NUMBER OF POINTS IN ENERGY RESOLVED CROSS-
      INCLUDE 'COLIS.INC'

      integer INIC(M_COLL), ICLOW(M_COLL), ICUP(M_COLL)
      real CCS(M_COLL), EC(LMAX,NMAX), SC(LMAX,NMAX)
      CHARACTER*19 TLINE(6)
C
      XP(X)=EXP(X*2.30258509)
C
C--- INITIALIZE CROSS-SECTIONS ---
      NC=(NL*NK)/2
      DO 1 IC=1,NC
      INIC(IC)=0
      ICIND(IC)=0
      ICINDN(IC)=0
      COLL(IC)=0.0
    1 COLNEU(IC)=0.0
      DO 15 I=1,LMAX
      DO 15 II=1,NMAX
      ECOLL(I,II)=0.0
      ECOLLN(I,II)=0.0
      SCOLL(I,II)=0.0
   15 SCOLLN(I,II)=0.0
C
      IC=0
      EIH=13.605
C
C--- READIN DEFAULT CROSS-SECTION FOR ELECTRON COLLISIONS ---
      READ(1,*)SCALE
C
C-----------------------------------------------------------------------
C  THE FOLLOWING DEFAULT CROSS-SECTIONS ARE USED:
C      OMEGA =  1.0 FOR OPTICALLY FORBIDDEN TRANSITIONS
C      OMEGA = 10.0 FOR OPTICALLY ALLOWED TRANSITIONS
C      OMEGA =  1.0 IF DIPOLE-APPROXIMATION YIELDS SIGMA.LT.0.1
C
C   SIGMA MAX (IN PI*A0**2) = OMEGA / (DELTA E * GLOW)  !DELTA E IN RYD!
C-----------------------------------------------------------------------
C
C--- SET DEFAULT CROSS-SECTIONS FOR ELECTRON COLLISIONS ---
      DO 6 I=1,NL
      DO 5 J=I+1,NK
      IC=IC+1
      IF(I.GE.NXTION(1))GOTO 3
      IF(J.GE.NXTION(1))GOTO 2
C--- FIRST IONIZATION STAGE ---
C--- COLLISIONAL EXCITATION ---
      EIJ=EPS(J)-EPS(I)
      COLL(IC)=-1.0*(EIH/EIJ)/G(I)*SCALE
      GOTO 5
C--- COLLISIONAL IONIZATION ---
    2 IF(J.NE.NXTION(I))GOTO 5
      EI=CHI_J(0) -EPS(I)+DI(I)+EPS(J)
      XXI=1.0
      IF (I.EQ.1 .OR. I.EQ.27) XXI=2.0
      COLL(IC)=(EIH/EI)**2.0*0.665*XXI
      GOTO 5
C--- SECOND IONIZATION STAGE ---
    3 IF(J.EQ.NXTION(I))GOTO 4
C--- COLLISIONAL EXCITATION ---
      EIJ=EPS(J)-EPS(I)
      COLL(IC)=-1.0*(EIH/EIJ)/G(I)*SCALE
      GOTO 5
C--- COLLISIONAL IONIZATION ---
    4 EI=CHI_J(1)-EPS(I)+DI(I)
      XXI=1.0
      COLL(IC)=(EIH/EI)**2.0*0.665*XXI
    5 CONTINUE
    6 CONTINUE
C
C--- READIN LABEL NUMBERS OF OPTICALLY ALLOWED TRANSITIONS WITH DEFAULT
C--- CROSS-SECTIONS I.GT.0 J.GT.0 ---
C--- READIN NUMBER OF THESE TRANSITIONS ---
      READ(1,*)N1
      NCC=N1
      IF(N1.LE.0)GOTO 36
C--- READIN TRANSITIONS (LOWER LEVEL/UPPER LEVEL) ----
      READ(1,*)(ICLOW(IC),ICUP(IC),IC=1,NCC)
C--- SET COLLISION CROSS-SECTIONS ---
      DO 7 IC=1,NCC
      IF(ICLOW(IC).LT.0.OR.ICUP(IC).LT.0)STOP 'ERR-01'
      I=ICLOW(IC)
      J=ICUP(IC)
      ICC=NK*(I-1)-(I*(I-1))/2+J-I
      CC=10.0*ABS(COLL(ICC))
      COLL(ICC)=CC
      CCS(IC)=CC
    7 CONTINUE
C
C--- READIN LABEL NUMBERS OF TRANSITIONS WITH COLLISION RATES
C--- TO BE COMPUTED FROM BORN-APPROXIMATION (SOBELMAN-TABLE INPUT)
C--- READIN NUMBER OF THESE TRANSITIONS ---
   36 READ(1,*)N3
      IF(N3.LE.0)GOTO 8
C--- READIN TRANSITIONS (LOWER LEVEL/UPPER LEVEL) ---
      READ(1,*)(ICLOW(IC),ICUP(IC),IC=1,N3)
C--- SET INDEX VARIABLE ICIND TO NEGATIVE VALUE ---
      DO 37 IC=1,N3
      IF(ICLOW(IC).LE.0 .OR. ICUP(IC).LE.0) STOP 'ERR-00'
      I=ICLOW(IC)
      J=ICUP(IC)
      ICC=NK*(I-1)-(I*(I-1))/2+J-I
      ICIND(ICC)=-1
   37 CONTINUE
C
C--- READIN SCALING FACTORS FOR ALL ELECTRON COLLISION CROSS-SECTIONS
C--- (BOUND-BOUND/BOUND-FREE) ---
    8 READ(1,*)FELBB,FELBF
C
C--- READIN ELECTRON COLLISION CROSS-SECTIONS ---
C--- I=ICLOW=LOWER LEVEL J=ICUP=UPPER LEVEL ----
C--- I.GE.0 J.GE.0: OPTICALLY ALLOWED, MAXIMUM CROSS-SECTION LISTED
C--- I.GE.0 J.LT.0: OPTICALLY ALLOWED, LOG(GF)-VALUE LISTED
C---                (DIPOLE-APPROXIMATION, AT LEAST 0.1*PI*A0**2)
C--- I.LT.0 J.GE.0: OPTICALLY FORBIDDEN, MAXIMUM CROSS-SECTION LISTED
C--- I.LT.0 J.LT.0: ENERGY RESOLVED CROSS-SECTION IS LISTED FOR N POINTS
C---                N.GE.0: OPTICALLY ALLOWED  N.LT.0: OPTICALLY FORBIDD
C
C--- READIN NUMBER OF THESE TRANSITIONS ---
      READ(1,*)N2
      NCC=NCC+N2
      IF(N2.LE.0)GOTO 10
      IS=1
      IN=0
C--- READIN TRANSITIONS ---
      READ(1,*)(ICLOW(IC),ICUP(IC),CCS(IC),(EC(INCOLL(IC,INIC,IN,LMAX),
     1II),SC(INCOLL(IC,INIC,IN,LMAX),II),II=1,MIN0(MIN0(ICLOW(IC),0)*
     2MIN0(ICUP(IC),0)*NINT(ABS(CCS(IC)))/(ICLOW(IC)*ICUP(IC)),NMAX)),
     3IC=N1+1,NCC)
C--- SET COLLISION CROSS SECTIONS ---
      DO 9 IC=N1+1,NCC
      I=IABS(ICLOW(IC))
      J=IABS(ICUP(IC))
      ICC=NK*(I-1)-(I*(I-1))/2+J-I
      IF(ICUP(IC).GT.0)THEN
      COLL(ICC)=CCS(IC)*ISIGN(1,ICLOW(IC))
      ELSE IF(ICUP(IC).LT.0.AND.ICLOW(IC).GT.0)THEN
      EIJ=EPS(J)-EPS(I)
      CC=(EIH/EIJ)**2.0*XP(CCS(IC))/G(I)
      IF(CC.LT.0.1)THEN
      CC=ABS(COLL(ICC))
      ICUP(IC)=J
      END IF
      COLL(ICC)=CC
      CCS(IC)=CC
      ELSE IF(ICUP(IC).LT.0.AND.ICLOW(IC).LT.0)THEN
      COLL(ICC)=CCS(IC)
      IF(IS.GT.LMAX)STOP 'ERR-02'
      ICIND(ICC)=IS
      DO 13 II=1,MIN0(NINT(ABS(CCS(IC))),NMAX)
      ECOLL(IS,II)=EC(INIC(IC),II)
   13 SCOLL(IS,II)=SC(INIC(IC),II)
      IS=IS+1
      END IF
    9 CONTINUE
   10 CONTINUE
C
C--- SET DEFAULT NEUTRAL PARTICLE COLLISION CROSS-SECTIONS ---
C    CROSS-SECTION IS SET EQUAL TO MAXIMUM ELECTRON COLLISION CROSS-SECT
      DO 11 ICC=1,NC
      ICINDN(ICC) = 0
      IF (ICIND(ICC).LE.0) THEN
         COLNEU(ICC) = ABS(COLL(ICC))
      ELSE IF (ICIND(ICC).GT.0) THEN
         NPOINT = NINT(ABS(COLL(ICC)))
         SMAX = 0.0
         IL = ICIND(ICC)
         DO 32 I1=1,NPOINT
   32    IF (SCOLL(IL,I1).GT.SMAX) I2=I1
         COLNEU(ICC) = SCOLL(IL,I2)
      END IF
   11 CONTINUE
C
C--- COMPUTE MINIMUM AND MAXIMUM CROSS-SECTIONS ---
      CMIN=1.0E99
      CMAX=0.0
      IC=0
      DO 12 I=1,NL
      DO 12 J=I+1,NK
      IC=IC+1
      IF(I.LT.NXTION(1).AND.J.GE.NXTION(1).AND.J.NE.NXTION(I))GOTO 12
      IF(ICIND(IC).EQ.0)THEN
      CC=COLNEU(IC)
      ELSE IF(ICIND(IC).GT.0)THEN
      CC=0
      DO 16 II=1,MIN0(NINT(ABS(COLL(IC))),NMAX)
   16 CC = AMAX1(CC, SCOLL(ICIND(IC),II))
      ELSE
      GOTO 12
      END IF
      IF(CC.LT.CMIN)THEN
      IMIN=I
      JMIN=J
      CMIN=CC
      ELSE IF(CC.GT.CMAX)THEN
      IMAX=I
      JMAX=J
      CMAX=CC
      END IF
   12 CONTINUE
C
C--- OUTPUT OF ELECTRON COLLISION CROSS-SECTIONS ---
      SCAL10=10.0*SCALE
      WRITE(6,2000)
 2000 FORMAT(1H1,132(1H=),/,34X,'TABLE OF ELECTRON AND NEUTRAL PARTICLE
     1COLLISION CROSS-SECTIONS',/,1X,132(1H=))
      WRITE(6,2001)SCALE,SCAL10,FELBB,FELBF
 2001 FORMAT(5(/),24X,84(1H-),/,50X,'ELECTRON COLLISION CROSS-SECTIONS',
     1/,24X,84(1H-),3(/),24X,'DEFAULT COLLISIONAL EXCITATION CROSS-SECTI
     2ON: OMEGA = ',F6.3,' / OMEGA = ',F6.3,//,        24X,'SCALING FACT
     3OR FOR ALL BOUND-BOUND COLLISION CROSS-SECTIONS LISTED BELOW: ',
     41PE10.3,/,24X,'SCALING FACTOR FOR ALL BOUND-FREE  COLLISION CROSS-
     5SECTIONS LISTED BELOW: ',1PE10.3)
      WRITE(6,2002)
 2002 FORMAT( 5(/),1X,'COLLISIONAL IONIZATION CROSS-SECTIONS IN UNITS OF
     1 PI*A0**2',//,1X,6(2X,'I',3X,'J',2X,'COLL(I,J) '),/)
C--- OUTPUT OF COLLISIONAL IONIZATION CROSS-SECTIONS ---
      NA=1
      NF=0
C--- PRINTOUT OF THRESHOLD CROSS-SECTIONS ---
      DO 17 I=1,NL
      II=NK*(I-1)-(I*(I-1))/2+NXTION(I)-I
      IF(ICIND(II).NE.0)THEN
      GOTO 29
      ELSE
      WRITE(TLINE(NA),2003)I,NXTION(I),COLL(II)
 2003 FORMAT(1X,I2,1X,I3,1X,1PG11.4E1)
      NA=NA+1
      END IF
   29 IF(NA.LE.6.AND.I.LT.NL)GOTO 17
      WRITE(6,2004)TLINE(1)//TLINE(2)//TLINE(3)//
     1             TLINE(4)//TLINE(5)//TLINE(6)
 2004 FORMAT(1X,A114)
      NA=1
      DO 18 II=1,6
   18 TLINE(II)='                      '
   17 CONTINUE
      WRITE(6,2005)
 2005 FORMAT(/)
C--- PRINTOUT OF ENERGY-RESOLVED CROSS-SECTIONS ---
      DO 19 I=1,NL
      II=NK*(I-1)-(I*(I-1))/2+NXTION(I)-I
      IF(ICIND(II).LE.0)GOTO 19
      IF(NF.EQ.0)WRITE(6,2014)
 2014 FORMAT(13X,5('  E(EV)    COLL',6X))
      NF=1
      WRITE(6,2006)I,NXTION(I),(ECOLL(ICIND(II),I1),SCOLL(ICIND(II),I1),
     1             I1=1,MIN0(NINT(ABS(COLL(II))),NMAX))
 2006 FORMAT(/,2X,I2,1X,I3,4X,5(2F8.3,5X):/9(12X,5(2F8.3,5X):/))
      WRITE(*,2005)
   19 CONTINUE
C--- OUTPUT OF COLLISIONAL EXCITATION CROSS-SECTIONS ---
      WRITE(6,2007)
 2007 FORMAT(5(/),1X,'OPTICALLY ALLOWED BOUND-BOUND TRANSITIONS WITH DEF
     1AULT CROSS-SECTIONS',/)
      IF(N1.EQ.0)WRITE(6,2008)
 2008 FORMAT(/,59X,'*** NONE ***')
      IF(N1.GT.0)WRITE(6,2009)(ICLOW(IC),ICUP(IC),IC=1,N1)
 2009 FORMAT(12(1X,I2,2X,I2,4X))
      WRITE(6,2010)
 2010 FORMAT(5(/),1X,'BOUND-BOUND TRANSITIONS WITH CROSS-SECTIONS (IN UN
     1ITS OF PI*A0**2) DIFFERENT FROM DEFAULT VALUES',/)
      IF(N2.EQ.0)THEN
      WRITE(6,2008)
      GOTO 28
      ELSE
      WRITE(6,2015)
 2015 FORMAT(/,1X,6(2X,'I',3X,'J',2X,'COLL(I,J) '),/)
      END IF
      NA=1
      NF=0
C--- PRINTOUT OF THRESHOLD CROSS-SECTIONS ---
      DO 20 I1=N1+1,NCC
      I=IABS(ICLOW(I1))
      J=IABS(ICUP(I1))
      IF((I.LT.NXTION(1).AND.J.GE.NXTION(1)).OR.
     1   (I.GE.NXTION(1).AND.J.EQ.NK))GOTO 30
      II=NK*(I-1)-(I*(I-1))/2+J-I
      IF(ICIND(II).NE.0)THEN
      GOTO 30
      ELSE
      WRITE(TLINE(NA),2003)I,J,COLL(II)
      NA=NA+1
      END IF
   30 IF(NA.LE.6.AND.I1.LT.NCC)GOTO 20
      WRITE(6,2004)TLINE(1)//TLINE(2)//TLINE(3)//
     1             TLINE(4)//TLINE(5)//TLINE(6)
      NA=1
      DO 21 I2=1,6
   21 TLINE(I2)='                      '
   20 CONTINUE
      WRITE(6,2005)
C--- PRINTOUT OF ENERGY-RESOLVED CROSS-SECTIONS ---
      DO 22 I1=N1+1,NCC
      I=IABS(ICLOW(I1))
      J=IABS(ICUP(I1))
      IF((I.LT.NXTION(1).AND.J.GE.NXTION(1)).OR.
     1   (I.GE.NXTION(1).AND.J.EQ.NK))GOTO 22
      II=NK*(I-1)-(I*(I-1))/2+J-I
      IF(ICIND(II).LE.0)GOTO 22
      IF(NF.EQ.0)WRITE(6,2014)
      NF=1
      WRITE(6,2006)I,J,(ECOLL(ICIND(II),I2),SCOLL(ICIND(II),I2),
     1             I2=1,MIN0(NINT(ABS(COLL(II))),NMAX))
   22 CONTINUE
C
   28 WRITE(6,2011)IMIN,JMIN,CMIN,IMAX,JMAX,CMAX
 2011 FORMAT(3(/),1X,'MINIMUM CROSS-SECTION:  (',I3,')-(',I3,')',3X,
     1       1PG11.4E1,/,1X,'MAXIMUM CROSS-SECTION:  (',I3,')-(',I3,
     2       ')',3X,1PG11.4E1)
C
C--- CLEAR ARRAY INIC ---
      DO 35 IC=1,NC
   35 INIC(IC)=0
C
C--- READIN SCALING FACTORS FOR ALL NEUTRAL PARTICLE COLLISIONS ---
      READ(1,*)FH1BB,FH1BF
C
C--- READIN NUMBER OF THESE TRANSITIONS ---
      READ(1,*)NCC
      IF(NCC.LE.0)GOTO 23
      IS=1
      IN=0
C--- READIN TRANSITIONS---
      READ(1,*)(ICLOW(IC),ICUP(IC),CCS(IC),(EC(INCOLL(IC,INIC,IN,LMAX),
     1II),SC(INCOLL(IC,INIC,IN,LMAX),II),II=1,MIN0(MIN0(ICLOW(IC),0)*
     2MIN0(ICUP(IC),0)*NINT(ABS(CCS(IC)))/(ICLOW(IC)*ICUP(IC)),NMAX)),
     3IC=1,NCC)
C--- SET COLLISION CROSS-SECTIONS ---
      DO 24 IC=1,NCC
      I=IABS(ICLOW(IC))
      J=IABS(ICUP(IC))
      ICC=NK*(I-1)-(I*(I-1))/2+J-I
      IF(ICLOW(IC).GE.0.AND.ICUP(IC).GE.0)THEN
      COLNEU(ICC)=CCS(IC)
      ICINDN(ICC)=0
      ELSE IF(ICLOW(IC).LT.0.AND.ICUP(IC).LT.0)THEN
      COLNEU(ICC)=CCS(IC)
      IF(IS.GT.LMAX)STOP 'ERR-03'
      ICINDN(ICC)=IS
      DO 34 II=1,MIN0(NINT(ABS(CCS(IC))),NMAX)
      ECOLLN(IS,IC)=EC(INIC(IC),II)
   34 SCOLLN(IS,II)=SC(INIC(IC),II)
      IS=IS+1
      ELSE
      STOP 'ERR-04'
      END IF
   24 CONTINUE
   23 CONTINUE
C
C--- OUTPUT OF NEUTRAL PARTICLE COLLISION CROSS-SECTIONS ---
      WRITE(6,2012)SCALE,SCAL10,FH1BB,FH1BF
 2012 FORMAT(5(/),24X,84(1H-),/,46X,'NEUTRAL PARTICLE COLLISION CROSS-SE
     1CTIONS',/,24X,84(1H-),3(/),24X,'DEFAULT COLLISIONAL EXCITATION CRO
     2SS-SECTION: OMEGA = ',F6.3,' / OMEGA = ',F6.3,//,        24X,'SCAL
     3ING FACTOR FOR ALL BOUND-BOUND COLLISION CROSS-SECTIONS LISTED BEL
     4OW: ',1PE10.3,/,24X,'SCALING FACTOR FOR ALL BOUND-FREE  COLLISION
     5CROSS-SECTIONS LISTED BELOW: ',1PE10.3)
      WRITE(6,2013)
 2013 FORMAT( 5(/),1X,'NEUTRAL PARTICLE COLLISION CROSS-SECTIONS DIFFERE
     1NT FROM CORRESPONDING ELECTRON COLLISION CROSS-SECTIONS')
      IF(NCC.LE.0)THEN
      WRITE(6,2008)
      GOTO 14
      ELSE
      WRITE(6,2015)
      END IF
      NA=1
      NF=0
C--- PRINTOUT OF THRESHOLD CROSS-SECTIONS ---
      DO 25 I1=1,NCC
      I=IABS(ICLOW(I1))
      J=IABS(ICUP(I1))
      II=NK*(I-1)-(I*(I-1))/2+J-I
      IF(ICINDN(II).NE.0)THEN
      GOTO 31
      ELSE
      WRITE(TLINE(NA),2003)I,J,COLNEU(II)
      NA=NA+1
      END IF
   31 IF(NA.LE.6.AND.I1.LT.NCC)GOTO 25
      WRITE(6,2004)TLINE(1)//TLINE(2)//TLINE(3)//
     1             TLINE(4)//TLINE(5)//TLINE(6)
      NA=1
      DO 26 I2=1,6
   26 TLINE(I2)='                      '
   25 CONTINUE
      WRITE(6,2005)
C--- PRINTOUT OF ENERGY-RESOLVED CROSS-SECTIONS ---
      DO 27 I1=1,NCC
      I=IABS(ICLOW(I1))
      J=IABS(ICUP(I1))
      II=NK*(I-1)-(I*(I-1))/2+J-I
      IF(ICINDN(II).EQ.0)GOTO 27
      IF(NF.EQ.0)WRITE(6,2014)
      NF=1
      WRITE(6,2006)I,J,(ECOLLN(ICINDN(II),I2),SCOLLN(ICINDN(II),I2),
     1             I2=1,MIN0(NINT(ABS(COLNEU(II))),NMAX))
      WRITE(*,2005)
   27 CONTINUE
C
   14 RETURN
      END
