        SUBROUTINE NEWPAGE( MAX_LINES, SKIP_LINES, HEAD_LINES,
     >                      NEW_PAGE )
C ***
C ******************************************************************************
C ***
C ***   Writes new page character (i.e. 1) to channel * if table does not fit
C ***   on current page. If it does two empty lines are written to print more
C ***   than one table per page.
C ***
C ***   Assumptions: Of table with maximal MAX_LINES many lines only every
C ***                SKIP_LINESth line is to be printed (exactly: if
C ***                MOD( MAX_LINES, SKIP_LINES ) == 0) plus some HEAD_LINES.
C ***                The first and last (i.e. MAX_LINESth) line is always to be
C ***                printed.
C ***
C ***   If NEW_PAGE is .TRUE. start always new page and reset routine.
C ***
C ***   Bug:         If single table is longer than page algorithm does not
C ***                work. This is a rather complicated problem, see TeX.
C ***
C ***   11-JAN-1991 14:38:47.90
C ***
C ******************************************************************************
C ***
C ***   Parameters:
C ***
        INTEGER MAX_LINES, SKIP_LINES, HEAD_LINES
        LOGICAL NEW_PAGE
C ***
C ***   Local variables:
C ***
        INTEGER Table_Length, Gap, Page_Length, Printed_Lines
        PARAMETER( Gap = 2, Page_Length = 64 )
        SAVE Printed_Lines
        DATA Printed_Lines /0/

        Table_Length = MAX_LINES/SKIP_LINES + 1 + HEAD_LINES
        IF( MOD( MAX_LINES, SKIP_LINES ) .NE. 0 ) THEN
           Table_Length = Table_Length + 1
        END IF

        IF( Table_Length + Printed_Lines .GT. Page_Length
     >      .OR. NEW_PAGE ) THEN
           WRITE( *, '(''1'')' )
           Printed_Lines = Table_Length + Gap
        ELSE
           WRITE( *, '(A)' ) (' ', I = 1, Gap)
           Printed_Lines = Printed_Lines + Table_Length + Gap
        END IF

        END
