       SUBROUTINE PTAU
C      PTAU.F                            ASTROPHYSIK KIEL 1988
C      *******************************************************
C      MODIFIED FOR DIRECT USE OF ATLAS9 DATA IN 1996
C      *******************************************************
C      MODIFICATIONS BECAME NECESSARY FOR CORRECT TREATMENT
C      OF THE RADIATION FIELD (ESPECIALLY RADIATIVE
C      ACCELERATION).
C      ORIGINAL PTAU SOLVES THE HYDROSTATICAL EQUATION AGAIN
C      USING AN APPROXIMATION FOR THE RADIATIONAL ACCELERATION
C      (= CONST) THAT IS NOT VALID FOR HIGH LUMINOSITIES.
C      INSTEAD THE MODIFIED PTAU USES THE ORIGINAL ATLAS9
C      STRATIFICATION GIVEN AS ADDITIONAL INPUT IN PTAU.DAT.
C      *******************************************************
C      DEFAULT VALUES GIVEN BELOW BECOME USELESS!
C      *******************************************************
C ***
C ***   Modified:
C ***
C ***   16-JUN-2004 21:38:56.54         ML / Stegaurach.  COMMON/I/ via
C ***                                   INCLUDE OPALION.INC
C ***
C ***
C ***   $Id: ptau_new.f,v 1.2 2004/06/16 20:01:12 michael Exp $
C ***
C      *******************************************************

       REAL*8 CDENSNC(100),CPGAS(100),CKAPPAREF(100),CSIGMAREF(100),
     &        HEIGHT(100)

       INTEGER PTAU_FILE, ATM_FILE
       PARAMETER( PTAU_FILE = 20, ATM_FILE = 1 )

       INCLUDE 'INT.INC'
       COMMON /CONST/ ALN10, BOLTZK, HPLANC, CLIGHT
       INCLUDE 'RE.INC' 
       COMMON /ARL/ TAU( 70 ), THETA( 70 ), XI( 70 ), ALGK( 70 ),
     >        ALGS( 70 ), ALTAU( 70 ), ALTHET( 70 ), ALXI( 70 ),
     >        R( 70 ), DENSNC( 70 ), ALP( 3, 70 )
       COMMON /ARX/ GT( 6 ), GE( 6 ), DGT( 6 ), DGE( 6 )
       COMMON /OUT/ OLAM( 40 )
       include 'OPALION.INC'
C      **********************************************************
       DIMENSION STAU( 30 ), SOLTAU( 30 ), SOLTH( 30 )
       DIMENSION Y( 8 ), YE( 8 )
       CHARACTER*10 A
C
       DATA ( STAU(L), L = 1, 30 ) /0.0, 2.0E-7, 2.5E-7, 5.0E-7, 1.0E-6,
     >      2.0E-6, 5.0E-6, 1.0E-5, 2.0E-5, 5.0E-5, 1.0E-4, 2.0E-4,
     >      5.0E-4, 0.001, 0.002, 0.005, 0.01, 0.02, 0.05, 0.10, 0.25,
     >      0.4, 0.7, 1.0, 1.5, 2.0, 4.0, 6.0, 8.0, 10.0/
       DATA ( SOLTAU(L), L = 1, 30 ) /0.0, 2.89E-7, 5.26E-7, 1.36E-6,
     >      2.58E-6, 4.63E-6, 9.98E-6, 1.79E-5, 3.27E-5, 7.40E-5,
     >      1.39E-4, 2.65E-4, 6.31E-4, 1.22E-3, 2.39E-3, 5.85E-3,
     >      1.15E-2, 0.023, 0.055, 0.109, 0.269, 0.426, 0.736, 1.045,
     >      1.552, 2.051, 3.954, 5.768, 7.534, 9.268/
       DATA ( SOLTH(L), L = 1, 30 ) /1.2923, 1.2923, 1.2857, 1.2695,
     >      1.2506, 1.2353, 1.2115, 1.1971, 1.1803, 1.1613, 1.1455,
     >      1.1300, 1.1126, 1.0980, 1.0862, 1.0678, 1.0500, 1.0286,
     >      0.9921, 0.9582, 0.9065, 0.8615, 0.8051, 0.7671, 0.7326,
     >      0.7039, 0.6364, 0.6109, 0.5986, 0.5929/
       DATA ( OLAM(I), I = 1, 12 ) /3648., 4000., 5000., 6000., 7000.,
     >      8000., 10000., 12500., 15000., 16420., 20000., 25000./


       ALN10 = LOG( 10. )


       CALL DATUM( DATE )
       WRITE( 6, '(5A, /)' ) '1PTAU      ASTROPHYSIK KIEL 1981', 
     >    ' - MODIFIED 1996     Calculated on ', DATE(:9), ' at ',
     >    DATE(11:)


C ***
C ******************************************************************************
C ***
C ***  Readin of PTAU.DAT
C ***
C ******************************************************************************
C ***
       OPEN( UNIT = PTAU_FILE, FILE = 'PTAU' )
       READ( PTAU_FILE, '(F8.2, F6.2, F8.2, F9.2, /, I3)' ) TEFF,
     >                                             GLOG, RSU, REFLAM, I
       R1 = 6.95997E10*RSU
       IF( I .EQ. 0 ) THEN
          LMAX = 30
          DO L = 1, 30
             TAU( L ) = STAU( L )
          END DO
       ELSE
          LMAX = I
          IF( LMAX .GT. 70 ) CALL TEXT( 2 )
          READ( PTAU_FILE, '(5E10.3)' ) ( TAU(L), L = 1, LMAX )
       END IF
       READ( PTAU_FILE, '(I3)' ) M
       IF( M .EQ. 0 ) THEN
          DO L = 1, LMAX
             IF( TAU(L) .LT. SOLTAU(2) .OR.
     >           TAU(L) .GT. SOLTAU(30) ) THEN
                N = 1
             ELSE
                N = 2
             END IF
             CALL PRE( N, I, GT, DGT, SOLTAU, 30, TAU(L), .FALSE. )
             THETA( L ) = T1( N, I, GT, SOLTH )*5780./TEFF
          END DO
       ELSE IF( M .EQ. 1 ) THEN
          READ( PTAU_FILE, '(5F7.4)' ) ( THETA(L), L = 1, LMAX )
       ELSE IF( M .EQ. -1 ) THEN
          READ( PTAU_FILE, '(5F7.0)' ) ( THETA(L), L = 1, LMAX )
          DO L = 1, LMAX
             THETA( L ) = 5040./THETA( L )
          END DO
       END IF

       READ( PTAU_FILE, '(F6.2)' ) TUR
       IF( TUR .LT. -1.E-9 ) THEN
          READ( PTAU_FILE, '(5F7.2)' ) ( XI(L), L = 1, LMAX )
       ELSE
          DO L = 1, LMAX
             XI( L ) = TUR
          END DO
       END IF


C *******************
C MODIFICATIONS BEGIN
C *******************       

       READ( PTAU_FILE, '(5E14.6)') ( ALP(3, L), L = 1, LMAX )
       READ( PTAU_FILE, '(I3)') JDUMMY
       READ( PTAU_FILE, '(5E14.6)') ( ALP(2, L), L = 1, LMAX )
       READ( PTAU_FILE, '(I3)') JDUMMY
       READ( PTAU_FILE, '(5E14.6)') ( ALGK(L), L = 1, LMAX )
       READ( PTAU_FILE, '(I3)') JDUMMY
       READ( PTAU_FILE, '(5E14.6)') ( ALGS(L), L = 1, LMAX )
       READ( PTAU_FILE, '(I3)') JDUMMY
       READ( PTAU_FILE, '(5E14.6)') ( HEIGHT(L), L = 1, LMAX )
       
C *****************
C MODIFICATIONS END
C *****************       


       READ( PTAU_FILE, * ) MODE, IONST, IPRINT, KPRINT, LPR1, LPR2, 
     >   LPRD
       KPLOT = ( KPRINT - (KPRINT/8)*8 )/4       ! 0 or 1
       KPRINT = ( KPRINT - (KPRINT/4)*4 )/2 + 1  ! 1 or 2
       IF( KPLOT .EQ. 1 ) THEN
          BACKSPACE PTAU_FILE
          READ( PTAU_FILE, * ) MODE, IONST, IPRINT, IDUMMY, LPR1, LPR2,
     >      LPRD, KPID, PLMIN, PLMAX, KPKT
       END IF

       READ( PTAU_FILE, * ) NLAKS
       IF( NLAKS .EQ. 0 ) THEN
          IMAX = 12
       ELSE
          IMAX = NLAKS
          IF( IMAX .GT. 40 ) CALL TEXT( 5 )
          READ( PTAU_FILE, '(5F10.2)' ) ( OLAM(I), I = 1, IMAX )
       END IF

       READ( PTAU_FILE, '(I3)' ) LCONTR
       IF( LCONTR .NE. LMAX ) CALL TEXT( 1 )
       IF( IONST .LT. 1 .OR. IONST .GT. 3 ) CALL TEXT( 4 )
       CLOSE( PTAU_FILE )


C *******************
C MODIFICATIONS BEGIN
C *******************

C      ******************************************************************   
C      SOME CALCULATIONS OF OTHER IMPOTRANT VALUES OTHERWISE SUPPORTER BY
C      ORIGINAL PTAU  
C      ******************************************************************

       KAPSIG = 0
       NMYPG = 0

       GG = AVEMAT*EXP( ALN10*GLOG )

       IF( TAU(1) .LT. 1.E-38 ) THEN
          TAU1 = 1.E-7
          DO WHILE( TAU1 .GE. TAU(2) )
             TAU1 = TAU1*0.1
          END DO  
          CALL PRE( 1, I, GT, DGT, TAU, LMAX, TAU1, .FALSE. )
          THETA( 1 ) = T1( 1, I, GT, THETA )
          XI( 1 ) = T1( 1, I, GT, XI )
          TAU( 1 ) = TAU1
       END IF
       DO L = 1, LMAX
          ALTHET( L ) = LOG10( THETA(L) )
          ALTAU( L ) = LOG10( TAU(L) )
       END DO
       DO L = 1, LMAX
          IF( XI(L) .LT. 1.E-10 ) THEN
             ALXI( L ) = -34.
          ELSE
             ALXI( L ) = LOG10( XI(L)*XI(L)*AVEMAT/2. ) + 10.
          END IF
       END DO

       R( 1 ) = ABS( R1 )
       DO L = 1, LMAX
         DENSNC( L ) = ( EXP(ALN10 * ALP(2,L)) -
     &     EXP(ALN10 * ALP(3,L)) ) / BOLTZK / 5040. * THETA(L)
         ALGK(L)=LOG10(ALGK(L)*AVEMAT)
         ALGS(L)=LOG10(ALGS(L)*AVEMAT)
         ALP(1, L) = LOG10( EXP(ALN10 * ALP(2,L)) +
     &     DENSNC(L) * EXP(ALN10 * ALXI(L)) )
         R(L) = ABS(R1) - HEIGHT(L)
       END DO


C *****************
C MODIFICATIONS END
C *****************


C ***
C ******************************************************************************
C ***
C ***   PRINTOUT
C ***
C ******************************************************************************
C ***
       DO L = 0, LMAX
          CALL ZEILE( L, 6 )
       END DO
       WRITE( 6, 9090 ) NMYPG, LMAX
       WRITE( 6, 9100 ) KAPSIG, LMAX*IMAX
       WRITE( 6, 9130 ) MODE
       WRITE( 6, 9140 ) IONST, IONST + 1
       A = 'no'
       IF( IPRINT .EQ. 2 ) A = 'yes'
       WRITE( 6, 9150 ) A
       A = 'no'
       IF( KPRINT .EQ. 2 ) A = 'yes'
       WRITE( 6, 9160 ) A
       WRITE( 6, 9170 ) LPR1, LPR2, LPRD
       A = ' '
       IF( NLAKS .EQ. 0 ) A = ' (Default)'
       WRITE( 6, 9180 ) NLAKS, A
C ***
C ***  OUTPUT TO ATM.DAT (MODEL)
C ***
       WRITE( ATM_FILE, 9190 )
       WRITE( ATM_FILE, 9200 ) LMAX, TEFF, GLOG, REFLAM, RSU
       WRITE( ATM_FILE, 9210 ) ( TAU(L), L = 1, LMAX )
       WRITE( ATM_FILE, 9190 )
       WRITE( ATM_FILE, 9220 ) ( THETA(L), L = 1, LMAX )
       WRITE( ATM_FILE, 9190 )
       WRITE( ATM_FILE, 9210 ) ( ALP(3, L), L = 1, LMAX )
       WRITE( ATM_FILE, 9190 )
       WRITE( ATM_FILE, 9210 ) ( ALP(2, L), L = 1, LMAX )
       WRITE( ATM_FILE, 9190 )
       WRITE( ATM_FILE, 9210 ) ( ALGK(L), L = 1, LMAX )
       WRITE( ATM_FILE, 9190 )
       WRITE( ATM_FILE, 9210 ) ( ALGS(L), L = 1, LMAX )
       WRITE( ATM_FILE, 9190 )
       WRITE( ATM_FILE, 9210 ) ( R(L), L = 1, LMAX )
       WRITE( ATM_FILE, 9190 )
       WRITE( ATM_FILE, 9220 ) ( XI(L), L = 1, LMAX )
C      ***********************************************************
9090   FORMAT( /, /, 1X, 'Number of IONDIS calls:', I5, ' + ', I5 )
9100   FORMAT( 1X, 'Number of OPALAM calls:', I5, ' + ', I5 )
9130   FORMAT( 1X, 'Mode used in IONDIS for calculating particle conce',
     >       'ntrations:', I5 )
9140   FORMAT( 1X, 'Output of ionization states', I2, ' and', I2 )
9150   FORMAT( 1X, 'Printout IONDIS: ', A )
9160   FORMAT( 1X, 'Printout OPALAM: ', A )
9170   FORMAT( 1X, 'Printout points:', I3, ' to', I3, ' step', I3 )
9180   FORMAT( 1X, 'Number of wavelengths for calculating kappa/sigma ',
     >       'values:', I5, A )
9190   FORMAT( /, / )
9200   FORMAT( 1X, I4, /, 1X, F8.1, F6.2, F10.2, F7.2, /, / )
9210   FORMAT( 1X, 1P, 5E14.6 )
9220   FORMAT( 1X, 5F14.6 )

       END
