	subroutine psize( xsize, ysize )
C ***
C ******************************************************************************
C ***
C ***	Returns desired size of plot.  System dependent.  Linux Version
C ***
C ***	xsize, ysize   (REAL)    <  Dimension of plot frame in cm
C ***
C ***
C ***	VMS/mongo version accepts symbols LINLTE_XSIZE and
C ***	LINLTE_YSIZE to set fram size in cm.
C ***	Defaults to 20x15 cm.
C ***
C ***	 7-OCT-1996 19:05:04.26		ML / Bamberg.  Made from PLOTO.
C ***	20-FEB-1997 18:19:03.39		ML / Bamberg.  Didn't default to
C ***                                   20x15 but does now.
C ***    9-MAY-1997 00:00:02.00         ML / Stegaurach.  Made from VMS version
C ***   29-SEP-2001 22:54:56.00		ML / Stegaurach.  LINLTE -> RESIZE
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	real xsize, ysize

C ***
C ***	Global variables
C ***
	include 'RESIZE.INC'

C ***
C ***	Local variables
C ***
	character*255 symbol
	character sym_name(2)*(13)
	data sym_name /'LINLTE_XSIZE', 'LINLTE_YSIZE'/
	real def_devs(2), devs(2)
	data def_devs /20., 15./
	integer i, ist, length


C ***
C ***	Functions
C ***
        integer idx

C ***
C ***	Get xsize (i=1) and ysize (i=2)
C ***
	do i = 1, 2
           call getenv( sym_name(i), symbol )
           if( symbol .ne. ' ' ) then
C ***      
C ***         from symbol
C ***
              length = idx( symbol )
              read( symbol(:length), *, iostat = ist ) devs(i)
              if( ist .ne. 0 ) then
                 write( stdout, * )
     >             'RESIZE>> ERROR: Can''t read symbol ', 
     >                                               sym_name(i), ':'
                 write( stdout, * )
     >             '                ', symbol(:length)
                 write( stdout, * )
     >             '                Fix assignment to provide ',
     >                                           'proper dimesions!'
                 call exit
              end if
           else
C ***      
C ***         default
C ***      
              devs(i) = def_devs(i)

           end if

	end do
        xsize = devs(1)
        ysize = devs(2)

	end
