	subroutine resize_add_lines( x, text, icol )
C ***
C ******************************************************************************
C ***
C ***	Routine to add spectral line id's for resize.
C ***
C ***	x		r >	x position (wavelength) of line
C ***	text		c >	line id to add
C ***	icol		i >	color index for text
C ***
C ***
C ***    7-OCT-2001 21:21:00.00		ML / Stegaurach.  Made.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***   Arguments
C ***
        character text*(*)
	real x
	integer icol

C ***
C ***	Gobal variables
C ***
	include 'RESIZE.INC'

C ***
C ***	Local variables
C ***
#if defined( CRAY_PTR ) || defined( REF_PTR )
	integer chunk
	parameter( chunk = 20 )	! chunks in which to allocate memory
#endif

	logical first /.true./
	integer status, i

! pointer size:  AXP/VAX:
#ifndef PTRSIZ
#ifdef __ALPHA
#define PTRSIZ 8
#else
#define PTRSIZ 4
#endif
#endif

#if defined( CRAY_PTR )
	real nxt(*), nyt(*), nsizet(*)
	integer nloct(*), ncolt(*), ncoort(*)

	integer*4 ntext_addr(*)
	integer*2 ntext_len(*)

	pointer( np_xt, nxt )
	pointer( np_yt, nyt )
	pointer( np_sizet, nsizet )
	pointer( np_loct, nloct )
	pointer( np_colt, ncolt )
	pointer( np_coort, ncoort )

	pointer( np_text_a, ntext_addr )
	pointer( np_text_l, ntext_len )
#elif defined( REF_PTR )
	integer*PTRSIZ np_xt
	integer*PTRSIZ np_yt
	integer*PTRSIZ np_sizet
	integer*PTRSIZ np_loct
	integer*PTRSIZ np_colt
	integer*PTRSIZ np_coort

	integer*PTRSIZ np_text_a
	integer*PTRSIZ np_text_l
#endif


C ***
C ***	Functions
C ***
#if defined( CRAY_PTR ) || defined( REF_PTR )
	integer lib$get_vm, lib$free_vm
	external lib$get_vm, lib$free_vm
#endif	

	save first


C ***
C ***	Code
C ***
	if( first ) then
           first = .false.
	   ntext = 0
           ncutxt = 0
	end if

	ntext = ntext + 1
#if defined( CRAY_PTR ) || defined( REF_PTR )
	if( ncutxt .lt. ntext ) then

C ***
C ***      Get new memory
C ***
           i = ncutxt + chunk
	   status = lib$get_vm( 4*i, np_xt )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_yt )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_sizet )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_loct )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_colt )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_coort )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_text_a )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_text_l )
	   if( status .ne. 1 ) call lib$signal( %val(status) )

#if defined( CRAY_PTR )
           do i = 1, ntext - 1
C ***
C ***         copy the old data to the new location
C ***
              nxt(i) = xt(i) 
	      nyt(i) = yt(i) 
	      nsizet(i) = sizet(i) 
	      nloct(i) = loct(i) 
	      ncolt(i) = colt(i)
	      ncoort(i) = coort(i)
	      ntext_addr(i) = text_addr(i)
	      ntext_len(i) = text_len(i)
	   end do
#elif defined( REF_PTR )
C ***
C ***      copy the old data to the new location
C ***
           call arrcp( %val(p_xt), %val(np_xt), 1, ntext-1)
	   call arrcp( %val(p_yt), %val(np_yt), 1, ntext-1)
	   call arrcp( %val(p_sizet), %val(np_sizet), 1, ntext-1)
	   call iarrcp( %val(p_loct), %val(np_loct), 1, ntext-1)
	   call iarrcp( %val(p_colt), %val(np_colt), 1, ntext-1)
	   call iarrcp( %val(p_coort), %val(np_coort), 1, ntext-1)
	   call iarrcp( %val(p_text_a), %val(np_text_a), 1, ntext-1)
	   call iarrcp( %val(p_text_l), %val(np_text_l), 1, ntext-1)
#endif

           if( ncutxt .gt. 0 ) then
C ***
C ***         Free the old memory
C ***
	      status = lib$free_vm( 4*ncutxt, p_xt )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncutxt, p_yt )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncutxt, p_sizet )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncutxt, p_loct )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncutxt, p_colt )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncutxt, p_coort )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncutxt, p_text_a )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncutxt, p_text_l )
	      if( status .ne. 1 ) call lib$signal( %val(status) )

           end if

C ***
C ***      Fix pointers
C ***      
	   p_xt = np_xt
	   p_yt = np_yt
	   p_sizet = np_sizet
	   p_loct = np_loct
	   p_colt = np_colt
	   p_coort = np_coort
	   p_text_a = np_text_a
	   p_text_l = np_text_l

           ncutxt = ncutxt + chunk	! remember what we've got
	end if

#if defined( CRAY_PTR )
        xt(ntext) = x
	yt(ntext) = y
	sizet(ntext) = size
	loct(ntext) = loc
	colt(ntext) = icol
	coort(ntext) = icoor

	text_addr(ntext) = %loc(text)  ! hope this doesn't return the address of the descriptor
	text_len(ntext) = len(text)
#elif defined( REF_PTR )
        call derefass( x, %val(p_xt), ntext )
        call derefass( y, %val(p_yt), ntext )
        call derefass( size, %val(p_sizet), ntext )
        call iderefass( loc, %val(p_loct), ntext )
        call iderefass( icol, %val(p_colt), ntext )
        call iderefass( icoor, %val(p_coort), ntext )
        call iderefass( %ref(%loc(text)), %val(p_text_a), ntext )
        call iderefass( len(text), %val(p_text_l), ntext )
#endif
#else
        if( ntext .gt. max_text ) then
	    write( stdout, * ) 'RE_PAINT>>  Can''t add more text.',
     >                         '  Max # of strings is', max_text
            call exit
        end if

        xt(ntext) = x
	yt(ntext) = y
	sizet(ntext) = size
	loct(ntext) = loc
	colt(ntext) = icol
	coort(ntext) = icoor

        text_string(ntext) = text

#endif

	end
