	subroutine censym( x, y, symbol, xsize, ysize, theta )
C ***
C ******************************************************************************
C ***
C ***	PGPLOT version.  This is almost generic (i.e., not grrafix package
C ***   dependent) except for symbol #31, #32 (circles) and filled symbols.
C ***	31, 31 are octogons originally.
C ***
C ***	x	[cm]	x coordinate of point
C ***	y	[cm]	y coordinate of point
C ***	symbol		# of symbol
C ***	xsize	[cm]	size in x direction
C ***	ysize	[cm]	size in y direction (ignored - mongo's too stupid)
C ***	theta		angle of symbol
C ***
C ***	 9-APR-1997 19:29:05.44		ML / Bamberg.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	real x, y, xsize, ysize, theta
	integer symbol

C ***
C ***	Global variables
C ***

C ***
C ***	Local variables
C ***
	
	integer fill
	real angle, expand
	real atheta, factor, xp, yp
	real xq(6), yq(6)

C ***
C ***	Functions
C ***

C ***
C ***	Code
C ***

	atheta = 3.14159265358979323846264*theta/180.

	xp = x
	yp = y


	go to ( 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
     >         17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30,
     >         31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43 
     >        ) symbol
	go to 1000

1	call ctrlin( xp, yp, atheta, ysize, 1 )
	go to 1000

2	call ctrlin( xp, yp, atheta, xsize, 3 )
	go to 1000

3	call ctrlin( xp, yp, atheta, ysize, 2 )
	go to 1000

4	call ctrlin( xp, yp, atheta, xsize, 4 )
	go to 1000

5	call ctrlin( xp, yp, atheta, ysize, 1 )
	call ctrlin( xp, yp, atheta, xsize, 4 )
	go to 1000

6	call ctrlin( xp, yp, atheta, xsize, 4 )
	call ctrlin( xp, yp, atheta, ysize, 2 )
	go to 1000

7	call ctrlin( xp, yp, atheta, xsize, 3 )
	call ctrlin( xp, yp, atheta, ysize, 1 )
	go to 1000

8	call ctrlin( xp, yp, atheta, ysize, 2 )
	call ctrlin( xp, yp, atheta, xsize, 3 )
	go to 1000

9	xq(1) = xp - 0.5*xsize
	yq(1) = yp

	xq(2) = xp + 0.5*xsize
	yq(2) = yp
	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )

	xq(1) = xp
	yq(1) = yp - 0.5*ysize

	xq(2) = xp
	yq(2) = yp + 0.5*ysize
	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )
	go to 1000

10	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp + 0.5*ysize
	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )

	xq(1) = xp - 0.5*xsize
	yq(1) = yp + 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp - 0.5*ysize
	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )
	go to 1000

11	xq(1) = xp
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp

	xq(3) = xp
	yq(3) = yp + 0.5*ysize

	xq(4) = xp - 0.5*xsize
	yq(4) = yp

	call ctrline( xp, yp, xq, yq, 4, atheta, .true. )
	go to 1000

12	xq(1) = xp
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp

	xq(3) = xp
	yq(3) = yp + 0.5*ysize

	xq(4) = xp - 0.5*xsize
	yq(4) = yp

	call ctrline( xp, yp, xq, yq, 4, atheta, .false. )
	go to 1000

13	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp - 0.5*ysize

	xq(3) = xp + 0.5*xsize
	yq(3) = yp + 0.5*ysize

	xq(4) = xp - 0.5*xsize
	yq(4) = yp + 0.5*ysize

	call ctrline( xp, yp, xq, yq, 4, atheta, .true. )
	go to 1000

14	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp - 0.5*ysize

	xq(3) = xp + 0.5*xsize
	yq(3) = yp + 0.5*ysize

	xq(4) = xp - 0.5*xsize
	yq(4) = yp + 0.5*ysize

	call ctrline( xp, yp, xq, yq, 4, atheta, .false. )
	go to 1000

15	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp - 0.5*ysize

	xq(3) = xp
	yq(3) = yp + 0.5*ysize

	call ctrline( xp, yp, xq, yq, 3, atheta, .true. )
	go to 1000

16	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp - 0.5*ysize

	xq(3) = xp
	yq(3) = yp + 0.5*ysize

	call ctrline( xp, yp, xq, yq, 3, atheta, .false. )
	go to 1000

17	xq(1) = xp
	yq(1) = yp - 0.5*ysize

	xq(2) = xp - 0.5*xsize
	yq(2) = yp + 0.5*ysize

	xq(3) = xp + 0.5*xsize
	yq(3) = yp + 0.5*ysize

	call ctrline( xp, yp, xq, yq, 3, atheta, .true. )
	go to 1000

18	xq(1) = xp
	yq(1) = yp - 0.5*ysize

	xq(2) = xp - 0.5*xsize
	yq(2) = yp + 0.5*ysize

	xq(3) = xp + 0.5*xsize
	yq(3) = yp + 0.5*ysize

	call ctrline( xp, yp, xq, yq, 3, atheta, .false. )
	go to 1000

19	xq(1) = xp + 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp + 0.5*ysize

	xq(3) = xp - 0.5*xsize
	yq(3) = yp

	call ctrline( xp, yp, xq, yq, 3, atheta, .true. )
	go to 1000

20	xq(1) = xp + 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp + 0.5*ysize

	xq(3) = xp - 0.5*xsize
	yq(3) = yp

	call ctrline( xp, yp, xq, yq, 3, atheta, .false. )
	go to 1000

21	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp - 0.5*xsize
	yq(2) = yp + 0.5*ysize

	xq(3) = xp + 0.5*xsize
	yq(3) = yp

	call ctrline( xp, yp, xq, yq, 3, atheta, .true. )
	go to 1000

22	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp - 0.5*xsize
	yq(2) = yp + 0.5*ysize

	xq(3) = xp + 0.5*xsize
	yq(3) = yp

	call ctrline( xp, yp, xq, yq, 3, atheta, .false. )
	go to 1000

23	xq(1) = xp - 0.5*xsize
	yq(1) = yp + 0.5*ysize

	xq(2) = xp
	yq(2) = yp
	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )

	xq(1) = xp
	yq(1) = yp

	xq(2) = xp
	yq(2) = yp - 0.5*ysize
	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )

	xq(1) = xp
	yq(1) = yp

	xq(2) = xp + 0.5*xsize
	yq(2) = yp + 0.5*ysize

	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )
	go to 1000

24	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp
	yq(2) = yp
	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )

	xq(1) = xp
	yq(1) = yp

	xq(2) = xp
	yq(2) = yp + 0.5*ysize
	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )

	xq(1) = xp
	yq(1) = yp

	xq(2) = xp + 0.5*xsize
	yq(2) = yp - 0.5*ysize

	call ctrline( xp, yp, xq, yq, 2, atheta, .false. )
	go to 1000

25	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp + 0.5*ysize

	xq(3) = xp - 0.5*xsize
	yq(3) = yp + 0.5*ysize

	xq(4) = xp + 0.5*xsize
	yq(4) = yp - 0.5*ysize

	xq(5) = xp - 0.5*xsize
	yq(5) = yp - 0.5*ysize

	call ctrline( xp, yp, xq, yq, 5, atheta, .false. )
	go to 1000

26	xq(1) = xp - 0.5*xsize
	yq(1) = yp - 0.5*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp + 0.5*ysize

	xq(3) = xp + 0.5*xsize
	yq(3) = yp - 0.5*ysize

	xq(4) = xp - 0.5*xsize
	yq(4) = yp + 0.5*ysize

	xq(5) = xp - 0.5*xsize
	yq(5) = yp - 0.5*ysize

	call ctrline( xp, yp, xq, yq, 5, atheta, .false. )
	go to 1000

27	xq(1) = xp
	yq(1) = yp - 0.5*ysize

	xq(2) = xp
	yq(2) = yp

	xq(3) = xp - 0.25*xsize
	yq(3) = yp

	xq(4) = xp
	yq(4) = yp + 0.5*ysize

	xq(5) = xp + 0.25*xsize
	yq(5) = yp

	xq(6) = xp
	yq(6) = yp

	call ctrline( xp, yp, xq, yq, 6, atheta, .false. )
	go to 1000

28	xq(1) = xp + 0.5*xsize
	yq(1) = yp

	xq(2) = xp
	yq(2) = yp

	xq(3) = xp
	yq(3) = yp + 0.25*ysize

	xq(4) = xp - 0.5*xsize
	yq(4) = yp

	xq(5) = xp
	yq(5) = yp - 0.25*ysize

	xq(6) = xp
	yq(6) = yp

	call ctrline( xp, yp, xq, yq, 6, atheta, .false. )
	go to 1000

29	xq(1) = xp
	yq(1) = yp + 0.5*ysize

	xq(2) = xp
	yq(2) = yp

	xq(3) = xp - 0.25*xsize
	yq(3) = yp

	xq(4) = xp
	yq(4) = yp - 0.5*ysize

	xq(5) = xp + 0.25*xsize
	yq(5) = yp

	xq(6) = xp
	yq(6) = yp

	call ctrline( xp, yp, xq, yq, 6, atheta, .false. )
	go to 1000

30	xq(1) = xp - 0.5*xsize
	yq(1) = yp

	xq(2) = xp
	yq(2) = yp

	xq(3) = xp
	yq(3) = yp + 0.25*ysize

	xq(4) = xp + 0.5*xsize
	yq(4) = yp

	xq(5) = xp
	yq(5) = yp - 0.25*ysize

	xq(6) = xp
	yq(6) = yp

	call ctrline( xp, yp, xq, yq, 6, atheta, .false. )
	go to 1000

31	call pgqfs( fill )
	call pgsfs( 1 )
	call pgcirc( xp, yp, 0.5*xsize )	! should be ellipses...
	call pgsfs( fill )
	go to 1000

32	call pgqfs( fill )
	call pgsfs( 2 )
	call pgcirc( xp, yp, 0.5*xsize )	! should be ellipses...
	call pgsfs( fill )
	go to 1000

33	call ctrlin( xp, yp, atheta, ysize, 1 )
        go to 12			! being lazy...

34	call ctrlin( xp, yp, atheta, ysize, 1 )
        go to 14			! again...

35	call ctrlin( xp, yp, atheta, ysize, 1 )
	go to 16

36	call ctrlin( xp, yp, atheta, ysize, 2 )
	go to 18

37	call ctrlin( xp, yp, atheta, xsize, 3 )
	go to 20

38	call ctrlin( xp, yp, atheta, xsize, 4 )
	go to 22

39	call ctrlin( xp, yp, atheta, ysize, 1 )
	go to 32

40	call ctrlin( xp, yp, atheta, ysize, 2 )
	xq(1) = xp - 0.25*xsize
	yq(1) = yp

	xq(2) = xp
	yq(2) = yp + 0.5*ysize

	xq(3) = xp + 0.25*xsize
	yq(3) = yp

	call ctrline( xp, yp, xq, yq, 3, atheta, .true. )
	go to 1000

41	call ctrlin( xp, yp, atheta, xsize, 4 )
	xq(1) = xp
	yq(1) = yp + 0.25*ysize

	xq(2) = xp - 0.5*xsize
	yq(2) = yp

	xq(3) = xp
	yq(3) = yp - 0.25*ysize

	call ctrline( xp, yp, xq, yq, 3, atheta, .true. )
	go to 1000

42	call ctrlin( xp, yp, atheta, ysize, 1 )
	xq(1) = xp - 0.25*xsize
	yq(1) = yp

	xq(2) = xp
	yq(2) = yp - 0.5*ysize

	xq(3) = xp + 0.25*xsize
	yq(3) = yp

	call ctrline( xp, yp, xq, yq, 3, atheta, .true. )
	go to 1000

43	call ctrlin( xp, yp, atheta, xsize, 3 )
	xq(1) = xp
	yq(1) = yp + 0.25*ysize

	xq(2) = xp + 0.5*xsize
	yq(2) = yp

	xq(3) = xp
	yq(3) = yp - 0.25*ysize

	call ctrline( xp, yp, xq, yq, 3, atheta, .true. )
	go to 1000


1000	continue
	call plot( xp, yp, 3 )

	end
	subroutine ctrlin( x, y, theta, size, direc )
	implicit none

C ***
C ***	Arguments
C ***
	real x, y, theta, size
	integer direc

C ***
C ***	Global variables
C ***

C ***
C ***	Local variables
C ***
	real xp, yp

C ***
C ***	Functions
C ***

	call plot( x, y, 3 )
	if( direc .eq. 1 ) then  ! up
	   xp = x - .5*size*sin(theta)
     	   yp = y + .5*size*cos(theta)
	else if( direc .eq. 2 ) then ! down
	   xp = x + .5*size*sin(theta)
           yp = y - .5*size*cos(theta)
	else if( direc .eq. 3 ) then ! left
	   xp = x - .5*size*cos(theta)
     	   yp = y - .5*size*sin(theta)
	else if( direc .eq. 4 ) then ! right
	   xp = x + .5*size*cos(theta)
     	   yp = y + .5*size*sin(theta)
	end if
        call plot( xp, yp, 2 )

	end
	subroutine ctrline( x0, y0, x, y, n, theta, fill )
C ***
C ******************************************************************************
C ***
C ***	Connects points which could be rotated.
C ***
C ***	x0, y0	R >	Origin of rotation
C ***	x, y	R ><	points
C ***	n	I >	number of points in x, y
C ***	theta	R >	Angle (radians)
C ***	fill	L >	Fill polygon if true	(requires PGPLOT fill routine)
C ***
C ***
C ***	10-APR-1997 15:35:27.28		ML / Bamberg.  Created.
C ***
C ******************************************************************************
C ***
	implicit none

	integer n
	real x0, y0, x(n), y(n), theta
	logical fill

	integer i
	real st, ct, xr, yr, z

	st = sin( theta )
	ct = cos( theta )

	do i = 1, n
           xr = x(i) - x0
           yr = y(i) - y0
	   z  =  ct*xr - st*yr
	   yr =  st*xr + ct*yr
           xr = z
           x(i) = xr + x0
           y(i) = yr + y0
	end do
	if( fill ) then
	   call pgpoly( n, x, y )
	else
	   call plot( x(1), y(1), 3 )
	   do i = 2, n
	      call plot( x(i), y(i), 2 )
	   end do
           if( n .gt. 2 ) call plot( x(1), y(1), 2 )
	end if

	end
