	subroutine textlk( length_in, res_length, size, text, res_size,
     >                     nchar )
C ***
C ******************************************************************************
C ***
C ***	This returns the length [cm] of the string. 
C ***
C ***	length_in	R	desired length [cm], not implemented
C ***	res_length	R	resultant length [cm]
C ***	size		R	size of characters [cm]
C ***	text		C	the text string to analyze
C ***	res_size	R	resultant size [cm]
C ***	nchar		I	number of characters in text, ignored
C ***
C ***	 9-APR-1997 17:34:58.75
C ***
C ******************************************************************************
C ***
	implicit none


C ***
C ***	Arguments
C ***
	real length_in, res_length, size, res_size
	integer nchar
	character*(*) text

C ***
C ***	Functions
C ***
	integer lnblnk

C ***
C ***	Global variables
C ***
	include 'pgpa.inc'

C ***
C ***	Local variables
C ***
!	include 'types.inc'
	integer n
	real f, expand, xbox(4), ybox(4), xch, ych
	character*1024 mon_text
!	record /vector/ lim
        real lim_min_x, lim_max_x, lim_min_y, lim_max_y

C ***
C ***	get the size right
C ***
	call pgqch( expand )		! save current size
	call pgsch( 1. )		! set current size to PGPLOT default
        call pgqwin( lim_min_x, lim_max_x, lim_min_y, lim_max_y ) ! some pos.
	call pgqtxt( lim_min_X, lim_min_y, 0., 0., 'M', XBOX, YBOX )
					! get size of letter M
        xch = ybox(2) - ybox(1)		! in cm
	xch = xch/1.375			! there's some fudge factor in PGPLOT

	f = size/xch   			! compute ratio for PGPLOT
	call pgsch( f*fact_y )          ! factor expansion in (can't be done
					! for x and y independently)


	call symk2mon( text, mon_text )
	n = lnblnk( mon_text )

	call pgqtxt( lim_min_X, lim_min_y, 0., 0., mon_text(:n), XBOX,
     >               YBOX )		! get the size
	call pgsch( expand ) 		! restore initial size


	res_length = xbox(4) - xbox(1)
	res_size = ybox(2) - ybox(1)

	end
